package edu.byu.deg.OntologyEditor;

import javax.swing.JInternalFrame;
import javax.swing.JMenuItem;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

/*========================================================================
 * Ontology Editor
 * Data Extraction Group
 *
 * Dr. Stephen W. Liddle (liddle@byu.edu)
 * School of Accountancy and Information Systems
 * Marriott School of Management
 * 540 TNRB, P.O. Box 23068-3068
 * Brigham Young University
 * Provo, UT 84602
 *
 * Dr. Douglas M. Campbell (campbell@cs.byu.edu) and
 * Dr. David W. Embley (embley@cs.byu.edu)
 * Department of Computer Science
 * 3361 TMCB
 * Brigham Young University
 * Provo, UT 84602
 *
 * Copyright (C) 1999, Board of Trustees of Brigham Young University
 *
 * Ontology Editor software, both binary and source
 * (hereafter, Software) is copyrighted by The Board of Trustees of
 * Brigham Young University (BYU), and ownership remains with BYU.
 *
 * BYU grants you (hereafter, Licensee) a license to use the Software
 * for academic, research and internal business purposes only, without a
 * fee.  Licensee may distribute the binary and source code (if released)
 * to third parties provided that the copyright notice and this statement
 * appears on all copies and that no charge is associated with such
 * copies.
 *
 * Licensee may not make derivative works without first arranging an
 * additional license agreement with BYU.
 *
 * Any Licensee wishing to make commercial use of the Software should
 * contact BYU to negotiate an appropriate license for such
 * commercial use.  Commercial use includes (1) integration of all or
 * part of the source code into a product for sale or license by or on
 * behalf of Licensee to third parties, or (2) distribution of the binary
 * code or source code to third parties that need it to utilize a
 * commercial product sold or licensed by or on behalf of Licensee.
 *
 * BYU MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE FOR
 * ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
 * WARRANTY.  BYU SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY THE
 * USERS OF THIS SOFTWARE.
 *
 * By using or copying this Software, Licensee agrees to abide by the
 * copyright law and all other applicable laws of the United States
 * including, but not limited to, export control laws, and the terms
 * of this license.  BYU shall have the right to terminate this license
 * immediately by written notice upon Licensee's breach of, or
 * non-compliance with, any of its terms.  Licensee may be held legally
 * responsible for any copyright infringement that is caused or
 * encouraged by Licensee's failure to abide by the terms of this license.
 *
 * Comments and questions are welcome and can be sent to hewett@cs.byu.edu.
 */

/**
 *
 * @author  Kimball A. Hewett
 * @version %I%, %G%
 * @see     java.awt.Button
 */


public class AbstractInternalFrame extends JInternalFrame implements InternalFrameListener {
  protected OntologyCanvasWindow m_frame;
  protected JMenuItem m_menuItem;
  protected OntologyEditor m_editor;
  
  private static int numOpenFrames = 0;
  
  public AbstractInternalFrame() { 
      /* default constructor */
      // REVISIT: is a default constructor desirable for this class?
  }
  
  public AbstractInternalFrame(String title, OntologyEditor editor, OntologyCanvasWindow frame) {
    super(title,true,true,true,true);
    this.setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
    m_editor = editor;
    if (frame != null)
      m_frame = frame;
    else
      m_frame = (OntologyCanvasWindow)this;
    
    addInternalFrameListener(this);
  }
  
  public void setMenuItem(JMenuItem item) {
    m_menuItem = item;
  }
  
  public JMenuItem getMenuItem() {
    return m_menuItem;
  }
  
  public OntologyCanvasWindow getOntologyFrame() {
    return m_frame;
  }
  
  public void showDataFrame() {
    m_frame.showDataFrame();
  }
  
  public void showDataFrameMatcher() {
    m_frame.showDataFrameMatcher();
  }
  
  public void showMacroEditor() {
    m_frame.showMacroEditor();
  }
  
  public void internalFrameActivated(InternalFrameEvent e) { /* do nothing */ }
  
  public void internalFrameClosed(InternalFrameEvent e) { /* do nothing */ }
  
  public void internalFrameClosing(InternalFrameEvent e) {
    numOpenFrames--;
  }
  
  public void internalFrameDeactivated(InternalFrameEvent e) { /* do nothing */ }
  
  public void internalFrameDeiconified(InternalFrameEvent e) { /* do nothing */ }
  
  public void internalFrameIconified(InternalFrameEvent e) { /* do nothing */ }
  
  public void internalFrameOpened(InternalFrameEvent e) {
    numOpenFrames++;
  }
  
  public static int getNumOpenFrames() {
    return numOpenFrames;
  }
}