package edu.byu.deg.OntologyEditor;

import edu.byu.deg.dataframe.DataFrameEditorPanel;
import edu.byu.deg.dataframe.LexiconEditorPanel;
import edu.byu.deg.dataframe.MacroEditorPanel;
import java.awt.BorderLayout;
import java.util.HashMap;

import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

class DataFrameEditorWindow extends AbstractInternalFrame implements InternalFrameListener
{
    private static boolean F = false;
    private static boolean T = true;
    private static String BL = "";
    private static String NL = "\n";
    private static String SP = " ";

    private HashMap tags = new HashMap();

    private JPanel mainContents;
    private JPanel macroContents;//Zonghui: Tab for Macro Editor
    private JPanel lexiconContents;//Zonghui: Tab for Lexicon Editor

    DataFrameEditorWindow(OntologyCanvasWindow frame, OntologyEditor editor)
    {
        super("Data Frame Editor - " + frame.getTitle(), editor, frame);
        build_tags();

        mainContents = new DataFrameEditorPanel(frame.getDocument());

        macroContents = new MacroEditorPanel(frame.getDocument());
        lexiconContents = new LexiconEditorPanel(frame.getDocument());

        getContentPane().setLayout(new BorderLayout());
        JTabbedPane tabs = new JTabbedPane();
        tabs.addTab("New interface", mainContents);
        tabs.addTab("Macro Editor", macroContents);
        tabs.addTab("Lexicon Editor", lexiconContents);

        getContentPane().add(tabs, BorderLayout.CENTER);

        addInternalFrameListener(this);

        pack();

    }

    /*
    private void populateNavTreeNode(DefaultMutableTreeNode node, OSMXObjectSetType objSet) {
      ObjectSetNode toAdd = new ObjectSetNode(null, navTreeModel);
      node.add(toAdd);
      if (objSet.isHighLevel() && objSet.isSetOSM()) {
        populateNavTreeNode(toAdd, (OSMXOSMType) objSet.getOSM());
      }
      toAdd.setUserObject(objSet);
    } // method populateNavTreeNode(OSMXObjectSetType)

    private void populateNavTreeNode(DefaultMutableTreeNode node, OSMXOSMType osm) {
      final java.text.Collator coll = java.text.Collator.getInstance();
      coll.setStrength(java.text.Collator.PRIMARY);
      java.util.List childObjSets = osm.getObjectSets(
        new java.util.Comparator() {
          public int compare(Object o1, Object o2) {
            OSMXObjectSetType objSet1 = (OSMXObjectSetType) o1;
            OSMXObjectSetType objSet2 = (OSMXObjectSetType) o2;
            return coll.compare(objSet1.getPrimaryName(), objSet2.getPrimaryName());
          }

          public boolean equals(Object obj) {
            return false;
          }
        }
      );
      for (Iterator i = childObjSets.iterator(); i.hasNext();) {
        OSMXObjectSetType objSet = (OSMXObjectSetType) i.next();
        populateNavTreeNode(node, objSet);
      }
    } // method populateNavTreeNode(OSMXOSMType)
    */

    public void internalFrameClosing(InternalFrameEvent e)
    {
        m_frame.dataFrameClosed();
        m_editor.removeFrame(this);
    }

/*
    private String strip_html_tags(String str)
    {
        //remove the entire <head> section
        Pattern p = Pattern.compile("<\\s*" + "/\\s*head[^>]*>\\s*", Pattern.CASE_INSENSITIVE);
        Matcher m = p.matcher(str);
        if (m.find())
        {
            str = str.substring(m.end());
        }

        //collapse multiple whitespace characters to a single space
        String ws_regex = "[ \\u00A0\t\\x09\n\\x0A\f\\x0c\r\\x0D]+";
        str = str.replaceAll(ws_regex, " ");


        //remove the rest of the tags
        p = Pattern.compile("<\\s*(/?\\s*([A-Za-z]+)(\\s[^>]+)?)>", Pattern.CASE_INSENSITIVE);
        m = p.matcher(str);
        while (m.find())
        {
            String tag_name = m.group(2).toLowerCase();

            // boolean is_close = m.group(1).startsWith("/");
            Tag tag = (Tag)tags.get(tag_name);
            String start_replacement = "";
            String end_replacement   = "";
            if (tag != null)
            {
                start_replacement = tag.getStartSpace();
                end_replacement   = tag.getEndSpace();
            }

            String start_regex = "(?i)<\\s*" + tag_name + "(\\s[^>]*)?>";
            String end_regex   = "(?i)<\\s*" + "/\\s*" + tag_name + "(\\s[^>]*)?>";

            str = str.replaceAll(start_regex, start_replacement);
            str = str.replaceAll(end_regex,   end_replacement);

            m = p.matcher(str);
        }

        //replace newlines with <br>
        str = str.trim();
        str = str.replaceAll(NL, "\r\n<br>");
        return str;
    }
*/

    private void build_tags()
    {
        tags.put("a",       new Tag("a",           F, BL, F, BL, F));
        tags.put("abbr",    new Tag("abbr",        F, BL, F, BL, F));
        tags.put("acronym", new Tag("acronym",     F, BL, F, BL, F));
        tags.put("address", new Tag("address",     F, BL, F, BL, F));
        tags.put("applet",  new Tag("applet",      T, SP, T, BL, F));
        tags.put("area",    new Tag("area",        T, BL, F, BL, F));
        tags.put("b",       new Tag("b",           F, BL, F, BL, F));
        tags.put("base",    new Tag("base",        T, BL, F, BL, F));
        tags.put("basefont",new Tag("basefont",    T, BL, F, BL, F));
        tags.put("bdo",     new Tag("bdo",         F, BL, F, BL, F));
        tags.put("big",     new Tag("big",         F, BL, F, BL, F));
        tags.put("blockquote",new Tag("blockquote",F, NL, F, NL, F));
        tags.put("body",    new Tag("body",        F, BL, F, BL, F));
        tags.put("br",      new Tag("br",          T, NL, T, BL, F));
        tags.put("button",  new Tag("button",      T, SP, T, BL, F));
        tags.put("caption", new Tag("caption",     F, BL, F, BL, F));
        tags.put("center",  new Tag("center",      F, NL, F, NL, F));
        tags.put("cite",    new Tag("cite",        F, BL, F, BL, F));
        tags.put("code",    new Tag("code",        F, BL, F, BL, F));
        tags.put("col",     new Tag("col",         T, BL, F, SP, F));
        tags.put("colgroup",new Tag("colgroup",    F, BL, F, BL, F));
        tags.put("dd",      new Tag("dd",          F, BL, F, BL, F));
        tags.put("del",     new Tag("del",         F, BL, F, BL, F));
        tags.put("dfn",     new Tag("dfn",         F, BL, F, BL, F));
        tags.put("dir",     new Tag("dir",         F, NL, F, NL, F));
        tags.put("div",     new Tag("div",         F, NL, F, NL, F));
        tags.put("dl",      new Tag("dl",          F, NL, F, NL, F));
        tags.put("dt",      new Tag("dt",          F, BL, F, NL, F));
        tags.put("em",      new Tag("em",          F, BL, F, BL, F));
        tags.put("frame",   new Tag("frame",       T, BL, F, SP, F));
        tags.put("frameset",new Tag("frameset",    F, BL, F, BL, F));
        tags.put("fieldset",new Tag("fieldset",    F, BL, F, BL, F));
        tags.put("font",    new Tag("font",        F, BL, F, BL, F));
        tags.put("form",    new Tag("form",        F, BL, F, BL, F));
        tags.put("h1",      new Tag("h1",          F, NL, F, NL, F));
        tags.put("h2",      new Tag("h2",          F, NL, F, NL, F));
        tags.put("h3",      new Tag("h3",          F, NL, F, NL, F));
        tags.put("h4",      new Tag("h4",          F, NL, F, NL, F));
        tags.put("h5",      new Tag("h5",          F, NL, F, NL, F));
        tags.put("h6",      new Tag("h6",          F, NL, F, NL, F));
        tags.put("hr",      new Tag("hr",          T, NL, T, BL, F));
        tags.put("iframe",  new Tag("iframe",      T, NL, T, BL, F));
        tags.put("isindex", new Tag("isindex",     T, BL, F, SP, F));
        tags.put("i",       new Tag("i",           F, BL, F, BL, F));
        tags.put("img",     new Tag("img",         T, SP, T, BL, F));
        tags.put("input",   new Tag("input",       T, SP, T, BL, F));
        tags.put("ins",     new Tag("ins",         F, BL, F, BL, F));
        tags.put("kbd",     new Tag("kbd",         F, BL, F, BL, F));
        tags.put("label",   new Tag("label",       F, SP, F, SP, F));
        tags.put("legend",  new Tag("legend",      F, SP, F, SP, F));
        tags.put("li",      new Tag("li",          F, NL, F, NL, F));
        tags.put("link",    new Tag("link",        T, BL, F, BL, F));
        tags.put("menu",    new Tag("menu",        F, NL, F, NL, F));
        tags.put("map",     new Tag("map",         F, BL, F, BL, F));
        tags.put("meta",    new Tag("meta",        T, BL, F, BL, F));
        tags.put("noscript",new Tag("noscript",    F, BL, F, BL, F));
        tags.put("noframes",new Tag("noframes",    F, BL, F, BL, F));
        tags.put("object",  new Tag("object",      F, BL, F, BL, F));
        tags.put("ol",      new Tag("ol",          F, NL, F, NL, F));
        tags.put("option",  new Tag("option",      F, BL, F, NL, F));
        tags.put("optgroup",new Tag("optgroup",    F, BL, F, BL, F));
        tags.put("p",       new Tag("p",           F, NL, F, NL, F));
        tags.put("param",   new Tag("param",       T, BL, F, BL, F));
        tags.put("pre",     new Tag("pre",         F, NL, F, NL, F));
        tags.put("q",       new Tag("q",           F, SP, F, SP, F));
        tags.put("s",       new Tag("s",           F, BL, F, BL, F));
        tags.put("samp",    new Tag("samp",        F, SP, F, SP, F));
        tags.put("script",  new Tag("script",      F, BL, F, BL, F));
        tags.put("select",  new Tag("select",      T, SP, T, BL, F));
        tags.put("small",   new Tag("small",       F, BL, F, BL, F));
        tags.put("span",    new Tag("span",        F, BL, F, BL, F));
        tags.put("strike",  new Tag("strike",      F, BL, F, BL, F));
        tags.put("style",   new Tag("style",       F, BL, F, BL, F));
        tags.put("sub",     new Tag("sub",         F, BL, F, BL, F));
        tags.put("sup",     new Tag("sup",         F, BL, F, BL, F));
        tags.put("strong",  new Tag("strong",      F, BL, F, BL, F));
        tags.put("table",   new Tag("table",       F, NL, T, NL, T));
        tags.put("tbody",   new Tag("tbody",       F, BL, F, BL, F));
        tags.put("td",      new Tag("td",          F, BL, F, SP, F));
        tags.put("tfoot",   new Tag("tfoot",       F, BL, F, NL, F));
        tags.put("th",      new Tag("th",          F, BL, F, SP, F));
        tags.put("thead",   new Tag("thead",       F, BL, F, NL, F));
        tags.put("tr",      new Tag("tr",          F, BL, F, NL, F));
        tags.put("tt",      new Tag("tt",          F, BL, F, BL, F));
        tags.put("textarea",new Tag("textarea",    T, SP, T, BL, F));
        tags.put("ul",      new Tag("ul",          F, NL, F, NL, F));
        tags.put("u",       new Tag("u",           F, BL, F, BL, F));
        tags.put("var",     new Tag("var",         F, BL, F, BL, F));
    }




    class Tag
    {
        String name;
        boolean empty, force_start, force_end;
        String start_whitespace;
        String end_whitespace;


        Tag(String name, boolean empty, String start_whitespace, boolean force_start,
        String end_whitespace, boolean force_end)
        {
            this.name = name;
            this.empty = empty;
            this.start_whitespace = start_whitespace;
            this.end_whitespace = end_whitespace;
        }
        public String getName()
        {return this.name;}
        public boolean isEmpty()
        {return this.empty;}
        public String getStartSpace()
        {return this.start_whitespace;}
        public boolean getForceStart()
        {return this.force_start;}
        public String getEndSpace()
        {return this.end_whitespace;}
        public boolean getForceEnd()
        {return this.force_end;}
    }



}




