package edu.byu.deg.OntologyEditor;
//import edu.byu.deg.OntologyModel.ObjectSetModel;
import edu.byu.deg.common.ColorButton;
import edu.byu.deg.osmx.OSMXStyleType;

/*
 * A basic implementation of the JDialog class.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.BevelBorder;
import edu.byu.deg.osmx.binding.StyleType;
import edu.byu.deg.OntologyEditor.shapes.DrawShape;
import edu.byu.deg.osmx.OSMXFontType;

public class FontDialog extends JDialog
{
    public static final int CANCEL = 0;
    public static final int OK = 1;
    public static final int DEFAULT = 2;

    private static final String[] FontList =
    { "Monospaced", "SansSerif", "Serif" };
    //private static final int      DEFAULT_FONT = 1;
    private static final int      DEFAULT_FONT = 0;
    private boolean m_fontChanged = false;
    private boolean m_fontColorChanged = false;
    private boolean m_fillColorChanged = false;
    private boolean m_lineColorChanged = false;
    private boolean m_lineWidthChanged = false;

    private Font m_initFont;
    private Color m_initFontColor;
    private Color m_initFillColor;
    private Color m_initLineColor;
    private int m_initLineWidth = 1;

    private Font m_font;
    private int m_size = 10; //default;
    private int m_buttonPressed = CANCEL;
    private OSMXStyleType m_style = new OSMXStyleType();

//    private DrawShape  sampleDrawshape = new DrawShape();

    public FontDialog(Point loc, Dimension size, Frame parent)
    {
        super(parent);

        // This code is automatically generated by Visual Cafe when you add
        // components to the visual environment. It instantiates and initializes
        // the components. To modify the code, only use code syntax that matches
        // what Visual Cafe can generate, or Visual Cafe may be unable to back
        // parse your Java file into its visual environment.
        //{{INIT_CONTROLS
        setModal(true);
        setTitle("Style Options");
        setSize(396,264);
        if (loc != null && size !=null)
            setLocation(loc.x+(size.width-396)/2,loc.y+(size.height-264)/2);
        setVisible(false);

        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        Insets insets = new Insets(5,5,2,2);

        getContentPane().setLayout(gbl);

        JLabel1.setText("Font:");
        JLabel1.setForeground(Color.black);
        JLabel1.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(), gbl, gbc, JLabel1, 0,0,1,1,2,0,GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        insets.left=10;
        JLabel4.setText("Font color:");
        JLabel4.setForeground(Color.black);
        JLabel4.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,JLabel4,5,0,1,1,1,0,GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        JLabel6.setText("Fill color:");
        JLabel6.setForeground(Color.black);
        JLabel6.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,JLabel6,5,1,1,1,1,0,GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        JLabel7.setText("Line color:");
        JLabel7.setForeground(Color.black);
        JLabel7.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,JLabel7,5,2,1,1,1,0,GridBagConstraints.NONE, GridBagConstraints.WEST, insets);


        insets.left=2;
        InsertItem(getContentPane(),gbl,gbc,m_fontCombo,1,0,3,1,1,0,GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        Dimension dim = new Dimension(24,24);
        m_fontColorBtn.setPreferredSize(dim);
        m_fillColorBtn.setPreferredSize(dim);
        m_lineColorBtn.setPreferredSize(dim);
        InsertItem(getContentPane(),gbl,gbc,m_fontColorBtn,6,0,1,1,1,0,GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);
        InsertItem(getContentPane(),gbl,gbc,m_fillColorBtn,6,1,1,1,1,0,GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);
        InsertItem(getContentPane(),gbl,gbc,m_lineColorBtn,6,2,1,1,1,0,GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);

        insets.right=5;
        InsertItem(getContentPane(),gbl,gbc,new JPanel(),7,0,1,3,0,0,GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);
        insets.right=2;

        insets.top = 1;
        JLabel2.setText("Size:");
        JLabel2.setForeground(Color.black);
        JLabel2.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,JLabel2,2,1,1,1,3,0,GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        InsertItem(getContentPane(),gbl,gbc,new JPanel(),2,1,1,1,4,0,GridBagConstraints.BOTH, GridBagConstraints.CENTER, insets);

        m_sizeCombo.setEditable(true);
        m_sizeCombo.setSelectedItem("10");
        InsertItem(getContentPane(),gbl,gbc,m_sizeCombo,3,1,1,1,0,0,GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        JLabel5.setText("Line width:");
        JLabel5.setForeground(Color.black);
        JLabel5.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,JLabel5,2,2,1,1,3,0,GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        m_widthCombo.setEditable(true);
        m_widthCombo.setSelectedItem("1");
        InsertItem(getContentPane(),gbl,gbc,m_widthCombo,3,2,1,1,0,0,GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        insets.left = 5;
        m_boldCheckBox.setText("Bold");
        m_boldCheckBox.setActionCommand("Bold");
        m_boldCheckBox.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,m_boldCheckBox,0,1,2,1,2,0,GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, insets);

        m_italicCheckBox.setText("Italic");
        m_italicCheckBox.setActionCommand("Italic");
        m_italicCheckBox.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,m_italicCheckBox,0,2,2,1,2,0,GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST, insets);

        JLabel3.setText("Preview:");
        JLabel3.setForeground(Color.black);
        JLabel3.setFont(new Font("Dialog", Font.PLAIN, 12));
        InsertItem(getContentPane(),gbl,gbc,JLabel3,0,3,2,1,0,0,GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        insets.right = 5;
        m_sample.setBorder(new BevelBorder(BevelBorder.LOWERED));
        m_sample.setBackground(Color.white);
        InsertItem(getContentPane(),gbl,gbc,m_sample,0,4,8,2,4,2,GridBagConstraints.BOTH, GridBagConstraints.CENTER, insets);

// Todo
//        ObjectSetModel model = new ObjectSetModel();
//        model.setName("The quick brown fox jumped over the lazy dogs.");
//        m_objectSet = new ObjSet(model);
//        m_objectSet.setIsSample(true);
//        m_sample.add(m_objectSet);

        //try to use ObjectSetShape
//        ObjectSetShape sampleShape = new ObjectSetShape();


        JPanel panel = new JPanel();
        GridBagLayout gbl2 = new GridBagLayout();
        GridBagConstraints gbc2 = new GridBagConstraints();

        panel.setLayout(gbl2);
        m_okBtn.setText("OK");
        m_cancelBtn.setText("Cancel");
        m_defaultBtn.setText("Make default");
        InsertItem(panel, gbl2, gbc2, m_defaultBtn,0,0,1,1,0,0,GridBagConstraints.NONE,GridBagConstraints.WEST,insets);
        InsertItem(panel, gbl2, gbc2, new JPanel(),1,0,3,1,1,0,GridBagConstraints.BOTH,GridBagConstraints.CENTER,insets);
        InsertItem(panel, gbl2, gbc2, m_okBtn,4,0,1,1,0,0,GridBagConstraints.NONE,GridBagConstraints.EAST,insets);
        InsertItem(panel, gbl2, gbc2, m_cancelBtn,5,0,1,1,0,0,GridBagConstraints.NONE,GridBagConstraints.EAST,insets);
        InsertItem(getContentPane(),gbl,gbc,panel,0,6,8,1,0,0,GridBagConstraints.BOTH, GridBagConstraints.CENTER, insets);
        //}}

        //{{REGISTER_LISTENERS
        SymItem lSymItem = new SymItem();
        m_fontCombo.addItemListener(lSymItem);
        SymAction lSymAction = new SymAction();
        m_fontColorBtn.addActionListener(lSymAction);
        m_fillColorBtn.addActionListener(lSymAction);
        m_lineColorBtn.addActionListener(lSymAction);
        m_sizeCombo.addItemListener(lSymItem);
        m_widthCombo.addItemListener(lSymItem);
        m_boldCheckBox.addActionListener(lSymAction);
        m_italicCheckBox.addActionListener(lSymAction);
        m_okBtn.addActionListener(lSymAction);
        m_cancelBtn.addActionListener(lSymAction);
        m_defaultBtn.addActionListener(lSymAction);
        //}}
        setFontColor(Color.black);
        m_initFont = null;
        m_initFontColor = null;
        addWindowListener(new ThisDialogAdapter());
        m_sizeCombo.addKeyListener(new SymKey());
        setResizable(true);
    }

    public FontDialog(Point p, Dimension d)
    {
        this(p,d,null);
    }

    public FontDialog(String sTitle)
    {
        this();
        setTitle(sTitle);
    }

    public FontDialog()
    {
        this((Point)null, null);
    }

    public void Initialize(DrawShape shape, StyleType style)
    {


//      OSMXElement m_element = shape.getElement();
//      OSMXObjectSetType os = (OSMXObjectSetType)m_element;
//      OSMXObjectSetType os2 = new OSMXObjectSetType();
//      os2.setName("The quick brown fox jumped over the lazy dogs.");
//      os2.setStyle(style);
//      DrawShape sampleShape = new ObjectSetShape (m_sample, (OSMXElement)os2);

//      m_shape.getElement();
//      String s = os.getName();
//      m_shape.setName("The quick brown fox jumped over the lazy dogs.");
//      System.out.println(os.getId());
//      System.out.println(os.getName());
//        m_initFont = style.getFont();
//      m_sample.add(sampleShape);

      m_fillColorBtn.setEnabled(true);
      m_fontColorBtn.setEnabled(true);
      m_lineColorBtn.setEnabled(true);

      m_style= (OSMXStyleType)style;
      m_initFont = new Font(((OSMXStyleType)style).getFontFamily(),
                            OSMXFontType.styleToInt(((OSMXStyleType)style).getFontStyle()),
                            ((int)((OSMXStyleType)style).getFontSize()));
      m_initFontColor = ((OSMXStyleType)style).getFontColor();
      m_initFillColor =  ((OSMXStyleType)style).getFillColor();

      m_initLineColor = ( (OSMXStyleType) style).getLineColor();

      Float f = new Float(((OSMXStyleType)style).getLineWidth());
      m_initLineWidth = f.intValue();
    }

    public StyleType getStyle()
    {
      String fontstyle = null;
//        if ((m_fontChanged) || (m_fontColorChanged))
//            style.setFont(m_font);
//          style.setFont(FontToFontType(m_font));
//        if (m_fontColorChanged)
//            style.setFontColor(m_fontColorBtn.getColor());
//          style.setFillColor(m_fontColorBtn.getColor());
        if (m_fontChanged) {
//          ((OSMXStyleType)m_style).setFontFamily(m_font.getFamily());
          m_style.setFontFamily((String)m_fontCombo.getSelectedItem());
          m_style.setFontSize(this.getFontsize());
//          ((OSMXStyleType)m_style).setFontSize(((String)m_sizeCombo.getSelectedItem()).toin);
        if ((m_boldCheckBox.isSelected()==true) && (m_italicCheckBox.isSelected()==true))
            fontstyle = "bold-italic";
        else if (m_boldCheckBox.isSelected()==true)
            fontstyle = "bold";
        else if (m_italicCheckBox.isSelected()==true)
            fontstyle = "italic";
          m_style.setFontStyle(fontstyle);
        }
        if (m_fontColorChanged)
          m_style.setFontColor(m_fontColorBtn.getColor());
        if (m_fillColorChanged)
          m_style.setFillColor(m_fillColorBtn.getColor());
//            style.setFillColor(m_fillColorBtn.getColor());
        if (m_lineColorChanged)
          m_style.setLineColor(m_lineColorBtn.getColor());
//            style.setLineColor(m_lineColorBtn.getColor());
        if (m_lineWidthChanged)
          m_style.setLineWidth(this.getLineWidth());
//            style.setLineWidth(getLineWidth());
        return m_style;
    }

    public Font getFont()
    {
        return m_font;
    }

    public void setFont(Font propValue)
    {
        m_font = propValue;
        m_size = m_font.getSize();
        boolean isBold = m_font.isBold();
        boolean isItalic = m_font.isItalic();

        //System.out.println("m_fontCombo size: " + m_fontCombo.size());
        //m_fontCombo.setSelectedIndex(DEFAULT_FONT);
        
        //m_fontCombo.setSelectedIndex(1);
        
        for (int i = 0; i < FontList.length; i++)
        {
            if (m_font.getName().equalsIgnoreCase(FontList[i]))
            {
                m_fontCombo.setSelectedIndex(i);
                break;
            }
        }

        m_boldCheckBox.setSelected(isBold);
        m_italicCheckBox.setSelected(isItalic);
        m_sizeCombo.setSelectedItem(Integer.toString(m_size));

        // Need to repeat assignment in case selections changed m_font.
        m_font = propValue;
        m_sample.setFont(m_font);
    }

    private void setFontColor(Color propValue)
    {
        m_fontColorBtn.setColor(propValue);
        m_sample.setForeground(propValue);
    }

    private void setFillColor(Color propValue)
    {
      m_fillColorBtn.setColor(propValue);
    }

    private int getLineWidth()
    {
        int width = 1;

        try
        {
            width = Integer.parseInt((String)m_widthCombo.getSelectedItem());
        }
        catch (NumberFormatException ex){ /* do nothing */ }
        
        return width;
    }

    private int getFontsize() {
      int size = 12;
      try
      {
        size = Integer.parseInt((String)m_sizeCombo.getSelectedItem());
      }
      catch (NumberFormatException ex){ /* fall back to default size */ }
      
      return size;
    }

    private void setLineColor(Color propValue)
    {
      m_lineColorBtn.setColor(propValue);
    }

    public void setVisible(boolean b)
    {
        if (b)
            setLocation(50, 50);
        super.setVisible(b);
    }

    static public void main(String args[])
    {
        (new FontDialog()).setVisible(true);
    }

    public void addNotify()
    {
        int i;

        // Record the size of the window prior to calling parents addNotify.
        Dimension size = getSize();

        super.addNotify();

        if (frameSizeAdjusted)
            return;
        frameSizeAdjusted = true;

        // Adjust size of frame according to the insets
        Insets insets = getInsets();
        setSize(insets.left + insets.right + size.width, insets.top + insets.bottom + size.height);

        // Load combo
        for (i = 0; i < FontList.length; i++)
        {
            m_fontCombo.addItem(FontList[i]);
        }

        if (m_initFontColor != null)
            setFontColor(m_initFontColor);

        if (m_initFillColor != null)
            setFillColor(m_initFillColor);

        if (m_initLineColor != null)
            setLineColor(m_initLineColor);

        if (m_initFont != null)
        {
            setFont(m_initFont);
        } else
        {
            m_fontCombo.setSelectedItem(FontList[DEFAULT_FONT]);
        }
//        showSample();

        // Initialize size combo
        for (i=6; i<=12; i++)
        {
            m_sizeCombo.addItem(Integer.toString(i));
        }
        for (i=14; i<=28; i+=2)
        {
            m_sizeCombo.addItem(Integer.toString(i));
        }
        m_sizeCombo.addItem(Integer.toString(36));
        m_sizeCombo.addItem(Integer.toString(48));
        m_sizeCombo.addItem(Integer.toString(72));
        m_sizeCombo.addItem(Integer.toString(144));

        // Initialize width combo
        for (i=1; i<=5; i++)
        {
            m_widthCombo.addItem(Integer.toString(i));
        }

        m_widthCombo.setSelectedItem(Integer.toString(m_initLineWidth));

        m_fontChanged = false;
        m_fontColorChanged = false;
        m_fillColorChanged = false;
        m_lineColorChanged = false;
        m_lineWidthChanged = false;
    }

    // Used by addNotify
    boolean frameSizeAdjusted = false;

    //{{DECLARE_CONTROLS
    JComboBox m_fontCombo = new JComboBox();
    JLabel JLabel1 = new JLabel();
    JLabel JLabel2 = new JLabel();
    JComboBox m_sizeCombo = new JComboBox();
    JComboBox m_widthCombo = new JComboBox();
    JCheckBox m_boldCheckBox = new JCheckBox();
    JCheckBox m_italicCheckBox = new JCheckBox();
    JLabel JLabel3 = new JLabel();
    JPanel m_sample = new JPanel();
//    ObjSet m_objectSet; Todo
    JLabel JLabel4 = new JLabel();
    JLabel JLabel5 = new JLabel();
    JLabel JLabel6 = new JLabel();
    JLabel JLabel7 = new JLabel();
    ColorButton m_fontColorBtn = new ColorButton();
    ColorButton m_fillColorBtn = new ColorButton();
    ColorButton m_lineColorBtn = new ColorButton();
    JButton m_defaultBtn = new JButton();
    JButton m_okBtn = new JButton();
    JButton m_cancelBtn = new JButton();
    //}}
    private void InsertItem(Container container, GridBagLayout gbl, GridBagConstraints gbc, Component c,
    int x, int y , int width, int height, int weightx, int weighty, int fill,
    int anchor, Insets insets)
    {
        gbc.gridx = x;
        gbc.gridy = y;
        gbc.gridwidth = width;
        gbc.gridheight = height;
        gbc.weightx = weightx;
        gbc.weighty = weighty;
        gbc.fill = fill;
        gbc.anchor = anchor;
        gbc.insets = insets;
        gbl.setConstraints(c, gbc);
        container.add(c);
    }

    class SymItem implements ItemListener
    {
        public void itemStateChanged(ItemEvent event)
        {
            Object object = event.getSource();
            if (object == m_fontCombo)
                mFontCombo_itemStateChanged(event);
            else if (object == m_sizeCombo)
                mSizeCombo_itemStateChanged(event);
            else if (object == m_widthCombo)
                mWidthCombo_itemStateChanged(event);
        }
    }

    void mFontCombo_itemStateChanged(ItemEvent event)
    {
        // to do: code goes here.

        m_fontCombo_itemStateChanged_Interaction1(event);
    }

    void m_fontCombo_itemStateChanged_Interaction1(ItemEvent event)
    {
        m_fontChanged = true;
    }

    class SymAction implements ActionListener
    {
        public void actionPerformed(ActionEvent event)
        {
            Object object = event.getSource();
            if (object instanceof ColorButton)
                mColorBtn_actionPerformed(event);
            else if (object == m_boldCheckBox)
                mBoldCheckBox_actionPerformed(event);
            else if (object == m_italicCheckBox)
                mItalicCheckBox_actionPerformed(event);
            else if (object == m_okBtn)
                mOkBtn_actionPerformed(event);
            else if (object == m_cancelBtn)
                mCancelBtn_actionPerformed(event);
            else if (object == m_defaultBtn)
                mDefaultBtn_actionPerformed(event);
        }
    }

    void mColorBtn_actionPerformed(ActionEvent event)
    {
        Object object = event.getSource();
        if (object instanceof ColorButton)
        {
            Color color = JColorChooser.showDialog(this, "Select Color", ((ColorButton)object).getColor());
            if (color != null)
            {
                ((ColorButton)object).setColor(color);
                if (object == m_fontColorBtn)
                {
                    m_sample.setForeground(color);
                    m_fontColorChanged = true;
                } else if (object == m_fillColorBtn)
                    m_fillColorChanged = true;
                else if (object == m_lineColorBtn)
                    m_lineColorChanged = true;

//                showSample();
            }
        }
    }

    class SymKey extends KeyAdapter
    {
        public void keyReleased(KeyEvent event)
        {
            Object object = event.getSource();
            if (object == m_sizeCombo)
                mSizeCombo_itemStateChanged(event);
        }
    }

    class ThisDialogAdapter extends WindowAdapter
    {
        public void windowClosing(WindowEvent e)
        {
            m_font = null;
        }
    }

    void mSizeCombo_itemStateChanged(AWTEvent event)
    {
        int guess = 0;

        m_fontChanged = true;
        try
        {
            guess = Integer.parseInt((String)m_sizeCombo.getSelectedItem());
            if ((guess >= 2) && (guess <= 144))
            {
                m_size = guess;
//                showSample();
            }
        }
        catch (NumberFormatException ex)
        {
            m_sizeCombo.setSelectedItem(""+m_size);
        }
        catch (java.lang.NullPointerException e){ /* do nothing */ }
    }

    void mWidthCombo_itemStateChanged(AWTEvent event)
    {
        m_lineWidthChanged = true;
//        showSample();
    }

    void mBoldCheckBox_actionPerformed(ActionEvent event)
    {
        m_fontChanged = true;
//        showSample();
    }

    void mItalicCheckBox_actionPerformed(ActionEvent event)
    {
        m_fontChanged = true;
//        showSample();
    }

    void mOkBtn_actionPerformed(ActionEvent event)
    {
        setVisible(false);
        m_buttonPressed = OK;
    }

    void mCancelBtn_actionPerformed(ActionEvent event)
    {
        setVisible(false);
        m_buttonPressed = CANCEL;
    }

    void mDefaultBtn_actionPerformed(ActionEvent event)
    {
        setVisible(false);
        m_buttonPressed = DEFAULT;
    }

    public int getButtonPressed()
    {
        return m_buttonPressed;
    }
}
