package edu.byu.deg.OntologyEditor;

import edu.byu.deg.common.ColorButton;
//import edu.byu.deg.OntologyModel.LexiconModel;
//import edu.byu.deg.OntologyModel.MacroModel;
//import edu.byu.deg.OntologyModel.OSMModel;
import edu.byu.deg.osmx.OSMXDocument;
import edu.byu.deg.osmx.binding.LexiconType;
import edu.byu.deg.osmx.binding.MacroType;
import edu.byu.deg.osmx.binding.OSMType;
import edu.byu.deg.osmx.binding.impl.LexiconImpl;
import edu.byu.deg.osmx.binding.impl.MacroImpl;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.beans.PropertyVetoException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;
//Z.H
//Z.H
import java.util.List;
import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.SoftBevelBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

//Z.H
//Z.H
//Z.H


class MacroLexiconEditorWindow extends AbstractInternalFrame implements ActionListener, FocusListener, ItemListener, InternalFrameListener
{
    class Spacer extends JComponent
    {
        /* no customization; just used for filler */
        /* REVISIT: what's the use of this class? */
    }

//    private OSMModel    m_rootModel;
    private OSMType   m_rootType;
    private JComboBox   m_macroLabelCombo;
    private JComboBox   m_lexiconLabelCombo;
    private JTextField	 m_macroExpr;
    private JTextField	 m_lexiconFilename;
    private JTextField	 m_lexiconSeparators;
    private JCheckBox	m_lexiconCaseSensitivity;
    private JButton     m_newMacroBtn;
    private JButton     m_delMacroBtn;
    private JButton     m_newLexiconBtn;
    private JButton     m_delLexiconBtn;
    private JButton     m_lexiconFileSelectBtn;
    private ColorButton m_macroExprColorBtn;
    private  OSMXDocument  m_doc;
    private FrameInfo   m_info;
    private JScrollPane m_scrollPane;
    private JTextPane   m_textPane;

    MacroLexiconEditorWindow(FrameInfo info, OntologyCanvasWindow frame, OntologyEditor editor)
    {
        super("Macro & Lexicon Editor - " + frame.getTitle(),editor, frame);

        m_info = info;

        m_textPane = new JTextPane();
        m_textPane.setEditable(false);
        m_textPane.setBorder(new SoftBevelBorder(BevelBorder.LOWERED));
        m_scrollPane = new JScrollPane(m_textPane);

        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        Insets insets = new Insets(5,5,5,5);


        getContentPane().setLayout(gbl);

        Spacer spacer = new Spacer();
        InsertItem(getContentPane(), gbl, gbc, spacer, 0,0,1,1,1,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        JButton buttonTest = new JButton("View");
        buttonTest.setActionCommand("toggleView");
        buttonTest.addActionListener(this);
        InsertItem(getContentPane(), gbl, gbc, buttonTest, 1,0,1,1,0,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);
        getContentPane().setBackground(buttonTest.getBackground());

        spacer = new Spacer();
        InsertItem(getContentPane(), gbl, gbc, spacer, 0,1,1,1,1,0,
				   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        JButton changeSrcBtn = new JButton("Change Source");
        changeSrcBtn.setActionCommand("changeSource");
        changeSrcBtn.addActionListener(this);
        InsertItem(getContentPane(), gbl, gbc, changeSrcBtn, 1,1,1,1,0,0,
				   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        GridBagLayout pgbl = new GridBagLayout();
        JPanel panel = new JPanel(pgbl);
        setUpMacroPanel(panel, pgbl);
        InsertItem(getContentPane(), gbl, gbc, panel, 0,2,2,1,0,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        pgbl = new GridBagLayout();
        panel = new JPanel(pgbl);
        setUpLexiconPanel(panel, pgbl);
        InsertItem(getContentPane(), gbl, gbc, panel, 0, 3,2,1,0,0,
				   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        addInternalFrameListener(this);

        pack();

        if (m_info.m_bShowText)
        {
            m_info.m_bShowText=false;
            toggleView();
        }
    }
    public void setRootModelnew (OSMXDocument doc)
    {
         m_doc = doc;
       m_rootType = m_doc.getModelRoot();//OSMType
       List l = m_rootType.getAllModelElements();//list
//        m_rootType = doc.getModelElements();
//        java.util.List l = m_rootType.getAllModelElements();

       Iterator it = l.iterator();
        Object node = it.next();


        while (node != null)
        {
            if (node instanceof MacroType)
            {
//                m_macroLabelCombo.addItem((MacroType)node);
              m_macroLabelCombo.addItem(node);
            }
            else if (node instanceof LexiconType)
            {
//              LexiconType m_l = (LexiconType)node;
//              System.out.println(m_l.getLabel());
//              m_l.getLabel();
//                m_lexiconLabelCombo.addItem((m_l.getLabel()));
//                m_lexiconLabelCombo.addItem(m_l);
               m_lexiconLabelCombo.addItem(node);
            }
        if (it.hasNext())
             node = it.next();
        else node = null;

        }

        m_newMacroBtn.setEnabled(true);
        m_newLexiconBtn.setEnabled(true);

        if (m_macroLabelCombo.getItemCount() > 0)
            m_macroLabelCombo.setSelectedIndex(0);

        if (m_lexiconLabelCombo.getItemCount() > 0)
            m_lexiconLabelCombo.setSelectedIndex(0);


        macroPhraseChanged();
        lexiconPhraseChanged();
    }


/*    public void setRootModel (OSMModel model)
    {
        m_rootModel = model;
        // load data
        Node node = m_rootModel.getFirstChild();

        while (node != null)
        {
            if (node instanceof MacroModel)
            {
                m_macroLabelCombo.addItem(node);
            }
            else if (node instanceof LexiconModel)
            {
                m_lexiconLabelCombo.addItem(node);
            }
            node = node.getNextSibling();

        }

        m_newMacroBtn.setEnabled(true);
        m_newLexiconBtn.setEnabled(true);

        if (m_macroLabelCombo.getItemCount() > 0)
            m_macroLabelCombo.setSelectedIndex(0);

        if (m_lexiconLabelCombo.getItemCount() > 0)
            m_lexiconLabelCombo.setSelectedIndex(0);


        macroPhraseChanged();
        lexiconPhraseChanged();
    }
*/
    private void InsertItem(Container container, GridBagLayout gbl, GridBagConstraints gbc, Component c,
    int x, int y , int width, int height, int weightx, int weighty, int fill,
    int anchor, Insets insets)
    {
        gbc.gridx = x;
        gbc.gridy = y;
        gbc.gridwidth = width;
        gbc.gridheight = height;
        gbc.weightx = weightx;
        gbc.weighty = weighty;
        gbc.fill = fill;
        gbc.anchor = anchor;
        gbc.insets = insets;
        gbl.setConstraints(c, gbc);
        container.add(c);
    }

    private void setUpMacroPanel(JPanel panel, GridBagLayout pgbl)
    {
        GridBagConstraints gbc = new GridBagConstraints();
        JLabel label;
        Insets insets = new Insets(0,5,5,5);

        // set border
        TitledBorder border = new TitledBorder("Macro Phrase");
        border.setTitlePosition(TitledBorder.TOP);
        border.setTitleJustification(TitledBorder.LEFT);
        panel.setBorder(border);

        label = new JLabel("Macro Label:");
        InsertItem(panel, pgbl, gbc, label, 0,0,1,1,0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        m_macroLabelCombo = new JComboBox();
        m_macroLabelCombo.setEditor(new PhraseEditorMacro());
        m_macroLabelCombo.setEditable(true);
        m_macroLabelCombo.setBorder(new BevelBorder(BevelBorder.LOWERED));
        m_macroLabelCombo.addItemListener(this);
        InsertItem(panel, pgbl, gbc, m_macroLabelCombo, 1,0,1,1,100,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        m_newMacroBtn = new JButton(new ImageIcon(getClass().getResource("images/newframe.gif")));
        m_newMacroBtn.setMargin(new Insets(1,1,1,1));
        m_newMacroBtn.setActionCommand("newMacro");
        m_newMacroBtn.addActionListener(this);
        InsertItem(panel, pgbl, gbc, m_newMacroBtn, 2, 0, 1, 1, 0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);

        m_delMacroBtn = new JButton(new ImageIcon(getClass().getResource("images/delete.gif")));
        m_delMacroBtn.setMargin(new Insets(1,1,1,1));
        m_delMacroBtn.setActionCommand("delMacro");
        m_delMacroBtn.addActionListener(this);
        InsertItem(panel, pgbl, gbc, m_delMacroBtn, 3, 0, 1, 1, 0,0,
				   GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);

        label = new JLabel("Value Expression:");
        InsertItem(panel, pgbl, gbc, label, 0,1,1,1,0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        m_macroExpr = new JTextField();
        m_macroExpr.addFocusListener(this);
        InsertItem(panel, pgbl, gbc, m_macroExpr, 1,1,1,1,100,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        m_macroExprColorBtn = new ColorButton();
        m_macroExprColorBtn.setMargin(new Insets(1,1,1,1));
        m_macroExprColorBtn.setActionCommand("ColorMacroExpr");
        m_macroExprColorBtn.addActionListener(this);
        InsertItem(panel, pgbl, gbc, m_macroExprColorBtn, 2, 1, 1, 1, 0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);
    }


    private void setUpLexiconPanel(JPanel panel, GridBagLayout pgbl)
    {
        GridBagConstraints gbc = new GridBagConstraints();
        JLabel label;
        Insets insets = new Insets(0,5,5,5);

        // set border
        TitledBorder border = new TitledBorder("Lexicon Phrase");
        border.setTitlePosition(TitledBorder.TOP);
        border.setTitleJustification(TitledBorder.LEFT);
        panel.setBorder(border);


        label = new JLabel("Lexicon Label:");
        InsertItem(panel, pgbl, gbc, label, 0,0,1,1,0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        m_lexiconLabelCombo = new JComboBox();
        m_lexiconLabelCombo.setEditor(new PhraseEditorLexicon());
        m_lexiconLabelCombo.setEditable(true);
        m_lexiconLabelCombo.setBorder(new BevelBorder(BevelBorder.LOWERED));
        m_lexiconLabelCombo.addItemListener(this);
        InsertItem(panel, pgbl, gbc, m_lexiconLabelCombo, 1,0,1,1,100,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        m_newLexiconBtn = new JButton(new ImageIcon(getClass().getResource("images/newframe.gif")));
        m_newLexiconBtn.setMargin(new Insets(1,1,1,1));
        m_newLexiconBtn.setActionCommand("newLexicon");
        m_newLexiconBtn.addActionListener(this);
        InsertItem(panel, pgbl, gbc, m_newLexiconBtn, 2, 0, 1, 1, 0,0,
        	       GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);

        m_delLexiconBtn = new JButton(new ImageIcon(getClass().getResource("images/delete.gif")));
        m_delLexiconBtn.setMargin(new Insets(1,1,1,1));
        m_delLexiconBtn.setActionCommand("delLexicon");
        m_delLexiconBtn.addActionListener(this);
        InsertItem(panel, pgbl, gbc, m_delLexiconBtn, 3, 0, 1, 1, 0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);

        label = new JLabel("Filename:");
        InsertItem(panel, pgbl, gbc, label, 0,1,1,1,0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        m_lexiconFilename = new JTextField();
        m_lexiconFilename.addFocusListener(this);
        InsertItem(panel, pgbl, gbc, m_lexiconFilename, 1,1,1,1,100,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        m_lexiconFileSelectBtn = new JButton(new ImageIcon(getClass().getResource("images/open.gif")));
        m_lexiconFileSelectBtn.setMargin(new Insets(1,1,1,1));
        m_lexiconFileSelectBtn.setActionCommand("lexiconFileSelect");
        m_lexiconFileSelectBtn.addActionListener(this);
        InsertItem(panel, pgbl, gbc, m_lexiconFileSelectBtn, 2, 1, 1, 1, 0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.CENTER, insets);

        label = new JLabel("Case Sensitive:");
        InsertItem(panel, pgbl, gbc, label, 0,3,1,1,0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        m_lexiconCaseSensitivity = new JCheckBox();
        m_lexiconCaseSensitivity.addFocusListener(this);
        InsertItem(panel, pgbl, gbc, m_lexiconCaseSensitivity, 1,3,1,1,100,0,
        		   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);

        label = new JLabel("Separators:");
        InsertItem(panel, pgbl, gbc, label, 0,4,1,1,0,0,
        		   GridBagConstraints.NONE, GridBagConstraints.WEST, insets);

        m_lexiconSeparators = new JTextField();
        m_lexiconSeparators.addFocusListener(this);
        InsertItem(panel, pgbl, gbc, m_lexiconSeparators, 1,4,1,1,100,0,
				   GridBagConstraints.HORIZONTAL, GridBagConstraints.CENTER, insets);
    }


    protected void macroPhraseChanged()
    {
      boolean bEnabled = false;
        MacroType type = (MacroType)m_macroLabelCombo.getSelectedItem();

        if (type != null)
        {   bEnabled = true;
            m_macroExpr.setText(type.getValue());

         // change the type of string to color
//            String val = type.getColor();
            Color color = Color.white;
            color =  type.getColor();
            // Parser cannot handle full eight character string
            // even though the toHexString produced it.
            // Since we only need the six rightmost chars
            // we take a substring.
/*            if (val !=null)
            {   if (val.length() >= 8)
                val = val.substring(2);
              try
               {  int rgb = Integer.parseInt(val, 16);
                  color = new Color(rgb);
                }
             catch (NumberFormatException e)
               { System.out.println(e);
               }
            }*/
            m_macroExprColorBtn.setColor(color);
        }
        else
        {
            m_macroExpr.setText("");
            m_macroExprColorBtn.setColor(Color.white);
        }

        m_macroLabelCombo.setEnabled(bEnabled);
        m_delMacroBtn.setEnabled(bEnabled);
        m_macroExpr.setEnabled(bEnabled);
        m_macroExprColorBtn.setEnabled(bEnabled);
    }

/*    protected void lexiconPhraseChanged()
    {
        boolean bEnabled = false;
        LexiconModel model = (LexiconModel)m_lexiconLabelCombo.getSelectedItem();

        if (model != null)
        {
            bEnabled = true;
            m_lexiconFilename.setText(model.getFilename());
            m_lexiconCaseSensitivity.setSelected(model.isCaseSensitive());
            m_lexiconSeparators.setText(model.getSeparators());
        }
        else
        {
            m_lexiconFilename.setText("");
            m_lexiconSeparators.setText("");
            m_lexiconCaseSensitivity.setSelected(false);
        }

        m_lexiconLabelCombo.setEnabled(bEnabled);
        m_delLexiconBtn.setEnabled(bEnabled);
        m_lexiconFilename.setEnabled(bEnabled);
        m_lexiconSeparators.setEnabled(bEnabled);
        m_lexiconCaseSensitivity.setEnabled(bEnabled);
        m_lexiconFileSelectBtn.setEnabled(bEnabled);
    }*/
  protected void lexiconPhraseChanged()
{
    boolean bEnabled = false;
    LexiconType type = (LexiconType)m_lexiconLabelCombo.getSelectedItem();

    if (type!= null)
    {
        bEnabled = true;
        m_lexiconFilename.setText(type.getUri());
        m_lexiconCaseSensitivity.setSelected(type.isCaseSensitive());
//        m_lexiconSeparators.setText(model.getSeparators());
        m_lexiconSeparators.setText(type.getDelimiters());
    }
    else
    {
        m_lexiconFilename.setText("");
        m_lexiconSeparators.setText("");
        m_lexiconCaseSensitivity.setSelected(false);
    }

    m_lexiconLabelCombo.setEnabled(bEnabled);
    m_delLexiconBtn.setEnabled(bEnabled);
    m_lexiconFilename.setEnabled(bEnabled);
    m_lexiconSeparators.setEnabled(bEnabled);
    m_lexiconCaseSensitivity.setEnabled(bEnabled);
    m_lexiconFileSelectBtn.setEnabled(bEnabled);
}

    public void itemStateChanged(ItemEvent e)
    {
        Object combo = e.getSource();
        if (combo == m_macroLabelCombo)
            macroPhraseChanged();
        else if (combo == m_lexiconLabelCombo)
            lexiconPhraseChanged();
    }

    public void focusGained(FocusEvent e){ /* do nothing */ }
    
    public void focusLost(FocusEvent e)
    {// could implement a textListener but this is probably more efficient
        if (m_rootType == null)
            return;

//        MacroModel macroModel = (MacroModel)m_macroLabelCombo.getSelectedItem();
          MacroType macroType = (MacroType)m_macroLabelCombo.getSelectedItem();
        LexiconType lexiconType = (LexiconType)m_lexiconLabelCombo.getSelectedItem();

        Object control = e.getSource();
        if (control == m_macroExpr)
        {
            if (macroType!= null)
//                macroModel.setBody(m_macroExpr.getText());
                  macroType.setValue(m_macroExpr.getText());
        }
        else if (control == m_lexiconFilename)
        {
            if (lexiconType != null)
//                lexiconType.setFilename(m_lexiconFilename.getText());
              lexiconType.setUri(m_lexiconFilename.getText());
        }
        else if (control == m_lexiconSeparators)
        {
            if (lexiconType != null)
//                lexiconType.setSeparators(m_lexiconSeparators.getText());
              lexiconType.setDelimiters(m_lexiconSeparators.getText());
        }
        else if (control == m_lexiconCaseSensitivity)
        {
            if (lexiconType != null)
                lexiconType.setCaseSensitive(m_lexiconCaseSensitivity.isSelected());
        }
    }

    public void actionPerformed(ActionEvent e)
    {
        String cmd = e.getActionCommand();
        if (cmd.equals("newMacro"))
        {
/*            Document doc = m_rootModel.getOwnerDocument();
            MacroModel model = (MacroModel)doc.createElement("Macro");
            m_rootModel.appendChild(model);

            m_macroLabelCombo.addItem(model);
            m_macroLabelCombo.setSelectedItem(model);
            macroPhraseChanged();
 **************************************************************************/
            MacroImpl type = new MacroImpl();

            m_macroLabelCombo.addItem(type);
            m_macroLabelCombo.setSelectedItem(type);
            macroPhraseChanged();

            m_doc.getModelRoot().getAllModelElements().add(type);

        }
        else if (cmd.equals("delMacro"))
        {
/*            MacroModel model = (MacroModel)m_macroLabelCombo.getSelectedItem();
            if (model != null)
            {
                m_macroLabelCombo.removeItem(model);
                m_rootModel.removeChild(model);
            }
            if (m_macroLabelCombo.getItemCount() > 0)
                m_macroLabelCombo.setSelectedIndex(0);
            macroPhraseChanged();
  ********************************************************************************/
            MacroType type = (MacroType)m_macroLabelCombo.getSelectedItem();
           if (type != null)
           {m_macroLabelCombo.removeItem(type);
             m_doc.getModelRoot().getAllModelElements().remove(type);
           }
            if (m_macroLabelCombo.getItemCount() > 0)
                m_macroLabelCombo.setSelectedIndex(0);
              macroPhraseChanged();

        }


        else if (cmd.equals("newLexicon"))
        {
 /*           Document doc = m_rootModel.getOwnerDocument();//OSMMODEL & document
            LexiconModel model = (LexiconModel)doc.createElement("Lexicon");
            m_rootModel.appendChild(model);

            m_lexiconLabelCombo.addItem(model);
            m_lexiconLabelCombo.setSelectedItem(model);
            lexiconPhraseChanged();*/

/****************************************************************************
           The new version code as below
 ****************************************************************************/

             LexiconImpl type = new LexiconImpl();
             type.setCaseSensitive(false);

             m_lexiconLabelCombo.addItem(type);
             m_lexiconLabelCombo.setSelectedItem(type);
             lexiconPhraseChanged();

             m_doc.getModelRoot().getAllModelElements().add(type);
        }
        else if (cmd.equals("delLexicon"))
        {
/*            LexiconModel model = (LexiconModel)m_lexiconLabelCombo.getSelectedItem();
            if (model != null)
            {
                m_lexiconLabelCombo.removeItem(model);
                m_rootModel.removeChild(model);
            }
            if (m_lexiconLabelCombo.getItemCount() > 0)
                m_lexiconLabelCombo.setSelectedIndex(0);
            lexiconPhraseChanged();*/
//****************************************************************************
             LexiconType type = (LexiconType)m_lexiconLabelCombo.getSelectedItem();
             if (type != null)
                 {m_lexiconLabelCombo.removeItem(type);
                 m_doc.getModelRoot().getAllModelElements().remove(type);
                  }
            if (m_lexiconLabelCombo.getItemCount() > 0)
                  m_lexiconLabelCombo.setSelectedIndex(0);
             lexiconPhraseChanged();

        }
        else if (cmd.equals("lexiconFileSelect"))
        {
            // change the source used for the text viewer
            ExtFileChooser chooser = new ExtFileChooser(m_lexiconFilename.getText());
            chooser.setFileFilter(chooser.getAcceptAllFileFilter());
            int returnVal = chooser.showOpenDialog(this);
            if (returnVal == JFileChooser.APPROVE_OPTION)
            {
                File file  = chooser.getSelectedFile();
                m_lexiconFilename.setText(file.getPath());
                LexiconType lexiconType = (LexiconType)m_lexiconLabelCombo.getSelectedItem();
                if (lexiconType != null)
                    lexiconType.setUri(file.getName());
            }
        }
        else if (cmd.equals("changeSource"))
        {
            // change the source used for the text viewer
            ExtFileChooser chooser = new ExtFileChooser();
            chooser.setFileFilter(chooser.getAcceptAllFileFilter());
            int returnVal = chooser.showOpenDialog(this);
            if (returnVal == JFileChooser.APPROVE_OPTION)
            {
                try
                {
                    byte []	input_string = new byte[2000];
                    int		read_size;

                    FileInputStream input = new FileInputStream(chooser.getSelectedFile());
                    read_size = input.read(input_string);
                    m_info.m_sourcestring = new String(input_string, 0, read_size);
                    input.close();
                }
                catch (FileNotFoundException e2)
                {
                    System.out.println(e2);
                }
                catch (IOException e2)
                {
                    System.out.println(e2);
                }
                updateMatchView();
            }
        }
        //change the corlor for Macro
        else if (e.getSource() instanceof ColorButton)
        {
            ColorButton btn = (ColorButton)e.getSource();
            Color color = JColorChooser.showDialog(this, "Select Color", btn.getColor());

            if (color != null)
            {
                btn.setColor(color);
                if (cmd.equals("ColorMacroExpr"))
                {
                    MacroType type = (MacroType)m_macroLabelCombo.getSelectedItem();

                    //change the Color into String
//                  int rgb = color.getRGB();
//                    String val = Integer.toHexString(rgb);
//                    type.setColor(val);
                    type.setColor(color);
                }
            }
        }
        else if (cmd.equals("toggleView"))
        {
            toggleView();
        }
        else
        {
            System.out.println("Unhandled cmd: " + cmd);
        }
    }


    private void toggleView()
    {
        Container container = getContentPane();
        GridBagLayout gbl = (GridBagLayout)(container.getLayout());
        m_info.m_bShowText = !m_info.m_bShowText;


        if (m_info.m_bShowText)
        {
            // save current size
            m_info.m_bMaximizedNoText = isMaximum();
            if (m_info.m_bMaximizedNoText)
            {
                try
                {
                    setMaximum(false);
                }
                catch (PropertyVetoException e)
                {
                    /* REVISIT: handle better? */
                }
            }
            m_info.m_sizeNoText = getSize();

            if (m_info.m_sizeWithText == null)
            {
                m_info.m_sizeWithText = new Dimension(m_info.m_sizeNoText);
                m_info.m_sizeWithText.width = getParent().getSize().width;
            }

            // set unmaximized size
            setSize(m_info.m_sizeWithText);

            try
            {
                setMaximum(m_info.m_bMaximizedWithText);
            }
            catch (PropertyVetoException e)
            {
                /* REVISIT: handle better? */
            }

            GridBagConstraints gbc = new GridBagConstraints();
            Insets insets = new Insets(5,5,5,5);

            InsertItem(container, gbl, gbc, m_scrollPane, 2,0,1,18,95,100,
            		   GridBagConstraints.BOTH, GridBagConstraints.CENTER, insets);
            updateMatchView();
        }
        else
        {
            // save current size
            m_info.m_bMaximizedWithText = isMaximum();
            if (m_info.m_bMaximizedWithText)
            {
                try
                {
                    setMaximum(false);
                }
                catch (PropertyVetoException e)
                {
                    /* REVISIT: handle better? */
                }
            }
            m_info.m_sizeWithText = getSize();

            setSize(m_info.m_sizeNoText);
            try
            {
                setMaximum(m_info.m_bMaximizedNoText);
            }
            catch (PropertyVetoException e)
            {
                /* REVISIT: handle better? */
            }

            container.remove(m_scrollPane);
        }

        container.validate();
        container.repaint();

    }

    private void updateMatchView()
    {
        m_textPane.setContentType("text/html");
//        m_textPane.setText(MatchMarker.Mark_Up_Matches(m_info.m_sourcestring,m_rootModel));
    }

    public void internalFrameClosing(InternalFrameEvent e)
    {
        m_frame.macroFrameClosed();
        m_editor.removeFrame(this);
    }
}




