package edu.byu.deg.OntologyEditor;
import java.awt.*;

import java.awt.geom.Point2D;

import javax.swing.border.AbstractBorder;


public class ObjBorder extends AbstractBorder 
{
	
//	Added by Muhammed
    static protected int arcX = 12;
    static protected int arcY = 12;
    protected boolean m_RoundRec ;
    protected boolean m_Transition ;
    protected Rectangle  transBord;
	
    static public int       WIDTH = 6;
    static protected int    INSET = 3;
    static protected double GAP = 1.0;
    static public int       TOP_LEFT = 1, TOP_RIGHT = 2, BOTTOM_LEFT = 4, BOTTOM_RIGHT = 8;
    static public int       TOP_CENTER = 16, LEFT_CENTER = 32, RIGHT_CENTER = 64, BOTTOM_CENTER = 128;
    //static protected Color  m_selColor = Color.lightGray;
    static protected Color  m_selColor = Color.GRAY;
    static protected int 	HANDLE_RECT_SIZE = 6;
    protected Insets        m_insets = new Insets(WIDTH, WIDTH, WIDTH, WIDTH);
    protected boolean       m_bSelected = false;
    protected boolean       m_bReadOnly = false;
    protected boolean       m_bRect = false;
    protected float         m_dash[] = null;
    protected int           m_lineWidth ;
    protected int           m_selOptions = TOP_LEFT | TOP_RIGHT | BOTTOM_LEFT | BOTTOM_RIGHT;
    protected Color         m_rectColor;
    protected Color         m_fillColor = Color.white;
    protected int           m_x, m_y, m_width, m_height;
    protected int           m_handleWidth = WIDTH;
    protected Rectangle 	topLeftRect, topRightRect, topCenterRect, 
    						bottomLeftRect, bottomRightRect, bottomCenterRect,
    						leftCenterRect, rightCenterRect;
    protected Rectangle  	borderRect, borderRectReadonly, rect;
    protected int 			positionX, positionY;
    protected Point2D.Double topLeft = null,topRight = null,topCenter = null,leftCenter = null,
    						rightCenter = null,bottomLeft = null,bottomRight = null,bottomCenter = null,point =null;
    protected boolean 		isFirsttime = true;
    
    public ObjBorder()
    {
      m_bRect = true;
      m_lineWidth = 1;
      m_rectColor = Color.black;
      m_fillColor = Color.white;
      topLeft = new Point2D.Double();
      topRight = new Point2D.Double();
      topCenter = new Point2D.Double();
      leftCenter = new Point2D.Double();
      rightCenter = new Point2D.Double();
      bottomLeft = new Point2D.Double();
      bottomRight = new Point2D.Double();
      bottomCenter = new Point2D.Double();
    }
    
    public Insets getBorderInsets(Component c)
    {
        return m_insets;
    }
    
    public void setBorderInsets(Insets insets)
    {
        m_insets = insets;
    }
    
    public boolean isBorderOpaque()
    {
        return (true);
    }
    
    public void paintBorder(Component c, Graphics g, int x, int y, int width, int height)
    {
        m_x = x;
        m_y = y;
        m_width = width;
        m_height = height;
        
        Color originalColor = g.getColor();
        

        Graphics2D g2 = (Graphics2D)g;
        if (m_RoundRec)
        {
        	//System.out.println("*** Round Rec");
            m_bRect = false;
            double  x1, y1, w1, h1, x2, y2, w2, h2;

            x1 = (double)x + (double)m_lineWidth * 0.5;
            y1 = (double)y + (double)m_lineWidth * 0.5;
            w1 = (double)width - (double)m_lineWidth;
            h1 = (double)height - (double)m_lineWidth;

            BasicStroke stroke = new BasicStroke(m_lineWidth, BasicStroke.CAP_SQUARE,
                                                 BasicStroke.JOIN_MITER, 10.0f, m_dash, 0);
            Graphics2D g2d = (Graphics2D)g;
            g2d.setStroke(stroke);
            g2d.setColor(m_rectColor);
            g2d.draw(new java.awt.geom.RoundRectangle2D.Double(x1,y1, w1, h1,arcX, arcY));
            
	     
	       
        }
        
        if (m_Transition)
        {
        	//System.out.println("*** Transition ***");
        	double  x1, y1, w1, h1, x2, y2, w2, h2;
        	
        	x1 = x + m_lineWidth * 0.5;
        	y1 = y + m_lineWidth * 0.5;
        	w1 = (double)width - (double)m_lineWidth;
        	h1 = (double)height - (double)m_lineWidth;
        	
        	setLexical(isLexical());
        	BasicStroke stroke = new BasicStroke(m_lineWidth, BasicStroke.CAP_SQUARE,
        			BasicStroke.JOIN_MITER, 10.0f, m_dash, 0);
	        Graphics2D g2d = (Graphics2D)g;
	        Graphics2D g2d1 = (Graphics2D)g;
	        g2d.setStroke(stroke);
	        g2d.setColor(m_rectColor);
	        g2d1.setStroke(stroke);
	        g2d1.setColor(m_rectColor);
	        borderRect = new Rectangle((int)x1, (int)y1, (int)w1, (int)h1);
	      //  System.out.println(x1+" "+y1+" h1 "+h1);
	      //  transBord = new Rectangle((int) x1, (int) (y1+h1/2), (int)w1, 1);
	        g2d.draw(borderRect);
	      //  g2d1.draw(transBord);
        }

        if (m_bSelected)
        {	//System.out.println("paintX, paintY : " + x +" " + y);
        //int w = m_handleWidth + tmpWidth;
        g2.setColor(m_selColor);
        if ((m_selOptions & TOP_LEFT) != 0){ 
        	topLeft.setLocation(x, y);
        	topLeftRect = new Rectangle(x, y, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(topLeftRect);
        }
        if ((m_selOptions & BOTTOM_LEFT) != 0) {
        	//bottomLeft.setLocation(x, y + height - HANDLE_RECT_SIZE);
        	bottomLeft.setLocation(x, y + height);
        	bottomLeftRect = new Rectangle(x, y + height - HANDLE_RECT_SIZE, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(bottomLeftRect);
        }
        if ((m_selOptions & TOP_RIGHT) != 0) {
        	//topRight.setLocation(x + width - HANDLE_RECT_SIZE, y) ;
        	topRight.setLocation(x + width, y) ;
        	topRightRect = new Rectangle(x + width - HANDLE_RECT_SIZE, y, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(topRightRect);
        }
        if ((m_selOptions & BOTTOM_RIGHT) != 0) {
        	//bottomRight.setLocation(x + width - HANDLE_RECT_SIZE, y + height - HANDLE_RECT_SIZE);
        	bottomRight.setLocation(x + width, y + height);
        	bottomRightRect= new Rectangle(x + width - HANDLE_RECT_SIZE, y + height - HANDLE_RECT_SIZE, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(bottomRightRect);
        }
        if ((m_selOptions & TOP_CENTER) != 0) {
        	//topCenter.setLocation(x + width/2 - HANDLE_RECT_SIZE/2, y);
        	topCenter.setLocation(x + width/2, y);
        	topCenterRect = new Rectangle(x + width / 2 - HANDLE_RECT_SIZE / 2, y, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(topCenterRect);//m_handleWidth
        }
        if ((m_selOptions & LEFT_CENTER) != 0) {
        	//leftCenter.setLocation(x, y + height/2 - HANDLE_RECT_SIZE);        		
        	leftCenter.setLocation(x, y + height/2);
        	leftCenterRect = new Rectangle(x, y + height / 2 - HANDLE_RECT_SIZE / 2, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(leftCenterRect);//m_handleWidth
        }
        if ((m_selOptions & RIGHT_CENTER) != 0) {
        	//rightCenter.setLocation(x + width - HANDLE_RECT_SIZE, y + height/2 - HANDLE_RECT_SIZE/2);
        	rightCenter.setLocation(x + width, y + height/2);
        	rightCenterRect = new Rectangle(x + width - HANDLE_RECT_SIZE, y + height / 2 - HANDLE_RECT_SIZE / 2, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(rightCenterRect);//m_handleWidth
        }
        if ((m_selOptions & BOTTOM_CENTER) != 0) {
        	//bottomCenter.setLocation(x + width/2 - HANDLE_RECT_SIZE/2, y + height - HANDLE_RECT_SIZE);
        	bottomCenter.setLocation(x + width/2, y + height);
        	bottomCenterRect = new Rectangle(x + width / 2 - HANDLE_RECT_SIZE / 2, y + height - HANDLE_RECT_SIZE, HANDLE_RECT_SIZE, HANDLE_RECT_SIZE);
        	g2.fill(bottomCenterRect);//m_handleWidth
        }
            
        		/*g.setColor(m_selColor);
        
            	if ((m_selOptions & TOP_LEFT) != 0)
                	g.fillRect(x, y, w, w);
                	if ((m_selOptions & BOTTOM_LEFT) != 0)
                	g.fillRect(x, y + height - w, w, w);
                	if ((m_selOptions & TOP_RIGHT) != 0)
                	g.fillRect(x + width - w, y, w, w);
                	if ((m_selOptions & BOTTOM_RIGHT) != 0)
                	g.fillRect(x + width - w, y + height - w, w, w);
	            if ((m_selOptions & TOP_CENTER) != 0)
	                g.fillRect(x + width / 2 - m_handleWidth / 2, y, w, w);
	            if ((m_selOptions & LEFT_CENTER) != 0)
	                g.fillRect(x, y + height / 2 - m_handleWidth / 2, w, w);
	            if ((m_selOptions & RIGHT_CENTER) != 0)
	                g.fillRect(x + width - w, y + height / 2 - m_handleWidth / 2, w, w);
	            if ((m_selOptions & BOTTOM_CENTER) != 0)
	                g.fillRect(x + width / 2 - m_handleWidth / 2, y + height - w, w, w);*/
        }
        if (m_bRect)
        {
        	//System.out.println("***Rec");
        	double  x1, y1, w1, h1, x2, y2, w2, h2;
        	
        	x1 = x + m_lineWidth * 0.5;
        	y1 = y + m_lineWidth * 0.5;
        	w1 = (double)width - (double)m_lineWidth;
        	h1 = (double)height - (double)m_lineWidth;
        	
        	setLexical(isLexical());
        	BasicStroke stroke = new BasicStroke(m_lineWidth, BasicStroke.CAP_SQUARE,
        			BasicStroke.JOIN_MITER, 10.0f, m_dash, 0);
	        Graphics2D g2d = (Graphics2D)g;
	        g2d.setStroke(stroke);
	        g2d.setColor(m_rectColor);
	        borderRect = new Rectangle((int)x1, (int)y1, (int)w1, (int)h1);
	        g2d.draw(borderRect);
	        //g2d.draw(new java.awt.geom.Rectangle2D.Double(x1, y1, w1, h1));
	            
	
	        if (m_bReadOnly)
	        {
	        	x2 = x1 + GAP + m_lineWidth;
	        	y2 = y1 + GAP + m_lineWidth;
	        	w2 = w1 - 2.0 * GAP - 2.0 * m_lineWidth;
	        	h2 = h1 - 2.0 * GAP - 2.0 * m_lineWidth;
	        	
	        	g2d.setStroke(new BasicStroke(m_lineWidth, BasicStroke.CAP_SQUARE,
	        			BasicStroke.JOIN_MITER, 10.0f, null, 0));
	            g2d.draw(new java.awt.geom.Rectangle2D.Double(x2, y2, w2, h2));
	        }
        }
        g.setColor(originalColor);
    }

    
    /* Added by Muhammed*/
    public void setRoundRec(boolean value)
    {
         m_RoundRec = value;     
        m_bRect = false;
        m_Transition = false; 
          
    }
    
    public void setTransitionBorder()
    {
    	 m_RoundRec = false;     
         m_bRect = false;
         m_Transition = true; 
    }
    
    public void setHandleWidth(int newWidth) {
        if (newWidth < 0) {
            newWidth = 0;
        }
        m_handleWidth = newWidth;
    }

    public void setSelect(boolean bSelect)
    {
        m_bSelected = bSelect;
    }

    public void setSelOptions(int options)
    {
        m_selOptions = options;
    }
    
    public void setRectDraw(boolean bRect)
    {
        m_bRect = bRect;
    }
    
    public void setRectColor(Color color)
    {
        m_rectColor = color;
    }
    
    public void setRectWidth(int width)
    {
        m_lineWidth = width;
    }
    
    public void setLexical(boolean bLex)
    {
        if (bLex)
        {
            m_dash = new float[2];
            m_dash[0] = 2.0f + m_lineWidth;
            m_dash[1] = 2.0f + m_lineWidth;
        }
        else
            m_dash = null;
    }
    
    public boolean isLexical()
    {	
        if (m_dash != null)
            return true;
        return false;
    }
    
    public boolean isReadOnly()
    {
        return m_bReadOnly;
    }
    
    public void setReadOnly(boolean bVal)
    {
        m_bReadOnly = bVal;
    }
    
    public Color getFillColor()
    {
        return m_fillColor;
    }
    
    public int getLineWidth()
    {
        return m_lineWidth;
    }
    
    public void setFillColor(Color color)
    {
        m_fillColor = color;
    }
    
    public int contains(int x, int y)
    {
        Point pt = new Point(x,y);
        return contains(pt);
    }
    
    public int contains(Point pt)
    {
        if (!m_bSelected)
            return 0;
        
        Rectangle rect = new Rectangle();
        int w = WIDTH + m_lineWidth;
        
        if ((m_selOptions & TOP_LEFT) != 0)
        {
            rect.setBounds(m_x,m_y,w,w);
            if (rect.contains(pt))
                return TOP_LEFT;
        }
        if ((m_selOptions & BOTTOM_LEFT) != 0)
        {
            rect.setBounds(m_x,m_y+m_height-w, w,w);
            if (rect.contains(pt))
                return BOTTOM_LEFT;
        }
        if ((m_selOptions & TOP_RIGHT) != 0)
        {
            rect.setBounds(m_x+m_width-w, m_y,w,w);
            if (rect.contains(pt))
                return TOP_RIGHT;
        }
        if ((m_selOptions & BOTTOM_RIGHT) != 0)
        {
            rect.setBounds(m_x+m_width-w, m_y+m_height-w,w,w);
            if (rect.contains(pt))
                return BOTTOM_RIGHT;
        }
        if ((m_selOptions & TOP_CENTER) != 0)
        {
            rect.setBounds(m_x+(m_width)/2 - WIDTH/2, m_y,w,w);
            if (rect.contains(pt))
                return TOP_CENTER;
        }
        if ((m_selOptions & LEFT_CENTER) != 0)
        {
            rect.setBounds(m_x, m_y+(m_height)/2 - WIDTH/2,w,w);
            if (rect.contains(pt))
                return LEFT_CENTER;
        }
        if ((m_selOptions & RIGHT_CENTER) != 0)
        {
            rect.setBounds(m_x+m_width-w, m_y+(m_height)/2 - WIDTH/2,w,w);
            if (rect.contains(pt))
                return RIGHT_CENTER;
        }
        if ((m_selOptions & BOTTOM_CENTER) != 0)
        {
            rect.setBounds(m_x+(m_width)/2 - WIDTH/2, m_y+m_height-w,w,w);
            if (rect.contains(pt))
                return BOTTOM_CENTER;
        }
        
        return 0;
    }

    public int updateCursor(int mouseMovedX, int mouseMovedY) {
    	int cursor = Cursor.DEFAULT_CURSOR;
    	
    	//If the selected shape is not rectangle, cursor should not changed
    	if ((m_selOptions & TOP_LEFT) == 0  || (m_selOptions & TOP_RIGHT) == 0 || (m_selOptions & TOP_CENTER) == 0 ||
    			(m_selOptions & BOTTOM_LEFT) == 0 || (m_selOptions & BOTTOM_RIGHT) == 0 || (m_selOptions & BOTTOM_CENTER) == 0 ||
    			(m_selOptions & LEFT_CENTER) == 0 || (m_selOptions & RIGHT_CENTER) == 0 )
    		return cursor;
    	
    	if (topLeftRect.contains(mouseMovedX, mouseMovedY)){
    		cursor = Cursor.NW_RESIZE_CURSOR;
		}
		else if (topRightRect.contains(mouseMovedX, mouseMovedY)){
			cursor = Cursor.NE_RESIZE_CURSOR;
		}
		else if (topCenterRect.contains(mouseMovedX, mouseMovedY)) {
			cursor = Cursor.N_RESIZE_CURSOR;
		}
		else if(bottomLeftRect.contains(mouseMovedX, mouseMovedY)) {
			cursor = Cursor.NE_RESIZE_CURSOR;
		}
		else if(bottomRightRect.contains(mouseMovedX, mouseMovedY)) {
			cursor = Cursor.NW_RESIZE_CURSOR;
		}
		else if(bottomCenterRect.contains(mouseMovedX, mouseMovedY)){
			cursor = Cursor.N_RESIZE_CURSOR;
		}
		else if(leftCenterRect.contains(mouseMovedX, mouseMovedY)){
			cursor = Cursor.E_RESIZE_CURSOR;
		}
		else if(rightCenterRect.contains(mouseMovedX, mouseMovedY)){
			cursor = Cursor.E_RESIZE_CURSOR;
		}
    	return cursor;
    }
   public String mousePressed(int mousePressedX, int mousePressedY){
    	if ( !((m_selOptions & TOP_LEFT) == 0  || (m_selOptions & TOP_RIGHT) == 0 || (m_selOptions & TOP_CENTER) == 0 ||
    			(m_selOptions & BOTTOM_LEFT) == 0 || (m_selOptions & BOTTOM_RIGHT) == 0 || (m_selOptions & BOTTOM_CENTER) == 0 ||
    			(m_selOptions & LEFT_CENTER) == 0 || (m_selOptions & RIGHT_CENTER) == 0 ) ) {
    		positionX = mousePressedX;
    		positionY = mousePressedY;
    		if (topLeftRect.contains(mousePressedX,mousePressedY)){
    			return "TOP_LEFT";
    		}
    		else if (topRightRect.contains(mousePressedX, mousePressedY)) {
    			return "TOP_RIGHT";
    		}
    		else if (topCenterRect.contains(mousePressedX, mousePressedY)) {
    			return "TOP_CENTER";
    		}
    		else if (leftCenterRect.contains(mousePressedX, mousePressedY)) {
    			return "LEFT_CENTER";
    		}
    		else if (rightCenterRect.contains(mousePressedX, mousePressedY)) {
    			return "RIGHT_CENTER";
    		}
    		else if (bottomLeftRect.contains(mousePressedX, mousePressedY)) {
    			return "BOTTOM_LEFT";
    		}
    		else if	(bottomRightRect.contains(mousePressedX, mousePressedY)){
    			return "BOTTOM_RIGHT";
    		}
    		else if (bottomCenterRect.contains(mousePressedX, mousePressedY)) {
    			return "BOTTOM_CENTER";
    		}
    		else return "NONE";
    	}
    	return "NONE";
    }
} /* class ObjBorder */

