package edu.byu.deg.OntologyEditor;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.JComponent;


public class PrimaryMarker extends JComponent
{
    final static int DEFAULT_RADIUS = 4;
    final static int DEFAULT_ARROW_WIDTH = 8;
    final static int DEFAULT_ARROW_PRONG_LENGTH = 3;
    
    private Color color;
    
    public PrimaryMarker()
    {
        super();
        color = Color.BLACK;
        this.setPreferredSize(new Dimension(DEFAULT_RADIUS*2 + DEFAULT_ARROW_WIDTH + 2,DEFAULT_RADIUS*2));
    }
    
    protected void paintComponent(Graphics g)
    {
        int w = getWidth();
        int h = getHeight();

        if (h > DEFAULT_RADIUS * 2) {
            h = DEFAULT_RADIUS * 2;
        }
        if (w > DEFAULT_RADIUS * 2 + DEFAULT_ARROW_WIDTH + 2) {
            w = DEFAULT_RADIUS * 2 + DEFAULT_ARROW_WIDTH + 2;
        }

        BasicStroke stroke = new BasicStroke(1, BasicStroke.CAP_SQUARE,BasicStroke.JOIN_MITER, 1, null, 0);
        Graphics2D g2d = (Graphics2D)(g);
        g2d.setStroke(stroke);
        
        g2d.setColor(color);
        g2d.drawLine(0, h/2, DEFAULT_ARROW_WIDTH - 1, h/2);
        g.drawLine(DEFAULT_ARROW_WIDTH - 1, h/2, DEFAULT_ARROW_WIDTH - DEFAULT_ARROW_PRONG_LENGTH - 1, h/2 - DEFAULT_ARROW_PRONG_LENGTH);
        g.drawLine(DEFAULT_ARROW_WIDTH - 1, h/2, DEFAULT_ARROW_WIDTH - DEFAULT_ARROW_PRONG_LENGTH - 1, h/2 + DEFAULT_ARROW_PRONG_LENGTH);
        g.fillOval(DEFAULT_ARROW_WIDTH + 1, 0, DEFAULT_RADIUS*2, h);
    }
    
    public void setColor(Color c) {
        color = c;
    }
    
    public Color getColor() {
        return color;
    }

} /* class PrimaryMarker */
