/*
 * Created on May 19, 2005
 *
 * This class is use to print the ontology
 * According to the ontology's size and shape automatically set up the printformat and print
 */
package edu.byu.deg.OntologyEditor;

/**
 * @author Zonghui
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
import java.awt.*;

import javax.print.PrintService;
import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.PrintRequestAttributeSet;
import javax.print.attribute.standard.Copies;
import javax.print.attribute.standard.JobName;
import javax.print.attribute.standard.OrientationRequested;
import javax.swing.*;

import java.awt.geom.AffineTransform;
import java.awt.print.*;

public class PrintUtilities implements Printable {
  private Component componentToBePrinted;
  private Graphics graphtobePrint;
  private String orientation = "LANDSCAPE";
  private Rectangle bound = null;
  
  public static void printComponent(Component c, Rectangle rec) {
    new PrintUtilities(c, rec).print();
  }
  
  public PrintUtilities(Component componentToBePrinted, Rectangle rec) {
 	bound = rec;
  	if (bound.height > bound.width) {
  		orientation = "PORTRAIT";
 	}
    this.componentToBePrinted = componentToBePrinted;
  }
  
  public void print() {
	/* Construct the print request specification.
	* The print data is a Printable object.
	* the request additonally specifies a job name, 2 copies, and
	* landscape orientation of the media.
	*/
	PrintRequestAttributeSet aset = new HashPrintRequestAttributeSet();
	if (orientation.equals("PORTRAIT"))
		aset.add(OrientationRequested.PORTRAIT);
	else
		aset.add(OrientationRequested.LANDSCAPE);
	
	aset.add(new Copies(1));
	aset.add(new JobName("My job", null));

	/* Create a print job */
	PrinterJob pj = PrinterJob.getPrinterJob();       
	pj.setPrintable(this);
	/* locate a print service that can handle the request */
	PrintService[] services =
		PrinterJob.lookupPrintServices();

	if (services.length > 0) {
		try {
			pj.setPrintService(services[0]);
			/*pj.pageDialog(aset);
				if(pj.printDialog(aset)) {
				pj.print(aset);
			}*/
			if (pj.printDialog()) {
				pj.print(aset);
			}
			
		} catch (PrinterException pe) { 
			System.err.println(pe);
		}
	}
  }

  public int print(Graphics g, PageFormat pageFormat, int pageIndex) {
  	
    if (pageIndex > 0) {
      return(NO_SUCH_PAGE);
    } 
    else {
      double adjustment =  0.01;
      Graphics2D g2d = (Graphics2D)g;
      
      //get paper's size
      Paper paper = pageFormat.getPaper();
      double paper_x = paper.getImageableWidth();
      double paper_y = paper.getImageableHeight();
      
      double scale = 1.0;
      
      //System.out.println("bound double x, y: " + bound.getX() + " " + bound.getY());
      
      //compare the bound with paper, adjust the scale
      if (bound.width < bound.height) {
      	if (bound.height > paper_y && bound.width > paper_x) {
      		scale = (double)(paper_y/bound.height) - adjustment;
      		if (bound.width * scale > paper_x) {
      			scale = (double)(paper_x/bound.width) - adjustment;
      		}
      	}
      	else if (bound.height > paper_y)  {
      		scale = (double)(paper_y/bound.height) - adjustment;
      	}
      	else if (bound.width > paper_x) {
      		scale = (double)(paper_x/bound.width) - adjustment;
      	}
      }
      else {
      	if (bound.height > paper_x && bound.width > paper_y) {
      		scale = (double)(paper_x/bound.height) - adjustment;
      		if (bound.width * scale > paper_y) {
      			scale = (double)(paper_y/bound.width) - adjustment;
      		}
      	}
      	else if (bound.height > paper_x)  {
      		scale = (double)(paper_x/bound.height) - adjustment;
      	}
      	else if (bound.width > paper_y) {
      		scale = (double)(paper_y/bound.width) - adjustment;
      	}
      }
      g2d.translate(-bound.getX() * scale, -bound.getY()*scale);
      
      g2d.scale(scale, scale);
      //System.out.println("scale: " + scale);
      
      g2d.translate((double)((pageFormat.getImageableX()+ 3)/scale),
      		(double)((pageFormat.getImageableY()+3)/scale));
      /*g2d.translate(-bound.x * scale  + pageFormat.getImageableX()/scale,
      		-bound.y * scale + pageFormat.getImageableY()/scale);
            disableDoubleBuffering(componentToBePrinted);*/
      
      componentToBePrinted.paint(g2d);
      
      enableDoubleBuffering(componentToBePrinted);
    }
      return(PAGE_EXISTS);
    
  }

  public static void disableDoubleBuffering(Component c) {
    RepaintManager currentManager = RepaintManager.currentManager(c);
    currentManager.setDoubleBufferingEnabled(false);
  }

  public static void enableDoubleBuffering(Component c) {
    RepaintManager currentManager = RepaintManager.currentManager(c);
    currentManager.setDoubleBufferingEnabled(true);
  }
}