package edu.byu.deg.OntologyEditor;

import edu.byu.deg.OntologyEditor.actions.OpenAction;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListCellRenderer;

/**
 * ServerFileChooser is a dialog that lets the user choose from a list of urls
 *
 * @author Tim Chartrand
 * @version 1.0
 */
//
//
// ServerFileChooser
//
//
public class ServerFileChooser extends JPanel implements ActionListener
{
    public boolean ready = false;
    
    JButton open_btn = new JButton();
    JButton cancel_btn = new JButton();
    JComboBox file_list = new JComboBox();
    private AbstractAction parent_action;
    
    public ServerFileChooser(AbstractAction parent_action, URL urls[])
    {
        super();
        ready = false;
        this.parent_action = parent_action;
        
        jbInit();
        for (int i = 0; i < urls.length; i++)
        {
            file_list.addItem(urls[i]);
        }
    }
    
    public ServerFileChooser()
    {
        ready = false;
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    private void jbInit()
    {
        this.setLayout(null);
        this.setMaximumSize(new Dimension(226, 23));
        this.setMinimumSize(new Dimension(225, 23));
        this.setPreferredSize(new Dimension(226, 23));
        this.setSize(new Dimension(193, 26));
        
        file_list.setRenderer(new URLRenderer());
        file_list.addActionListener(this);
        cancel_btn.addActionListener(this);
        cancel_btn.setText("Cancel");
        cancel_btn.setMargin(new Insets(2, 2, 2, 2));
        cancel_btn.setBounds(new Rectangle(142, 1, 82, 21));
        file_list.setBounds(new Rectangle(2, 1, 140, 21));
        this.add(cancel_btn, null);
        this.add(file_list, null);
    }
    
    public void setSelectedIndex(int index)
    {
        file_list.setSelectedIndex(index);
    }
    
    public void actionPerformed(ActionEvent e)
    {
      
        if (!ready) return;
        if (e.getSource() == this.open_btn || e.getSource() == this.file_list)
        {
            if (parent_action instanceof OpenAction)
            {
                ((OpenAction)parent_action).openDocument(file_list.getSelectedItem());
                ((OpenAction)parent_action).close_chooser();
                ((OpenAction)parent_action).getEditor().current_ont_index = file_list.getSelectedIndex();
            }
        }
        else if (e.getSource() == this.cancel_btn)
        {
            this.file_list.setSelectedIndex(-1);
            if (parent_action instanceof OpenAction)
            {
                ((OpenAction)parent_action).close_chooser();
            }
        }
    }
    
}
class URLRenderer extends JLabel implements ListCellRenderer
{
    public URLRenderer()
    {
        setOpaque(true);
    }
    
    public Component getListCellRendererComponent(JList list, Object value,
    int index, boolean isSelected,
    boolean cellHasFocus)
    {
        if (value == null)
        {
            setText("");
        }
        else
        {
            String path = ((URL)value).getFile();
            String filename = path.substring(path.lastIndexOf("/")+1);
            setText(filename);
        }
        setBackground(isSelected ? Color.gray : Color.white);
        setForeground(isSelected ? Color.white : Color.black);
        return this;
    }
}