/*
 * ToggleMenuItem.java
 *
 * Created on November 24, 2003, 2:55 PM
 */

package edu.byu.deg.OntologyEditor;

/**
 *
 * @author  Alan
 */
public class ToggleMenuItem extends javax.swing.JCheckBoxMenuItem {
  
  protected boolean mutex = false;
  protected boolean defaultItem = false;
  
  /** Creates a new instance of ToggleMenuItem */
  public ToggleMenuItem() {
    super();
  }
  
  public ToggleMenuItem(javax.swing.Action a) {
    super(a);
  }
  
  public ToggleMenuItem(javax.swing.Icon icon) {
    super(icon);
  }
  
  public ToggleMenuItem(String text) {
    super(text);
  }
  
  public ToggleMenuItem(String text, boolean b) {
    super(text, b);
  }
  
  public ToggleMenuItem(String text, javax.swing.Icon icon) {
    super(text, icon);
  }
  
  public ToggleMenuItem(String text, javax.swing.Icon icon, boolean b) {
    super(text, icon, b);
  }
  
  protected void configurePropertiesFromAction(javax.swing.Action a) {
    super.configurePropertiesFromAction(a);
    updateSelectionStateFromAction(a);
  }
  
  protected void updateSelectionStateFromAction(javax.swing.Action a) {
    String toggleState = (String) a.getValue(ActionLoader.ACTION_TOGGLE_STATE_KEY);
    String myState;
    if (isMutex()) {
      myState = getActionCommand();
    } else {
      myState = ActionLoader.ACTION_TOGGLE_STATE_ON;
    }
    setSelected((toggleState == null && defaultItem) || myState.equalsIgnoreCase(toggleState));
  }
  
  protected java.beans.PropertyChangeListener createActionPropertyChangeListener(javax.swing.Action a) {
    final java.beans.PropertyChangeListener inner;
    
    inner = super.createActionPropertyChangeListener(a);
    java.beans.PropertyChangeListener outer = new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent evt) {
        if (ActionLoader.ACTION_TOGGLE_STATE_KEY.equals(evt.getPropertyName())) {
          updateSelectionStateFromAction((javax.swing.Action) evt.getSource());
        } else {
          inner.propertyChange(evt);
        }
      }
    };
    return outer;
  }
  
  public void setMutex(boolean value) {
    mutex = value;
  }
  
  public boolean isMutex() {
    return mutex;
  }
  
  public void setDefault(boolean value) {
    defaultItem = value;
  }
  
  public boolean isDefault() {
    return defaultItem;
  }
  
}
