/*
 * AddAnchorAction.java
 *
 * Created on November 26, 2003, 12:49 AM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.shapes.ConnectionShape;
import edu.byu.deg.osmx.OSMXAnchorType;
import java.awt.Component;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import javax.swing.SwingUtilities;


/**
 *
 * @author  Alan
 */
public class AddAnchorAction extends ShapeAction {
  
  public void actionPerformed(ActionEvent e) {
    ConnectionShape connShape = (ConnectionShape) getShape();
    MouseEvent evt = getMouseEvent();
    OSMXAnchorType anchor = new OSMXAnchorType();
    Point pt = SwingUtilities.convertPoint((Component) evt.getSource(), evt.getPoint(), connShape);
    anchor.setX(pt.x);
    anchor.setY(pt.y);
    connShape.addAnchor(connShape.getAnchorInsertionIndex(pt), anchor);
    connShape.setSelected(true);
    connShape.repaint();
  }
  
  public boolean isApplicable() {
    boolean result = super.isApplicable();
    result = result && (getShape() instanceof ConnectionShape);
    result = result && (getMouseEvent() != null);
    return result;
  }
  
}
