/*
 * CanvasAction.java
 *
 * Created on November 17, 2003, 11:35 PM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.AbstractInternalFrame;
import edu.byu.deg.OntologyEditor.OntologyCanvas;
import edu.byu.deg.OntologyEditor.OntologyCanvasWindow;
import java.awt.event.MouseEvent;


/**
 *
 * @author  Alan
 */
public abstract class CanvasAction extends InternalFrameAction {
  
  public OntologyCanvasWindow getCanvasWindow() {
    AbstractInternalFrame frame = getActiveFrame();
    if (frame != null && frame instanceof OntologyCanvasWindow) {
      return (OntologyCanvasWindow) frame;
    } else {
      return null;
    }
  }
  
  public OntologyCanvas getRootCanvas() {
    OntologyCanvasWindow ocw = getCanvasWindow();
    if (ocw == null) return null;
    return ocw.getCanvas();
  }
  
  public MouseEvent getMouseEvent() {
    OntologyCanvas canvas = getRootCanvas();
    if (canvas == null) return null;
    else return canvas.getActiveMouseEvent();
  }
  
  public boolean isApplicable() {
    boolean result = super.isApplicable();
    result = result && (getCanvasWindow() != null) && (getRootCanvas() != null);
    return result;
  }
  
}
