/*
 * GeneralAction.java
 *
 * Created on November 17, 2003, 11:31 PM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.ActionLoader;
import edu.byu.deg.OntologyEditor.OntologyEditor;
import javax.swing.AbstractAction;

/**
 *
 * @author  Alan
 */
public abstract class GeneralAction extends AbstractAction {
  
  protected OntologyEditor editor = null;
  
  public OntologyEditor getEditor() {
    return (OntologyEditor) getValue(ActionLoader.EDITOR_KEY_NAME);
  }
  
  public boolean isEnabled() {
    boolean result = super.isEnabled();
    result = result && isApplicable();
    return result;
  }
  
  public boolean isApplicable() {
    return (getEditor() != null);
  }
  
  public void setEnabled(boolean b) {
    boolean bVal = b && isApplicable();
    super.setEnabled(bVal);
  }
  
  public void updateState() {
    setEnabled(true);
    if (isToggleAction()) {
      if (!isEnabled()) setSelected(false);
      else {
        updateSelected();
      }
    }
  }
  
  protected boolean isToggleAction() {
    Object toggleState = getValue(ActionLoader.ACTION_TOGGLE_STATE_KEY);
    boolean result = (toggleState != null);
    result = result && (ActionLoader.ACTION_TOGGLE_STATE_ON.equals(toggleState) || ActionLoader.ACTION_TOGGLE_STATE_OFF.equals(toggleState));
    return result;
  }
  
  public boolean isSelected() {
    if (!isToggleAction()) return false;
    Object state = getValue(ActionLoader.ACTION_TOGGLE_STATE_KEY);
    return (isEnabled() && ActionLoader.ACTION_TOGGLE_STATE_ON.equals(state));
  }
  
  public void setSelected(boolean state) {
    if (!isToggleAction()) return;
    Object oldStateVal = getValue(ActionLoader.ACTION_TOGGLE_STATE_KEY);
    Object stateVal;
    if (state) stateVal = ActionLoader.ACTION_TOGGLE_STATE_ON;
    else stateVal = ActionLoader.ACTION_TOGGLE_STATE_OFF;
    putValue(ActionLoader.ACTION_TOGGLE_STATE_KEY, stateVal);
    firePropertyChange(ActionLoader.ACTION_TOGGLE_STATE_KEY, oldStateVal, stateVal);
  }
  
  protected void updateSelected() {
    // allow subclasses to implement body
  }
  
}
