/*
 * RemoveAnchorAction.java
 *
 * Created on November 28, 2003, 11:32 AM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.shapes.*;
import java.awt.Component;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import javax.swing.SwingUtilities;

/**
 *
 * @author  Alan
 */
public class RemoveAnchorAction extends ShapeAction {
  
  public void actionPerformed(ActionEvent e) {
    MouseEvent evt = getMouseEvent();
    Component c = (Component) evt.getSource();
    ConnectionShape conn = (ConnectionShape) getShape();
    Point pt = SwingUtilities.convertPoint(c, evt.getPoint(), conn);
    AnchorShape anchor = conn.getNearestAnchor(pt);
    conn.removeAnchor(anchor);
  }
  
  public boolean isApplicable() {
    boolean result = super.isApplicable();
    result = result && (getShape() instanceof ConnectionShape);
    result = result && ((ConnectionShape) getShape()).getAnchorCount() > 0;
    result = result && (getMouseEvent() != null);
    return result;
  }
  
}
