/*
 * SetAnchorAction.java
 *
 * Created on December 31, 2003, 1:51 PM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.shapes.*;
import edu.byu.deg.osmx.*;

/**
 *
 * @author  Liddle
 */
public class SetAnchorAction extends ShapeAction {

    public void actionPerformed(java.awt.event.ActionEvent e) {
        if (getShape() instanceof ConnectorShape) {
            ConnectorShape  connShape = (ConnectorShape)getShape();
            
            if (isSelected()) {
                // Need to unanchor this connector
                connShape.unanchorCenterPoint();
            } else {
                // Need to anchor this connector
                connShape.anchorCenterPoint();
            }
            setSelected(!isSelected());
        }
    }

    public boolean isApplicable() {
        boolean result = super.isApplicable();
        result = result && (getShape() instanceof ConnectorShape);
        return result;
    }

    protected void updateSelected() {
        if (getShape() != null) {
            ConnectorShape connShape = (ConnectorShape) getShape();
            OSMXElement element = connShape.getElement();
            if (connShape != null && element != null && element instanceof PositionedElement &&
                ((PositionedElement)element).isSetPosition()) {
                setSelected(true);
            } else {
                setSelected(false);
            }
        } else {
            setSelected(false);
        }
    }

} /* class SetAnchorAction */
