/*
 * SetCardinalityConstraint.java
 *
 * Created on November 25, 2003, 10:44 PM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.shapes.ObjectSetShape;
import edu.byu.deg.osmx.binding.ObjectSetType;
import java.awt.event.ActionEvent;

/**
 *
 * @author  Alan
 */
public class SetCardinalityConstraintAction extends ShapeAction {
  
  public boolean isApplicable() {
    boolean result = super.isApplicable();
    result = result && (getShape() instanceof ObjectSetShape);
    return result;
  }
  
  protected void updateSelected() {
    if (getShape() != null) {
      ObjectSetShape objSetShape = (ObjectSetShape) getShape();
      ObjectSetType objSet = objSetShape.getObjectSet();
      if (objSet.isSetCardinalityConstraint()) {
        setSelected(true);
      } else {
        setSelected(false);
      }
    } else {
      setSelected(false);
    }
  }
  
  public void actionPerformed(ActionEvent e) {
    ObjectSetShape objSetShape = (ObjectSetShape) getShape();
    ObjectSetType objSet = objSetShape.getObjectSet();
    setSelected(!isSelected());
    if (isSelected() && !objSet.isSetCardinalityConstraint()) {
      objSet.setCardinalityConstraint("1");
    } else if (!isSelected()) {
      objSet.unsetCardinalityConstraint();
    }
  }
  
}
