/*
 * SetLeftArrowAction.java
 *
 * Created on December 26, 2003, 12:42 PM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.shapes.RelationshipSetShape;
import edu.byu.deg.osmx.binding.RelationshipSetType;
import java.awt.event.ActionEvent;

/**
 *
 * @author  Liddle
 */
public class SetLeftArrowAction extends ShapeAction {
  
  public void actionPerformed(ActionEvent e) {
    RelationshipSetShape relSetShape = (RelationshipSetShape) getShape();
    RelationshipSetType relSet = (RelationshipSetType)relSetShape.getElement();
    setSelected(!isSelected());
    relSet.setLeftArrow(isSelected());
    relSetShape.updateArrow();
  }

  public boolean isApplicable() {
    boolean result = super.isApplicable();
    result = result && (getShape() instanceof RelationshipSetShape);
    return result;
  }
  
  protected void updateSelected() {
    if (getShape() != null) {
      RelationshipSetShape relSetShape = (RelationshipSetShape) getShape();
      RelationshipSetType relSet = (RelationshipSetType)relSetShape.getElement();
      if (relSet != null && relSet.isSetLeftArrow() && relSet.isLeftArrow()) {
        setSelected(true);
      } else {
        setSelected(false);
      }
    } else {
      setSelected(false);
    }
  }
  
}  /* class SetLeftArrowAction */
