package edu.byu.deg.OntologyEditor.actions;

import java.awt.event.ActionEvent;

import edu.byu.deg.OntologyEditor.shapes.ChildRelSetConnectionShape;
import edu.byu.deg.OntologyEditor.shapes.RelSetConnectionShape;
import edu.byu.deg.osmx.OSMXChildRelSetConnection;
import edu.byu.deg.osmx.OSMXParticipationConstraintType;
import edu.byu.deg.osmx.OSMXRelSetConnectionType;
import edu.byu.deg.osmx.binding.ChildRelSetConnection;
import edu.byu.deg.osmx.binding.ParticipationConstraintType;

public class SetParentSideParticipationConstraintAction extends ShapeAction{
	public SetParentSideParticipationConstraintAction(){
		
	}
	public void actionPerformed(ActionEvent e) {
	    ChildRelSetConnectionShape connShape = (ChildRelSetConnectionShape) getShape();
	    
	    OSMXChildRelSetConnection conn = ((OSMXChildRelSetConnection) (connShape.getElement()));
	   
	    //conn.restoreParticipationConstraint();  
	    ParticipationConstraintType value= conn.getParentSideParticipationConstraint();

	    setSelected(!isSelected());
	    
	    //if (isSelected() && !conn.isSetParticipationConstraint()) {
	    if (isSelected() && !conn.isSetParentSideParticipationConstraint()) {
	    //if (isSelected()) {
	      if (value == null) {
	    	  value = new OSMXParticipationConstraintType();
	          value.setContent("0:*");
	      }
	      //conn.setParticipationConstraint(value);
	      conn.setParentSideParticipationConstraint(value);
	    } else if (!isSelected()) {
//	      conn.suppressParticipationConstraint();
	      //TODO
	    	conn.suppressParentSideParticipationConstraint();
	    }
	  }
	  
	  public boolean isApplicable() {
	    boolean result = super.isApplicable();
	    result = result && (getShape() instanceof ChildRelSetConnectionShape);
	    return result;
	  }
	protected void updateSelected() {
		if (getShape() != null ){
			ChildRelSetConnectionShape connShape = (ChildRelSetConnectionShape) getShape();
    		ChildRelSetConnection conn = (ChildRelSetConnection) connShape.getElement();
    		if (conn.isSetParentSideParticipationConstraint())
    			setSelected(true);
    		else
    			setSelected(false);
		}
	    else {
	      setSelected(false);
	    }
	}
}
