/*
 SetConstraintAction.java
 *
 * Created on November 29, 2003, 11:01 PM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.shapes.ChildRelSetConnectionShape;
import edu.byu.deg.OntologyEditor.shapes.ParticipationConstraintShape;
import edu.byu.deg.OntologyEditor.shapes.RelSetConnectionShape;
import edu.byu.deg.osmx.binding.*;
import edu.byu.deg.osmx.*;
import java.awt.event.ActionEvent;

/**
 *
 * @author  Reema AL-KAMHA
 */
public class SetParticipationConstraintAction extends ShapeAction {
  	
  /** Creates a new instance of SetParticipationConstraintAction */
    public SetParticipationConstraintAction() {
  }
  
  public void actionPerformed(ActionEvent e) {
    RelSetConnectionShape connShape = (RelSetConnectionShape) getShape();
    
    OSMXRelSetConnectionType conn = ((OSMXRelSetConnectionType) (connShape.getElement()));
   
    //conn.restoreParticipationConstraint();  
    ParticipationConstraintType value= conn.getParticipationConstraint();

    setSelected(!isSelected());
    
    if (isSelected() && !conn.isSetParticipationConstraint()) {
    //if (isSelected()) {
      if (value == null) {
    	  value = new OSMXParticipationConstraintType();
          value.setContent("0:*");
      }
      conn.setParticipationConstraint(value);
    } else if (!isSelected()) {
      conn.suppressParticipationConstraint();
    }
  }
  
  public boolean isApplicable() {
    boolean result = super.isApplicable();
    result = result && (getShape() instanceof RelSetConnectionShape);
    return result;
  }
  
  protected void updateSelected() {
    if (getShape() != null) {
    	RelSetConnectionShape connShape = (RelSetConnectionShape) getShape();
    	RelSetConnectionType conn = (RelSetConnectionType) connShape.getElement();
    	if (conn.isSetParticipationConstraint()) {
    		setSelected(true);
    	} else {
    		setSelected(false);
    	}
    } 
    else {
      setSelected(false);
    }
  }
  
}