/*
 * SetPrimaryObjectSetAction.java
 *
 * Created on December 1, 2003, 8:59 PM
 */

package edu.byu.deg.OntologyEditor.actions;

import edu.byu.deg.OntologyEditor.shapes.ObjectSetShape;
import edu.byu.deg.osmx.binding.ObjectSetType;
import java.awt.event.ActionEvent;

/**
 *
 * @author  Alan
 */
public class SetPrimaryObjectSetAction extends ShapeAction {
  
  public boolean isApplicable() {
    boolean result = super.isApplicable();
    result = result && (getShape() instanceof ObjectSetShape);
    return result;
  }
  
  public void actionPerformed(ActionEvent e) {
    ObjectSetShape objSetShape = (ObjectSetShape) getShape();
    ObjectSetType objSet = objSetShape.getObjectSet();
    setSelected(!isSelected());
    objSet.setPrimary(isSelected());
  }
  
  protected void updateSelected() {
    if (getShape() != null) {
      ObjectSetShape objSetShape = (ObjectSetShape) getShape();
      ObjectSetType objSet = objSetShape.getObjectSet();
      if (objSet.isSetPrimary() && objSet.isPrimary()) {
        setSelected(true);
      } else {
        setSelected(false);
      }
    } else {
      setSelected(false);
    }
  }
  
}
