/*
 * AnchorShape.java
 *
 * Created on August 22, 2003, 8:54 PM
 */

package edu.byu.deg.OntologyEditor.shapes;

import edu.byu.deg.osmx.OSMXElement;
import edu.byu.deg.osmx.binding.AnchorType;
import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.*;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

/**
 *
 * @author  Alan
 */
public class AnchorShape extends PlanarShape {
  
  protected static final int ANCHOR_WIDTH = 6;
  
  protected Point originPt;
  protected Point anchorPoint = null;
  protected AnchorType anchor;
  private ComponentAdapter canvasSizeListener;
  private boolean isHandle = false;
  
  /** Creates a new instance of AnchorShape */
  public AnchorShape(Container c, OSMXElement elem) {
    super(c, elem);
    anchor = (AnchorType) element;
    anchorPoint = new Point(anchor.getX(), anchor.getY());
    setSize(ANCHOR_WIDTH, ANCHOR_WIDTH);
  }
  
  protected void updateSelectionState() {
    repaint();
  }
  
  protected void initSize() {
    canvasSizeListener = new ComponentAdapter() {
      public void componentResized(ComponentEvent evt) {
        setSize(getParent().getSize());
      }
    };
    getParent().addComponentListener(canvasSizeListener);
  }
  
  public Point getPoint() {
    return anchorPoint;
  }
  
  public void setPoint(Point pt) {
    anchorPoint = pt;
  }
  
  //test
  public void isHandle(boolean ishandle) {
	  isHandle = ishandle;
  }
  //end test
  
  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    Graphics2D g2d = (Graphics2D) g.create();
    Color fill = (selected ? Color.lightGray : Color.BLACK);
    g2d.setColor(fill);
    Rectangle2D.Double handle = new Rectangle2D.Double(0, 0, ANCHOR_WIDTH, ANCHOR_WIDTH);
    g2d.fill(handle);
    /*
    g2d.setColor(Color.BLACK);
    g2d.draw(handle);
     */
  }
  
  public Point getOrigin() {
    if (originPt == null) originPt = new Point(ANCHOR_WIDTH / 2, ANCHOR_WIDTH / 2);
    return originPt;
  }
  public void undecide(){
	  
  }
}
