/*
 * ConnectableShape.java
 *
 * Created on June 23, 2003, 8:57 PM
 */

package edu.byu.deg.OntologyEditor.shapes;

import edu.byu.deg.osmx.OSMXElement;
import java.awt.Container;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

/**
 *
 * @author  Alan
 */
public abstract class ConnectableShape extends PlanarShape {
  
  /** Creates a new instance of ConnectableShape */
  public ConnectableShape(Container c, OSMXElement elem) {
    super(c, elem);
  }
  
  public Point2D.Double getIntersectionPoint(Point2D.Double pt) {
    Rectangle rect = getBounds();
    Point2D.Double centerPt = new Point2D.Double(rect.width / 2, rect.height / 2);

    double x, y, m, x2, y2;
    
    // determine slope
    // double check divide by zero error
    if (Math.round(pt.x) == Math.round(centerPt.x)) {
      // vertical line
      return new Point2D.Double(centerPt.x, pt.y < centerPt.y ? 0 : rect.height);
    }
    
    m = (pt.y - centerPt.y) / (pt.x - centerPt.x);
    if (Math.abs(m) < 0.0000001) {
      // horizontal line
      y = centerPt.y;
      if (pt.x < centerPt.x)
        x = 0;
      else
        x = rect.width;
    } else if (pt.x < centerPt.x) {
      if (pt.y < centerPt.y) {	// intersects on left or top side
        // point slope formula
        // y - y1 = m(x - x1)
        x2 = 0;
        y2 = 0;
        x = (y2 - pt.y)/m + pt.x;
        y = m * (x2 - pt.x) + pt.y;
        
        if (x < x2) // intersects on left side
          x = x2;
        if (y < y2) // intersects on top side
          y = y2;
      }
      else {	// intersects on left or bottom side
        x2 = 0;
        y2 = rect.height;
        x = (y2 - pt.y) / m + pt.x;
        y = m * (x2 - pt.x) + pt.y;
        
        if (x < x2) // intersects on left side
          x = x2;
        if (y > y2) // intersects on bottom side
          y = y2;
      }
    } else {
      if (pt.y < centerPt.y) {	// intersects on right or top side
        x2 = rect.width;
        y2 = 0;
        x = (y2 - pt.y)/m + pt.x;
        y = m * (x2 - pt.x) + pt.y;
        
        if (x > x2) // intersects on right side
          x = x2;
        if (y < y2) // intersects on top side
          y = y2;
      } else {	// intersects on right or bottom side
        x2 = rect.width;
        y2 = rect.height;
        x = (y2 - pt.y)/m + pt.x;
        y = m * (x2 - pt.x) + pt.y;
        
        if (x > x2) // intersects on right side
          x = x2;
        if (y > y2) // intersects on bottom side
          y = y2;
      }
    }
    return new Point2D.Double(x, y);

  } // method getIntersectionPoint
  
}
