/*
 * NoteShape.java
 *
 * Created on June 23, 2003, 1:55 PM
 */

package edu.byu.deg.OntologyEditor.shapes;

import edu.byu.deg.OntologyEditor.ObjBorder;
import edu.byu.deg.osmx.OSMXElement;
import edu.byu.deg.osmx.OSMXPositionedText;
import edu.byu.deg.osmx.binding.Note;
import edu.byu.deg.osmx.binding.PositionedText;
import java.awt.Container;

/**
 *
 * @author  Alan Wessman
 */
public class NoteShape extends TextShape {
  Note note;
  private static final String DEFAULT_NOTE_TEXT = "Note";
  
  /** Creates a new instance of NoteShape */
  public NoteShape(Container c, OSMXElement elem) {
    super(c, elem);
    setBorder(shapeBorder);
    ((ObjBorder) shapeBorder).setRectDraw(getStyle() != DEFAULT_STYLE && getStyle().getLine() != null);
    if (textElement.getContent() == null)
    	textElement.setContent(DEFAULT_NOTE_TEXT);
    setSize(getPreferredSize());
  }
  
  protected PositionedText getTextElement() {
    if (textElement != null) return textElement;
    textElement = (OSMXPositionedText) element;
    return textElement;
  } // method getTextElement
  
  protected Note getNote() {
    if (note != null) return note;
    note = (Note) element;
    return note;
  } // method getNote
  
}
