/*
 * ParticipationConstraintShape.java
 *
 * Created on November 18, 2003, 8:25 PM
 */

package edu.byu.deg.OntologyEditor.shapes;

import edu.byu.deg.osmx.OSMXElement;
import java.awt.Container;
import java.awt.Point;

import javax.swing.JComponent;
import javax.swing.SwingUtilities;


/**
 *
 * @author  Alan
 */
public class ParticipationConstraintShape extends TextShape {
  private boolean isConnectTriangle;//indicate whether it is a parentSidePC
  /** Creates a new instance of ParticipationConstraintShape */
  public ParticipationConstraintShape(Container c, OSMXElement elem, boolean connTriangle) {
    super(c, elem);
    this.isConnectTriangle = connTriangle;
  }
  
  protected void setLocationFromPosition() {
    positionChanging = true;
    // read position from posElem
    // calculate location from position coords
    int x = posElem.getX();
    int y = posElem.getY();
    Point pt = new Point(getOrigin());
    pt.x = -pt.x;
    pt.y = -pt.y;
    pt.translate(x, y);
    Point connectionPoint = null;
    //Point connectionPoint = ((RelSetConnectionShape) getParent()).getRealObjectCenterPoint();
    if (getParent() instanceof RelSetConnectionShape)
    	connectionPoint = ((RelSetConnectionShape) getParent()).getRealObjectCenterPointAccordingToAngle();//test
    else if (getParent() instanceof ChildRelSetConnectionShape){
    	if (!this.isConnectTriangle)
    		connectionPoint = ((ChildRelSetConnectionShape) getParent()).getRealObjectCenterPointAccordingToAngle();//test
    	else{
    		connectionPoint = ((ChildRelSetConnectionShape) getParent()).getRealObjectCenterPointAccordingToAngle();
    		//System.out.println("center:" + connectionPoint);
    		//System.out.println("con:" +((ChildRelSetConnectionShape)getParent()).getPosition() );
    		//System.out.println("aggreg: " +((DrawShape)getParent().getParent()).getPosition() );
    		//connectionPoint = ((ChildRelSetConnectionShape) getParent()).getOrigin();
    		//connectionPoint = SwingUtilities.convertPoint((ChildRelSetConnectionShape) getParent(),connectionPoint, this);
    		//JComponent comp = 
    		//connectionPoint = 
    	}
    }
    pt.translate(connectionPoint.x, connectionPoint.y);
    // call setLocation
    setLocation(pt);
    positionChanging = false;
  }
  
  public Point getPosition() {
    Point loc = getLocation();
    //Point pt = ((RelSetConnectionShape) getParent()).getRealObjectCenterPoint();
    Point pt = null;
    if (getParent() instanceof RelSetConnectionShape)
    	pt = ((RelSetConnectionShape) getParent()).getRealObjectCenterPointAccordingToAngle();//test
    else if (getParent() instanceof ChildRelSetConnectionShape){
    	if (this.isConnectTriangle == false)
    		pt = ((ChildRelSetConnectionShape) getParent()).getRealObjectCenterPointAccordingToAngle();//test
    	else{
    		pt = ((ChildRelSetConnectionShape) getParent()).getOrigin();
    		pt = SwingUtilities.convertPoint((ChildRelSetConnectionShape) getParent(),pt, this);
    	}
    }
    loc.translate(-pt.x, -pt.y); // negative is correct: gives loc relative to parent origin
    pt = getOrigin();
    loc.translate(pt.x, pt.y); // now adjust to put in terms of this shape's origin
    
    return loc;
  } // method getPosition
  
}
