/*
 * PointUtilities.java
 *
 * Created on January 2, 2004, 3:53 PM
 */

package edu.byu.deg.OntologyEditor.shapes;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

/**
 *
 * @author  Liddle
 */
public abstract class PointUtilities {

    public static Point2D.Double hiResPoint(Point pt) {
    	if (pt == null) System.out.println("sth wrong here");
        return (new Point2D.Double(pt.x, pt.y));
    }

    public static Point lowResPoint(Point2D.Double pt) {
        return (new Point((int)(pt.x + 0.5), (int)(pt.y + 0.5)));
    }

    public static Point2D.Double convertPoint(Component source, Point2D.Double aPoint, Component destination) {
        Point2D.Double p;

        if (source == null && destination == null)
            return aPoint;
        if (source == null) {
            source = SwingUtilities.getWindowAncestor(destination);
            if (source == null)
                throw new Error("Source component not connected to component tree hierarchy");
        }
        p = new Point2D.Double(aPoint.x, aPoint.y);
        convertPointToScreen(p, source);
        if (destination == null) {
            destination = SwingUtilities.getWindowAncestor(source);
            if (destination == null)
                throw new Error("Destination component not connected to component tree hierarchy");
        }
        convertPointFromScreen(p, destination);
        return p;
    }

    public static void convertPointToScreen(Point2D.Double p, Component c) {
        int x, y;

        do {
            if (c instanceof JComponent) {
                x = ((JComponent)c).getX();
                y = ((JComponent)c).getY();
            } else if(c instanceof java.applet.Applet ||
                      c instanceof java.awt.Window) {
                try {
                    Point pp = c.getLocationOnScreen();
                    x = pp.x;
                    y = pp.y;
                } catch (IllegalComponentStateException icse) {
                    x = c.getX();
                    y = c.getY();
                }
            } else {
                x = c.getX();
                y = c.getY();
            }

            p.x += x;
            p.y += y;

            if (c instanceof java.awt.Window || c instanceof java.applet.Applet)
                break;
            c = c.getParent();
        } while(c != null);
    }

    /**
     * Convert a point from a screen coordinates to a component's 
     * coordinate system
     *
     * @param p  a Point object (converted to the new coordinate system)
     * @param c  a Component object
     */
    public static void convertPointFromScreen(Point2D.Double p, Component c) {
        int x, y;

        do {
            if (c instanceof JComponent) {
                x = ((JComponent)c).getX();
                y = ((JComponent)c).getY();
            }  else if (c instanceof java.applet.Applet ||
                        c instanceof java.awt.Window) {
                try {
                    Point pp = c.getLocationOnScreen();
                    x = pp.x;
                    y = pp.y;
                } catch (IllegalComponentStateException icse) {
                    x = c.getX();
                    y = c.getY();
                }
            } else {
                x = c.getX();
                y = c.getY();
            }

            p.x -= x;
            p.y -= y;

            if (c instanceof java.awt.Window || c instanceof java.applet.Applet)
                break;
            c = c.getParent();
        } while(c != null);
    }

} /* class PointUtilities */
