/*
 * StateConnectableContainerShape.java
 *
 * Created on Feb 3, 2005, 7:36 PM
 */

package edu.byu.deg.OntologyEditor.shapes;

import edu.byu.deg.OntologyEditor.Canvas;
import edu.byu.deg.OntologyEditor.EditableText;
import edu.byu.deg.OntologyEditor.ObjBorder;
import edu.byu.deg.osmx.*;
import edu.byu.deg.osmx.binding.OSMType;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import javax.swing.JTextArea;
import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.beans.PropertyChangeEvent;
import java.awt.Font;


/**
 *
 * @author  Muhammed
 */
public abstract class StateConnectableContainerShape extends ObjConnectableShape 
implements Canvas,DocumentListener {//DocumentListener
  
  protected static final Color HIGHLEVEL_COLOR = new Color(230,230,230,255);
  protected JTextArea nameText = null;
  JTextField jtf;
  protected boolean suppressDocEvents = false;
    
  /** Creates a new instance of ConnectableContainerShape */
  public StateConnectableContainerShape(Container c, OSMXElement elem) {
    super(c, elem);
    
    
   ObjBorder stateBorder = (ObjBorder) shapeBorder;
   //Added by Muhammed--functions in ObjBorder
   stateBorder.setRectDraw(false);
   stateBorder.setRoundRec(true); //I comment out this method in Nov 7, 2005
   //stateBorder.
   setBorder(shapeBorder);
   setBorder(stateBorder);
    FlowLayout fl = new FlowLayout();
    ConnectableContainerLayout ccl = new ConnectableContainerLayout();
    fl.setHgap(0);
    fl.setVgap(0);
    setLayout(ccl);
    setBackground(getFillColor());
    setForeground(getFontColor());
    jtf = new JTextField();
    
    nameText = new EditableText();
    nameText.addMouseListener(this.getRootCanvas());
    nameText.addMouseMotionListener(this.getRootCanvas());
    nameText.setForeground(getFontColor());
    nameText.setBackground(getFillColor());
    nameText.setFont(new Font(getFontFamily(), OSMXFontType.styleToInt(getFontStyle()), (int) getFontSize()));
    positionNameText();
    nameText.getDocument().addDocumentListener(this);
    suppressDocEvents = true;
    String shapeName = getShapeName();
    nameText.setText(shapeName);
    this.setSize(this.getPreferredSize());
    nameText.setSize(nameText.getPreferredSize());
    suppressDocEvents = false;
  }
    
  protected void positionNameText()
  {
    if (element != null && element instanceof TextAlignableElement) {
      TextAlignableElement tae = (TextAlignableElement) element;
      remove(nameText);
      if (tae.isCentered()) {
        add(ConnectableContainerLayout.CENTER, nameText);
      } else {
        add(ConnectableContainerLayout.CENTER, nameText);
      }
    }
  }
  
  /** Gives notification that an attribute or set of attributes changed.
   *
   * @param e the document event
   *
   */
  public void changedUpdate(DocumentEvent e) {//System.out.println("CUD");
  }
  
  public void dragSelectedObjects(int x, int y) {
  }
  
  public int getNumberSelected(boolean bWithSubObjs) {
    return 0; // TODO
  }
  
  public abstract OSMType getOSM();
  
  public abstract String getShapeName();
  
  protected abstract void setShapeName(String s);
  
  public int getState() {
    return 0; // TODO
  }
  
  /** Gives notification that there was an insert into the document.  The
   * range given by the DocumentEvent bounds the freshly inserted region.
   *
   * @param e the document event
   *
   */
  public void insertUpdate(DocumentEvent e) {
    if (!suppressDocEvents) {
      setSize(getPreferredSize());
      setShapeName(nameText.getText());
    }
  }
  
  /** Gives notification that a portion of the document has been
   * removed.  The range is given in terms of what the view last
   * saw (that is, before updating sticky positions).
   *
   * @param e the document event
   *
   */
  public void removeUpdate(DocumentEvent e) {System.out.println("RUH");
    if (!suppressDocEvents) {
      setSize(getPreferredSize());
      setShapeName(nameText.getText());
    }
  } 
  
  public void setState(int state) {
  }
  
  public void toBack(Component comp) {
  }
  
  public void toFront(Component comp) {
  }
  
  public void unselectAll() {
  }
  
    protected void updateSelectionState() {
        super.updateSelectionState();
        if (!selected) {
            // de-select the text in the nested text component
            nameText.select(0, 0);
        }
    }

    public DrawShape findShapeForElement(OSMXElement elem) {
        return null; // TODO
    }
  
    public void elementPropertyChange(PropertyChangeEvent evt) {//System.out.println("YES");
        super.elementPropertyChange(evt);
        if (OSMXStyleType.STYLE_PROPERTY.equals(evt.getPropertyName())) {
            nameText.setFont(new Font(getFontFamily(),
                                      OSMXFontType.styleToInt(getFontStyle()),
                                      (int)getFontSize()));
            nameText.setForeground(getFontColor());
            nameText.setBackground(getFillColor());
        }
    }
  
} /* class StateConnectableContainerShape */
