/*
 * State.java
 *
 * Created on January 18, 2005, 11:07 AM
 */

package edu.byu.deg.OntologyEditor.shapes;

import edu.byu.deg.OntologyEditor.*;
import edu.byu.deg.osmx.*;
import edu.byu.deg.osmx.binding.*;
import edu.byu.deg.OntologyEditor.epsgraphics.EpsGraphics2D;
import java.awt.Container;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.beans.PropertyChangeEvent;
import javax.swing.JPanel;
//
import java.awt.*;
import javax.swing.*;
import java.awt.geom.*;
import javax.swing.event.DocumentListener;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.awt.event.ComponentAdapter;

//
/**
 *
 * @author  Muhammed
 */

public class StateShape extends  StateConnectableContainerShape
implements TextChangeListener{//DocumentListener

	   protected String            stateName = null;
	    protected OSMXStateType state = null;
	    protected JPanel            constraintPanel = null;
	    protected GridBagLayout     gridbag = null;
	    protected static final int  PRIMARY_WIDTH = 20;
	    protected static final int  PRIMARY_HEIGHT = 5;
	    private java.awt.geom.RoundRectangle2D.Double shapeBorder;
	    protected ComponentAdapter      canvasSizeListener;
	    
	    /** Creates a new instance of ObjectSetShape */
	    public StateShape(Container c, OSMXElement elem) {
	        super(c, elem);  
	        getState1();
	        state.addPositionListener(this);
	        //add(this);
	    }

	    public OSMXStateType getState1() {
	        if (state != null) return state;
	        state = (OSMXStateType) element;
	        return state;
	    
	    }

	    public OSMType getOSM() {
	        return getState1().getOSM();
	    }

	    public String getShapeName() {
	        if (stateName == null && getState1() != null)
	        {
	        	 
	        	return state.getPrimaryName();
	        }
	       
	        return "state";
	    }

	    protected void setShapeName(String s) {
	    	System.out.print("*@# "+s);
	        stateName = s;
	        if (state != null) state.setName(stateName);
	    }

	     public void delete() {
	        getParent().removeComponentListener(canvasSizeListener);
	        super.delete();
	    }
	   public void paintComponent(Graphics g) {
	       
	        if (g instanceof EpsGraphics2D) {
	            ((EpsGraphics2D)g).addComment("");
	            ((EpsGraphics2D)g).addComment("State<" + stateName + ">");
	           System.out.println("in If Out"); 
	            super.paintComponent(g);
	        }
	        super.paintComponent(g);
	        
	   System.out.println("Out");
	 
	    }
	   public void textChanged(String newText) {
		   System.out.println("***>>> "+newText);
	       suppressDocEvents = true;
	       nameText.setText(newText);
	       suppressDocEvents = false;
	  } // 
	    
	    public void changedUpdate(DocumentEvent e) {
	    	System.out.println("CU");
	    }
	    
	    public void insertUpdate(DocumentEvent e) {
	    	
	    	if (!suppressDocEvents) {
	    	      setSize(getPreferredSize());
	    	      setShapeName(nameText.getText());
	    	    }
	    	//setShapeName(nameText.getText());
	    	
	    }
	    
	    public void removeUpdate(DocumentEvent e) {
	    	System.out.println("RU");
	    
	    	 if (!suppressDocEvents) {
	    	      setSize(getPreferredSize());
	    	      setShapeName(nameText.getText());
	        }
	    }
	    
	 // method textChanged
}
