/*
 * TransitionConnectableContainerShape.java
 *
 * Created on February 11, 2005, 8:14 PM
 */

package edu.byu.deg.OntologyEditor.shapes;
import java.awt.*;
import javax.swing.*;
import java.awt.geom.*;
import edu.byu.deg.OntologyEditor.Canvas;
import edu.byu.deg.OntologyEditor.EditableText;
import edu.byu.deg.OntologyEditor.ObjBorder;
import edu.byu.deg.osmx.*;
import edu.byu.deg.osmx.binding.OSMType;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import javax.swing.JTextArea;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.beans.PropertyChangeEvent;
import java.awt.Font;
import java.awt.Point;
import java.awt.Rectangle;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;

/**
 *
 * @author  Muhammed Al-Muhammed
 */
public abstract class TransitionConnectableContainerShape extends ObjConnectableShape 
implements Canvas, DocumentListener {
  
//  protected static final Color HIGHLEVEL_COLOR = new Color(230,230,230,255);
 
  protected JTextArea TriggerText = null;
  protected JTextArea ActionText = null;
  protected boolean suppressDocEvents = false;
    /** Creates a new instance of TransitionConnectableContainerShape */
    public TransitionConnectableContainerShape(Container c, OSMXElement elem) {
    super(c, elem);
    
    //shapeBorder = new RoundRectangle2D.Double(0, 0,100,40,100,40);
    
  ObjBorder stateBorder = (ObjBorder) shapeBorder;
 
   //stateBorder.setRoundRec(false);
  stateBorder.setTransitionBorder();
   setBorder(shapeBorder);
   FlowLayout fl = new FlowLayout();
  //  VerticalLayout vl = new VerticalLayout();
    ConnectableContainerLayout ccl = new ConnectableContainerLayout();
   
   
    fl.setHgap(40);
    fl.setVgap(10);
    setLayout(ccl);
    
    
    setBackground(getFillColor());
    setForeground(getFontColor());
    TriggerText = new EditableText();
    
    System.out.print("************** IN Transiton ****");
    suppressDocEvents = true;
    TriggerText.setText(getTriggers());
    
    TriggerText.setSize(TriggerText.getPreferredSize());
    Border brd = BorderFactory.createMatteBorder( -1, -1, 1, 0, Color.black);
    TriggerText.setBorder(brd);
    TriggerText.addMouseListener(this.getRootCanvas());
    TriggerText.addMouseMotionListener(this.getRootCanvas());
    TriggerText.setForeground(getFontColor());
    TriggerText.setBackground(getFillColor());
    TriggerText.setFont(new Font(getFontFamily(), OSMXFontType.styleToInt(getFontStyle()), (int) getFontSize()));
    TriggerText.getDocument().addDocumentListener(this);
    positionTriggerText();
    
    //
  //  ConnectableContainerLayout ccl1 = new ConnectableContainerLayout();
    //setLayout(ccl1);
    ActionText = new EditableText();
    ActionText.setText(getActions());
    ActionText.setSize(TriggerText.getPreferredSize());
    ActionText.addMouseListener(this.getRootCanvas());
    ActionText.addMouseMotionListener(this.getRootCanvas());
    ActionText.setForeground(getFontColor());
    ActionText.setBackground(getFillColor());
    ActionText.setFont(new Font(getFontFamily(), OSMXFontType.styleToInt(getFontStyle()), (int) getFontSize()));
    ActionText.getDocument().addDocumentListener(this);
    positionActionText();
 
    
   
    suppressDocEvents = false;
     
  }
    
  protected void positionTriggerText()
  {
    if (element != null && element instanceof TextAlignableElement) {
    	System.out.println("NO IN CENTERD ***");
      TextAlignableElement tae = (TextAlignableElement) element;
      remove(TriggerText);
      //
     // remove(ActionText);
      //
      if (tae.isCentered()) {System.out.println("IN CENTERED HELLO ***");

        add(ConnectableContainerLayout.TOP_CENTER, TriggerText);
      //  add(ConnectableContainerLayout.BOTTOM_CENTER, ActionText);
      } else {
        add(ConnectableContainerLayout.TOP_CENTER, TriggerText);
       // add(ConnectableContainerLayout.BOTTOM_CENTER, ActionText);
      }
    }
  }
  
  protected void positionActionText()
  {
    if (element != null && element instanceof TextAlignableElement)
    {
    	System.out.println("NO IN CENTERD ***");
      TextAlignableElement tae = (TextAlignableElement) element;
     // remove(nameText);
      //
      remove(ActionText);
      //
      if (tae.isCentered()) {
    	  System.out.println("IN CENTERED HELLO ***");

      //  add(ConnectableContainerLayout.TOP_CENTER, nameText);
        add(ConnectableContainerLayout.BOTTOM_CENTER, ActionText);
      } else {
        //add(ConnectableContainerLayout.TOP_CENTER, nameText);
        add(ConnectableContainerLayout.BOTTOM_CENTER, ActionText);
      }
    }
  }
  
  /** Gives notification that an attribute or set of attributes changed.
   *
   * @param e the document event
   *
   */
  public void changedUpdate(DocumentEvent e) {
  }
  
  public void dragSelectedObjects(int x, int y) {
  }
  
  public int getNumberSelected(boolean bWithSubObjs) {
    return 0; // TODO
  }
  
  public abstract OSMType getOSM();
  protected abstract void setTransitionAction(String s);
  protected abstract void setTransitionTrigger(String s); 
  public abstract String getShapeName();
  
 // protected abstract void setShapeName(String s);
  
  public int getState() {
    return 0; // TODO
  }
  
  public abstract String getTriggers();
  public abstract String getActions();
  
  /** Gives notification that there was an insert into the document.  The
   * range given by the DocumentEvent bounds the freshly inserted region.
   *
   * @param e the document event
   *
   */
  public void insertUpdate(DocumentEvent e) {System.out.println("TICHANGE");
    if (!suppressDocEvents) {
      setSize(getPreferredSize());
      setTransitionTrigger(TriggerText.getText());
      setTransitionAction(ActionText.getText());
    }
  }
  
  /** Gives notification that a portion of the document has been
   * removed.  The range is given in terms of what the view last
   * saw (that is, before updating sticky positions).
   *
   * @param e the document event
   *
   */
  public void removeUpdate(DocumentEvent e) {
    if (!suppressDocEvents) {
      setSize(getPreferredSize());
      setTransitionTrigger(TriggerText.getText());
    }
  } 
  
  public void setState(int state) {
  }
  
  public void toBack(Component comp) {
  }
  
  public void toFront(Component comp) {
  }
  
  public void unselectAll() {
  }
  
    protected void updateSelectionState() {
        super.updateSelectionState();
        if (!selected) {
            TriggerText.select(0, 0);
            ActionText.select(0, 0);
        }
    }

    public DrawShape findShapeForElement(OSMXElement elem) {
        return null; // TODO
    }
  
    public void elementPropertyChange(PropertyChangeEvent evt) {
        super.elementPropertyChange(evt);
        if (OSMXStyleType.STYLE_PROPERTY.equals(evt.getPropertyName())) {
            TriggerText.setFont(new Font(getFontFamily(),
                                      OSMXFontType.styleToInt(getFontStyle()),
                                      (int)getFontSize()));
            TriggerText.setForeground(getFontColor());
            TriggerText.setBackground(getFillColor());
        }
    }
  
    
}
