package edu.byu.deg.OntologyEditor.text_tools;
/**
 * Generates soundex codes for strings.
 *
 * Taken from the java code snippets on sourceforge.net:
 * http://sourceforge.net/snippet/detail.php?type=snippet&id=100251
 *
 * @author    santoni
 */
public final class Soundex
{
	/**
	 * Generates the soundex code for the String in
	 *
	 * @param in  String for which to generate soundex code
	 * @return    Soundex code for in
	 */
	public static String code(String in)
	{
		char  out[]      = {'0', '0', '0', '0'};
		char  last;
		char  mapped;
		int   incount  = 1;
		int   count    = 1;
		out[0] = Character.toUpperCase(in.charAt(0));
		last = getMappingCode(in.charAt(0));
		while ((incount < in.length()) &&
			(mapped = getMappingCode(in.charAt(incount++))) != 0 &&
			(count < 4))
		{
			if ((mapped != '0') && (mapped != last))
				out[count++] = mapped;
			last = mapped;
		}
		return (new String(out));
	}



	private static char getMappingCode(char c)
	{
		if (!Character.isLetter(c))
			return 0;
		else
			return map[Character.toUpperCase(c) - 'A'];
	}
	// Mapping


	private final static  char  map[]  =
		"01230120022455012623010202".toCharArray();
}
