package edu.byu.deg.common;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import javax.swing.Icon;
import javax.swing.JButton;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import java.awt.Dimension;

public class ColorButton extends JButton {
  private List colorListeners;

  public ColorButton() {
    super(new ColorIcon());
    colorListeners = new ArrayList();
    this.setText(null);
    this.setMaximumSize(new Dimension(ColorIcon.ICONWIDTH + 8, ColorIcon.ICONWIDTH + 8));
    this.setMinimumSize(new Dimension(ColorIcon.ICONWIDTH + 2, ColorIcon.ICONWIDTH + 2));
    this.setPreferredSize(this.getMaximumSize());
 /*   this.addActionListener(
    new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Color chosenColor = JColorChooser.showDialog(ColorButton.this, "Choose Expression Color", getColor());
        if (chosenColor != null) {
          setColor(chosenColor);
        }
      }
    }
    );*/
  }

  public void addColorListener(ColorListener cl) {
    if (!colorListeners.contains(cl)) colorListeners.add(cl);
  }

  public void removeColorListener(ColorListener cl) {
    colorListeners.remove(cl);
  }

  protected void fireColorChanged() {
    for (Iterator i = colorListeners.iterator(); i.hasNext();) {
      ColorListener cl = (ColorListener) i.next();
      cl.colorChanged(getColor());
    }
  }

  public void setColor(Color color) {
    if (getColor() == color) return;
    ((ColorIcon)getIcon()).setColor(color);
    repaint();
    fireColorChanged();
  }

  public Color getColor() {
    return ((ColorIcon)getIcon()).getColor();
  }

  public void setEnabled(boolean b) {
    super.setEnabled(b);
    ((ColorIcon) getIcon()).setEnabled(b);
  }
} // class ColorButton

class ColorIcon implements Icon {
  public static final int ICONWIDTH = 16;
  private Color m_color;
  private boolean enabledState = false;

  public ColorIcon() {
    m_color = Color.white;
  }

  void setColor(Color color) {
    m_color = color;
  }

  Color getColor() {
    return m_color;
  }

  public void setEnabled(boolean enabled) {
    enabledState = enabled;
  }

  public boolean isEnabled() {
    return enabledState;
  }

  public int getIconHeight() {
    return ICONWIDTH;
  }

  public int getIconWidth() {
    return ICONWIDTH;
  }

  public void paintIcon(Component c, Graphics g, int x, int y) {
    g.setColor(enabledState ? Color.BLACK : Color.GRAY);
    g.fillRect(x, y, ICONWIDTH, ICONWIDTH);
    g.setColor(enabledState ? m_color : Color.LIGHT_GRAY);
    g.fillRect(x + 1, y + 1, ICONWIDTH - 2, ICONWIDTH - 2);
    if (!enabledState) {
      g.setColor(Color.GRAY);
      g.drawLine(x, y, x + ICONWIDTH - 1, y + ICONWIDTH - 1);
      g.drawLine(x, y + ICONWIDTH - 1, x + ICONWIDTH - 1, y);
    }
  }
} // class ColorIcon