/*
 * Extractor.java
 *
 * Created on April 27, 2004, 12:01 PM
 */

package edu.byu.deg.cs652;

import edu.byu.deg.osmx.*;
import edu.byu.deg.util.*;
import edu.byu.deg.framework.retriever.DOMRetriever;
import edu.byu.deg.framework.*;
/**
 *
 * @author  troywalk
 */
public class Extractor {
  
  /** Creates a new instance of Extractor */
  public Extractor() {
  }
  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) {
    if(args.length!=2){
      System.out.println("please input ontology filename and url list filename as inputs");
      return;
    }
    try{
      if(Timer.time) Timer.timer.startTask("Extracting");
      OSMXDocument ontology = new OSMXDocument();

      if(Timer.time) Timer.timer.startTask("Loading ontology");
      ontology = ontology.openDocument(args[0]);
      if(Timer.time) Timer.timer.endTask("Loading ontology");

      if(Timer.time) Timer.timer.startTask("Initiating Document Retriever");
      DocumentRetriever retriever = new DOMRetriever(args[1]);
      if(Timer.time) Timer.timer.endTask("Initiating Document Retriever");
      
      edu.byu.deg.extractionmodule.MetaExtractor extractor = new edu.byu.deg.extractionmodule.MetaExtractor(ontology);
      extractor.startExtraction(retriever, null);
      
      if(Timer.time) Timer.timer.startTask("Saving ontology");
      ontology.saveAsDocument("result.xml");
      if(Timer.time) Timer.timer.endTask("Saving ontology");

      if(Timer.time) Timer.timer.startTask("Saving result page");
      edu.byu.deg.query.DataPrinter printer = new edu.byu.deg.query.DataPrinter();
      //printer.printToFile("result.html", ontology);
      printer.printToFile("c:\\askOntosData\\result.html", ontology);
      if(Timer.time) Timer.timer.endTask("Saving result page");

      if(Timer.time) Timer.timer.endTask("Extracting");
    }catch(Exception e) {e.printStackTrace();return;}
  }
  
}
