/*
 * AbstractDataFrameTreeNode.java
 *
 * Created on July 26, 2003, 7:31 PM
 */

package edu.byu.deg.dataframe;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;


/**
 *
 * @author  Alan
 */
public abstract class AbstractDataFrameTreeNode extends DefaultMutableTreeNode {
  
  protected DefaultTreeModel treeModel;
  protected boolean isNodeSetChanging = false;
  
  /** Creates a new instance of AbstractDataFrameTreeNode */
  public AbstractDataFrameTreeNode(Object obj, DefaultTreeModel model) {
    super(obj);
    treeModel = model;
  } // constructor
  
  public void setModel(DefaultTreeModel model) {
    treeModel = model;
  } // method setModel
  
  public DefaultTreeModel getModel() {
    return treeModel;
  } // method getModel
  
  public void insert(MutableTreeNode newChild, int childIndex) {
    super.insert(newChild, childIndex);
    if (isNodeSetChanging) return;
    nodeAdded(newChild);
  } // method insert
  
  public void remove(MutableTreeNode aChild) {
    super.remove(aChild);
  } // method remove(MutableTreeNode)
  
  public void remove(int childIndex) {
    TreeNode child = getChildAt(childIndex);
    super.remove(childIndex);
    if (isNodeSetChanging) return;
    nodeRemoved(child);
  } // method remove(int)
  
  public abstract void nodeAdded(TreeNode child);
  
  public abstract void nodeRemoved(TreeNode child);
  
}
