/*
 * KeywordPhraseListNode.java
 *
 * Created on July 19, 2003, 4:38 PM
 */

package edu.byu.deg.dataframe;

import edu.byu.deg.osmx.binding.KeywordPhraseType;
import java.util.List;
import java.util.Iterator;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;


/**
 *
 * @author  Alan
 */
public class KeywordPhraseListNode extends AbstractDataFrameTreeNode {
  
  protected List keywordPhraseList;
  
  /** Creates a new instance of KeywordPhraseListNode */
  public KeywordPhraseListNode(List kpl, DefaultTreeModel model) {
    super(kpl, model);
    keywordPhraseList = kpl;
    if (keywordPhraseList != null && keywordPhraseList != null) {
      for (Iterator i = keywordPhraseList.iterator(); i.hasNext();) {
        KeywordPhraseType phrase = (KeywordPhraseType) i.next();
        this.add(new KeywordPhraseNode(phrase, treeModel));
      }
    }
  } // constructor
  
  public String toString() {
    return "Keyword Phrases";
  } // method toString
  
  public List getKeywordPhraseList() {
    return keywordPhraseList;
  } // method getKeywordPhraseList
  
  public void setUserObject(Object userObj) {
    if (userObj instanceof List) {
      super.setUserObject(userObj);
      keywordPhraseList = (List) userObj;
    }
  } // method setUserObject
  
  public void add(MutableTreeNode newChild) {
    if (!(newChild instanceof KeywordPhraseNode)) return;
    super.add(newChild);
  }
  
  public void nodeAdded(TreeNode child) {
    isNodeSetChanging = true;
    KeywordPhraseNode newChild = (KeywordPhraseNode) child;
    if (newChild != null) {
      if (!keywordPhraseList.contains(newChild.getKeywordPhrase())) {
        keywordPhraseList.add(newChild.getKeywordPhrase());
      }
    }
    if (treeModel != null) treeModel.insertNodeInto(newChild, this, this.getChildCount() - 1);
    isNodeSetChanging = false;
  }
  
  public void nodeRemoved(TreeNode child) {
    isNodeSetChanging = true;
    KeywordPhraseNode newChild = (KeywordPhraseNode) child;
    if (keywordPhraseList != null) {
      keywordPhraseList.remove(newChild.getKeywordPhrase());
    }
    if (treeModel != null) treeModel.nodeStructureChanged(this);
    isNodeSetChanging = false;
  }
  
}
