 /**
  * <p>Lexicon Dictionary File Editor : </p>
  * <p>To be called by LexiconEditorPlanel:</p>
  * @Zonghui
  * @version 1.0
  */



package edu.byu.deg.dataframe;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;
import javax.swing.event.*;

public class LexiconDictEditor extends  JPanel{//JFrame


  JToolBar toolBar = new JToolBar();
  JButton jButton2 = new JButton();
  ImageIcon image2;
  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();
//  JMenuItem jMenuItem1 = new JMenuItem();
//  JMenuItem jMenuItem2 = new JMenuItem();
//  JMenuItem jMenuItem3 = new JMenuItem();
//  JMenuItem jMenuItem4 = new JMenuItem();
//  JMenu jMenu1 = new JMenu();
//  JMenuItem jMenuItem6 = new JMenuItem();
//  JMenuItem jMenuItem7 = new JMenuItem();
  JFileChooser jFileChooser1 = new JFileChooser();
  String currFileName = null;  // Full path with filename. null means new/untitled.
  boolean dirty = false;
  Document document1;
  JTextField tfFilename = new JTextField();
//public JCheckBox jCheckBox1 = new JCheckBox();

  //Construct the frame
  public LexiconDictEditor() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    image2 = new ImageIcon(getClass().getResource("images/save.gif"));
    document1 = jTextArea1.getDocument();
    this.setLayout(borderLayout1);
    jButton2.setIcon(image2);
    jButton2.addActionListener(new TextEditFrame_jButton2_actionAdapter(this));
    jButton2.setToolTipText("Save File");
    jTextArea1.setLineWrap(true);
    jTextArea1.setWrapStyleWord(true);
    jTextArea1.setBackground(Color.white);
    document1.addDocumentListener(new TextEditFrame_document1_documentAdapter(this));

    jButton2.setEnabled(false);
    toolBar.add(jButton2);
    tfFilename.setEditable(false);
    tfFilename.setFont(new java.awt.Font("Dialog", 1, 15));
    toolBar.add(tfFilename);

    this.add(toolBar, BorderLayout.NORTH);

    this.add(jScrollPane1, BorderLayout.CENTER);
    jTextArea1.setEditable(false);
    jScrollPane1.getViewport().add(jTextArea1, null);

  }



  // Handle the File|Open menu or button, invoking okToAbandon and openFile
  // as needed.
  void fileOpen() {
    if (!okToAbandon()) {
      return;
    }
    // Use the OPEN version of the dialog, test return for Approve/Cancel
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
      // Call openFile to attempt to load the text from file into TextArea
      openFile(jFileChooser1.getSelectedFile().getPath());
    }
    this.repaint();
  }

  // Open named file; read text from file into jTextArea1; report to statusBar.
 public  void openFile(String fileName)  {
    try
    {
      // Open a file of the given name.
      File file = new File(fileName);

      // Cache the currently opened filename for use at save time...
      this.currFileName = fileName;

      // Get the size of the opened file.
      int size = (int)file.length();

      // Set to zero a counter for counting the number of
      // characters that have been read from the file.
      int chars_read = 0;

      // Create an input reader based on the file, so we can read its data.
      // FileReader handles international character encoding conversions.
      FileReader in = new FileReader(file);

      // Create a character array of the size of the file,
      // to use as a data buffer, into which we will read
      // the text data.
      char[] data = new char[size];

      // Read all available characters into the buffer.
      while(in.ready()) {
        // Increment the count for each character read,
        // and accumulate them in the data buffer.
        chars_read += in.read(data, chars_read, size - chars_read);
      }
      in.close();

      // Create a temporary string containing the data,
      // and set the string into the JTextArea.
      jTextArea1.setText(new String(data, 0, chars_read));


      // ...and mark the edit session as being clean
      this.dirty = false;


      jTextArea1.setCaretPosition(0);

    }
    catch (IOException e)
    { /* do nothing */ /* REVISIT: handle differently? */ }
  }

    // Save current file; handle not yet having a filename; report to statusBar.
  boolean saveFile() {

    // Handle the case where we don't have a file name yet.
/*    if (currFileName == null) {
      return saveAsFile();
    }*/

    try
    {
      File file;
      // Open a file of the current name.
//      if (currFileName != null)
         file = new File (currFileName);
//      else
//          file =  new File (tfFilename.getText());

      // Create an output writer that will write to that file.
      // FileWriter handles international characters encoding conversions.
      FileWriter out = new FileWriter(file);
      String text = jTextArea1.getText();
      out.write(text);
      out.close();
      this.dirty = false;


      return true;
    }
    catch (IOException e) {
        /* do nothing */ /* REVISIT: handle differently? */
    }
    return false;
  }


  // Check if file is dirty.
  // If so get user to make a "Save? yes/no" decision.
  boolean okToAbandon() {
    if (!dirty) {
      return true;
    }
    int value =  JOptionPane.showConfirmDialog(this, tfFilename.getText()+ " changed, save changes?",
                                         "Text Edit", JOptionPane.YES_NO_OPTION) ;

    switch (value) {
       case JOptionPane.YES_OPTION:
         // yes, please save changes
         return saveFile();
       case JOptionPane.NO_OPTION:
         // no, abandon edits
         // i.e. return true without saving
         return true;
       case JOptionPane.CANCEL_OPTION:
       default:
         // cancel
         return false;
    }
  }




  //File | Exit action performed
/*  public void fileExit_actionPerformed(ActionEvent e) {
    if (okToAbandon()) {
      System.exit(0);
    }
  }*/


  //Overridden so we can exit when window is closed
/*  protected void processWindowEvent(WindowEvent e) {

    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }*/


/*  void jMenuItem6_actionPerformed(ActionEvent e) {
    // Handle the "Foreground Color" menu item
    Color color = JColorChooser.showDialog(this,"Foreground Color",jTextArea1.getForeground());
    if (color != null) {
      jTextArea1.setForeground(color);
    }
    //repaints menu after item is selected
    this.repaint();
  }

  void jMenuItem7_actionPerformed(ActionEvent e) {
    // Handle the "Background Color" menu item
    Color color = JColorChooser.showDialog(this,"Background Color",jTextArea1.getBackground());
    if (color != null) {
     jTextArea1.setBackground(color);
    }
    //repaints menu after item is selected
    this.repaint();
  }*/


/*  void jMenuItem3_actionPerformed(ActionEvent e) {
    //Handle the File|Save menu item.
    saveFile();
  }*/


  void jButton2_actionPerformed(ActionEvent e) {
    //Handle tool bar Save button
    saveFile();
  }


  void document1_changedUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;

    }
  }

  void document1_insertUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;

    }
  }

  void document1_removeUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;

    }
  }
}

/*class TextEditFrame_menuFileExit_ActionAdapter implements ActionListener {
  LexiconDictEditor adaptee;

  TextEditFrame_menuFileExit_ActionAdapter(LexiconDictEditor adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.fileExit_actionPerformed(e);
  }
}*/

/*class TextEditFrame_menuHelpAbout_ActionAdapter implements ActionListener {
  LexiconDictEditor adaptee;

  TextEditFrame_menuHelpAbout_ActionAdapter(LexiconDictEditor adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.helpAbout_actionPerformed(e);
  }
}

class TextEditFrame_jMenuItem6_actionAdapter implements java.awt.event.ActionListener {
  LexiconDictEditor adaptee;

  TextEditFrame_jMenuItem6_actionAdapter(LexiconDictEditor adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem6_actionPerformed(e);
  }
}

class TextEditFrame_jMenuItem7_actionAdapter implements java.awt.event.ActionListener {
  LexiconDictEditor adaptee;

  TextEditFrame_jMenuItem7_actionAdapter(LexiconDictEditor adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem7_actionPerformed(e);
  }
}*/



/*class TextEditFrame_jMenuItem3_actionAdapter implements java.awt.event.ActionListener {
  LexiconDictEditor adaptee;

  TextEditFrame_jMenuItem3_actionAdapter(LexiconDictEditor adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem3_actionPerformed(e);
  }
}*/


class TextEditFrame_jButton2_actionAdapter implements java.awt.event.ActionListener {
  LexiconDictEditor adaptee;

  TextEditFrame_jButton2_actionAdapter(LexiconDictEditor adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}


class TextEditFrame_document1_documentAdapter implements javax.swing.event.DocumentListener {
  LexiconDictEditor adaptee;

  TextEditFrame_document1_documentAdapter(LexiconDictEditor adaptee) {
    this.adaptee = adaptee;
  }

  public void changedUpdate(DocumentEvent e) {
    adaptee.document1_changedUpdate(e);
  }

  public void insertUpdate(DocumentEvent e) {
    adaptee.document1_insertUpdate(e);
  }

  public void removeUpdate(DocumentEvent e) {
    adaptee.document1_removeUpdate(e);
  }
}
