package edu.byu.deg.dataframe;

import java.awt.*;
import javax.swing.*;

import edu.byu.deg.osmx.OSMXDocument;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import java.awt.Dimension;
import java.net.URL;
import edu.byu.deg.osmx.binding.*;//Z.H
import java.util.Iterator;//Z.H
import java.util.Vector;
import edu.byu.deg.osmx.binding.impl.*;//Z.H
import java.awt.event.*;//Z.H
import javax.swing.event.*;
import javax.swing.border.TitledBorder;
import java.lang.Boolean;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableCellEditor;
import java.io.File;
import javax.swing.JFileChooser;
/**
 * <p>Lexicon Editor Panel: </p>
 * <p>initialize the lexicon editor panel for the tab in dataframe editor window:</p>
 * @Zonghui
 * @version 1.0
 */

public class LexiconEditorPanel extends JPanel implements ActionListener,FocusListener{
	
	private OSMXDocument ontologyDoc;
	//  private GridBagConstraints c = new GridBagConstraints();
	private JButton btnAdd = new JButton();
	private JButton btnDelete = new JButton();
	private JButton btnLexiconFileSelect;
	private JTable lexiconTable;
	private JScrollPane scrollpane;
	private OSMType   m_rootType;
	private defaultTableModel lexiconTableModel;
	private Vector columnNames = new Vector();
	private Vector lexicondata = new Vector();
	private BorderLayout mainLayout = new BorderLayout();
	private LexiconType dellexicon;
	private LexiconImpl newlexicon;
	private LexiconDictEditor lde;
	private JSplitPane splitPane;
	private JPanel panela = new JPanel();
	private JPanel panelb = new JPanel();
	
	public LexiconEditorPanel() {
		try {
			jbInit();
		}
		catch(Exception ex) {
			ex.printStackTrace();
		}
	}
	public LexiconEditorPanel(OSMXDocument mydoc) {
		ontologyDoc = mydoc;
		try {
			jbInit();
		}
		catch(Exception ex) {
			ex.printStackTrace();
		}
	}
	
	void jbInit() throws Exception {
		//Initialize a button for the Select File button in the lexicon table
		btnLexiconFileSelect = new JButton(new ImageIcon(getClass().getResource("images/open.gif")));
		
		btnLexiconFileSelect.setMargin(new Insets(1,1,1,1));
		//    Dimension d = new Dimension(2,2);
		//    btnLexiconFileSelect.setPreferredSize(d);
		
		this.setLayout(mainLayout);
		
		setupLexiconTablePanel();
		setupOpenFilePanel();
		splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, panela, panelb);
		splitPane.setOneTouchExpandable(true);
		
		this.add(splitPane, BorderLayout.CENTER);
	}
	
	private void setupLexiconTablePanel (){
		TitledBorder border = new TitledBorder("Lexicon Phrase");
		border.setTitlePosition(TitledBorder.TOP);
		border.setTitleJustification(TitledBorder.LEFT);
		panela.setBorder(border);
		
		//Intialize the data for the Tablemodel
		tableLoadData(ontologyDoc);
		
		lexiconTableModel = new defaultTableModel(lexicondata,columnNames);
		lexiconTable = new JTable(lexiconTableModel);
		// set the "select" option of the table as the single
		lexiconTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		//add TableModelListenter on the Tablemodel to detect the change of the table
		lexiconTableModel.addTableModelListener(new myTableModelListener());
		
		//"hide" the column "invisible lexicon"
		lexiconTable.getColumnModel().getColumn(5).setMaxWidth(0);
		lexiconTable.getColumnModel().getColumn(5).setMinWidth(0);
		lexiconTable.getColumnModel().getColumn(5).setPreferredWidth(0);
		//set the size of the column OPEN FILE BUTTON
		lexiconTable.getColumnModel().getColumn(2).setMaxWidth(20);
		lexiconTable.getColumnModel().getColumn(2).setMinWidth(20);
		lexiconTable.getColumnModel().getColumn(2).setPreferredWidth(20);
		
		// Create the scrollPane to add the table into it
		scrollpane = new JScrollPane(lexiconTable);
		
		//Set up renderer and editor for the Button column.
		lexiconTable.setDefaultRenderer(JButton.class, new ButtonRenderer());
		lexiconTable.setDefaultEditor(JButton.class,new ButtonEditor());
		
		//Initialize the Add and Delete button of the lexicon table
		Class thisClass = this.getClass();
		URL addIconURL = thisClass.getResource("images/add.gif");
		URL removeIconURL = thisClass.getResource("images/remove.gif");
		btnAdd.setText(null);
		btnDelete.setText(null);
		btnAdd.setIcon(new ImageIcon(addIconURL));
		btnDelete.setIcon(new ImageIcon(removeIconURL));
		Dimension minButtonSize = new Dimension(20, 20);
		Dimension maxButtonSize = new Dimension(24, 24);
		btnAdd.setMinimumSize(minButtonSize);
		btnDelete.setMinimumSize(minButtonSize);
		btnAdd.setMaximumSize(maxButtonSize);
		btnDelete.setMaximumSize(maxButtonSize);
		btnAdd.setToolTipText("Add new Lexicon");
		btnDelete.setToolTipText("Delete selected Lexicon");
		btnAdd.setActionCommand("Add Lexicon");
		btnAdd.addActionListener(this);
		btnDelete.setActionCommand("Delete Lexicon");
		btnDelete.addActionListener(this);
		//add a new checkkbox for open the dictionary file
		//     JCheckBox ckbOpen = new JCheckBox();
		JPanel panelaSouth = new JPanel();
		panelaSouth.setPreferredSize(new Dimension(90,30));
		//     BorderLayout bpanelaSouth = new BorderLayout();
		//     panelaSouth.setLayout(bpanelaSouth);
		panelaSouth.add(btnAdd);
		panelaSouth.add(btnDelete);
		
		
		BorderLayout bpanela = new BorderLayout();
		panela.setLayout(bpanela);
		//Add the scroll pane to this panel.
		panela.add(scrollpane, BorderLayout.CENTER);
		panela.add(panelaSouth,BorderLayout.SOUTH);
		
		//    this.add(panela, BorderLayout.CENTER);
		
		lexiconTable.addFocusListener(this);
		ListSelectionModel rowSM = lexiconTable.getSelectionModel();
		rowSM.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				//Ignore extra messages.
				if (e.getValueIsAdjusting())
					return;
				ListSelectionModel lsm = (ListSelectionModel)e.getSource();
				if (!lsm.isSelectionEmpty()) {
					int selectedRow = lsm.getMinSelectionIndex();
					autocheckdicfile(selectedRow);
				}
			}
		});
		
	}
	private void setupOpenFilePanel (){
		TitledBorder border = new TitledBorder("Dictionary File");
		border.setTitlePosition(TitledBorder.TOP);
		border.setTitleJustification(TitledBorder.LEFT);
		panelb.setBorder(border);
		panelb.setPreferredSize(new Dimension(300, 37));
		BorderLayout bpanelb = new BorderLayout();
		panelb.setLayout(bpanelb);
		lde = new LexiconDictEditor();
		panelb.add(lde,BorderLayout.CENTER);
		//    this.add(panelb, BorderLayout.EAST);
	}
	public void actionPerformed (ActionEvent e) {
		String cmd = e.getActionCommand();
		if (cmd == "Add Lexicon") {
			newlexicon = new LexiconImpl();
			newlexicon.setLabel("");
			newlexicon.setUri("");
			newlexicon.setCaseSensitive(false);
			newlexicon.setDelimiters("");
			
			Vector v = new Vector();
			v.addElement("");
			v.addElement("");
			v.addElement(btnLexiconFileSelect);
			v.addElement(new Boolean(false));
			v.addElement("");
			v.addElement(newlexicon);
			lexiconTableModel.addRow(v);
			
			//set dictionary file be editable
			lde.jButton2.setEnabled(true);
			lde.jTextArea1.setEditable(true);
			
		}
		if (cmd == "Delete Lexicon") {
			//save the macro before it be deleted
			dellexicon = (LexiconType)lexiconTableModel.getValueAt(lexiconTable.getSelectedRow(),5);
			lexiconTableModel.removeRow(lexiconTable.getSelectedRow());
		}
	}
	
	
	
	public void tableLoadData (OSMXDocument doc) {
		//Column define
		columnNames.addElement("Lexicon Label");
		columnNames.addElement("Filename");
		columnNames.addElement("...");
		columnNames.addElement("Case Sensitive");
		columnNames.addElement("Separators");
		columnNames.addElement("invisibleLexicon");
		
		OSMXDocument m_doc = doc;
		m_rootType = m_doc.getModelRoot();
		java.util.List l = m_rootType.getAllModelElements();
		Iterator it = l.iterator();
		Object node = it.next();
		while (node != null) {
			if (node instanceof LexiconType)
			{ loadvalue(node);
			}
			if (it.hasNext())
				node = it.next();
			else node = null;
		}
	}
	
	public void loadvalue(Object value) {
		LexiconType m_lexicon = (LexiconType)value;
		String label =m_lexicon.getLabel();
		String filename = m_lexicon.getUri();//file name
		boolean casesen = m_lexicon.isCaseSensitive();
		String separators = m_lexicon.getDelimiters();
		if (separators == null)
			separators = "";
		
		Vector row = new Vector();
		//make a row
		row.addElement(label);
		row.addElement(filename);
		row.addElement(btnLexiconFileSelect); // the "select file" button for the filename column
		if (casesen == true)
			row.addElement(new Boolean(true));
		else
			row.addElement(new Boolean(false));
		row.addElement(separators);
		row.addElement(m_lexicon);
		//add the row to the table
		lexicondata.addElement(row);
	}
	
	public void focusGained(FocusEvent e)
	{//System.out.println("Get focus");
	}
	
	public void focusLost(FocusEvent e){
		//Update data before Lost focus
		/*   int row = lexiconTable.getSelectedRow();
		 int column = lexiconTable.getSelectedColumn();
		 TableModelEvent  my_e = new TableModelEvent(lexiconTableModel,row, row, column);
		 myTableModelListener mtl = new myTableModelListener();
		 mtl.tableChanged(my_e);
		 
		 //    DefaultTableModel model = (DefaultTableModel) e.getSource();
		  LexiconType lt = (LexiconType) lexiconTable.getValueAt(row, 5);
		  int i = ontologyDoc.getModelRoot().getAllModelElements().indexOf(lt);
		  if (column == 0)
		  {        String temp = (String) lexiconTable.getValueAt(row, column);
		  String temp2 =  (String) lexiconTableModel.getValueAt(row, column);
		  lt.setLabel((String) lexiconTable.getValueAt(row, column));
		  }
		  else if (column == 1)
		  {lt.setUri((String)lexiconTable.getValueAt(row, column));
		  //View the dictionary file
		   String filename = (String) lexiconTableModel.getValueAt(row, 1);
		   if (filename.equals("") == false) {
		   ExtFileChooser exfch = new ExtFileChooser();
		   String filepath = removeFileNameFromPath(exfch.m_lastDirectory) +
		   (String) lexiconTable.getValueAt(row, 1);
		   lde.openFile(filepath);
		   lde.jTextArea1.setEditable(true);
		   lde.jButton2.setEnabled(true);
		   lde.tfFilename.setText(filename);
		   }
		   }
		   else if (column == 2) {
		   }
		   else if(column == 3) {
		   Boolean b = (Boolean)lexiconTable.getValueAt(row, column);
		   lt.setCaseSensitive(b.booleanValue());
		   }
		   else if (column == 4) {
		   lt.setDelimiters((String) lexiconTable.getValueAt(row, column));
		   }
		   
		   ontologyDoc.getModelRoot().getAllModelElements().set(i,lt);
		   lexiconTableModel.setValueAt(lt,row,5);*/
		
		//Check the dictionary filename and if it qualify it shouldu
		
	}
	
	private void autocheckdicfile (int selectedrow){
		//Check whether the dictionary file changed
		if (lde.tfFilename.getText().equals("") == false)
			lde.okToAbandon();
		
		lde.jTextArea1.setText("");
		
		if ((String)lexiconTableModel.getValueAt(selectedrow,1) == null) {
			lde.jTextArea1.setEditable(false);
			lde.jButton2.setEnabled(false);
			lde.tfFilename.setText("");
		}
		else
		{
			String filename = (String) lexiconTableModel.getValueAt(selectedrow, 1);
			if (filename.equals("") == false) {
				//        ExtFileChooser exfch = new ExtFileChooser();
				String filepath = (String) lexiconTable.getValueAt(selectedrow, 1);
				lde.openFile(filepath);
				lde.jTextArea1.setEditable(true);
				lde.jButton2.setEnabled(true);
				lde.tfFilename.setText(filename);
			}
			else {
				lde.jTextArea1.setEditable(false);
				lde.jButton2.setEnabled(false);
				lde.tfFilename.setText("");
			}
		}
	}
	public String  removeFileNameFromPath(String  path){
		int idx = path.lastIndexOf("\\");
		return path.substring(0, idx+1);
	}
	
	public   class defaultTableModel  extends DefaultTableModel {
		public defaultTableModel(Vector data, Vector columnNames) {
			setDataVector(data, columnNames);
		}
		/*
		 * JTable uses this method to determine the default renderer/
		 * editor for each cell.  If we didn't implement this method,
		 * then the last column would contain text ("true"/"false"),
		 * rather than a check box.
		 */
		public Class getColumnClass(int c) {
			return getValueAt(0, c).getClass();
			
		}
	}
	public class myTableModelListener implements TableModelListener{
		public void tableChanged(TableModelEvent e) {
			int row = e.getFirstRow();
			int column = e.getColumn();
			if (column == 5) return;//the change at column "invisible lexicon" should quit
			//save the UPDATE of the macro into the ontologyDoc
			if (e.getType() == 0) {
				DefaultTableModel model = (DefaultTableModel) e.getSource();
				LexiconType lt = (LexiconType) model.getValueAt(row, 5);
				int i = ontologyDoc.getModelRoot().getAllModelElements().indexOf(lt);
				if (column == 0)
					lt.setLabel((String) model.getValueAt(row, column));
				else if (column == 1)
				{lt.setUri((String)model.getValueAt(row, column));
				//View the dictionary file
				String filename = (String) lexiconTableModel.getValueAt(row, 1);
				if (filename.equals("") == false) {
					//              ExtFileChooser exfch = new ExtFileChooser();
					String filepath = (String) lexiconTable.getValueAt(row, 1);
					lde.openFile(filepath);
					lde.jTextArea1.setEditable(true);
					lde.jButton2.setEnabled(true);
					lde.tfFilename.setText(filename);
				}
				}
				else if (column == 2) { /* do nothing */ }
				else if(column == 3) {
					Boolean b = (Boolean)model.getValueAt(row, column);
					lt.setCaseSensitive(b.booleanValue());
				}
				else if (column == 4) {
					lt.setDelimiters((String) model.getValueAt(row, column));
				}
				
				ontologyDoc.getModelRoot().getAllModelElements().set(i,lt);
				lexiconTableModel.setValueAt(lt,row,5);
			}
			//save the DELETE of the macro into the ontologyDoc
			if (e.getType() == -1) {
				ontologyDoc.getModelRoot().getAllModelElements().remove(dellexicon);
				//         System.out.println("delete the row");
			}
			// save the INSERT of the macro into the ontologyDoc
			if (e.getType() == 1){
				ontologyDoc.getModelRoot().getAllModelElements().add(newlexicon);
			}
		}
	}
	public class ButtonRenderer extends JButton
	implements TableCellRenderer {
		//     Border unselectedBorder = null;
		//     Border selectedBorder = null;
		boolean isBordered = true;
		
		public ButtonRenderer() {
			//         this.isBordered = isBordered;
			setOpaque(false); //MUST do this for background to show up.
		}
		
		public Component getTableCellRendererComponent(
				JTable table, Object button,
				boolean isSelected, boolean hasFocus,
				int row, int column) {
			
			return btnLexiconFileSelect;
		}
	}
	public class ButtonEditor extends AbstractCellEditor
	implements TableCellEditor,
	ActionListener {
		//     private int row=row;
		public ButtonEditor() {
			btnLexiconFileSelect.setActionCommand("select a file");
			btnLexiconFileSelect.addActionListener(this);
		}
		
		public void actionPerformed(ActionEvent e) {
			if (e.getActionCommand()=="select a file"){
				
				// change the source used for the text viewer
				JFileChooser chooser = new JFileChooser();
				chooser.setFileFilter(chooser.getAcceptAllFileFilter());
				
				//          int returnVal = chooser.showOpenDialog(btnLexiconFileSelect);
				int returnVal = chooser.showOpenDialog(lexiconTable);
				if (returnVal == JFileChooser.APPROVE_OPTION)
				{
					File file  = chooser.getSelectedFile();
					lexiconTable.setValueAt(file.getName(),lexiconTable.getSelectedRow(),1);
					/*            m_lexiconFilename.setText(file.getPath());
					 LexiconType lexiconType = (LexiconType)m_lexiconLabelCombo.getSelectedItem();
					 if (lexiconType != null)
					 lexiconType.setUri(file.getName());*/
				}
			}
		}
		
		//Implement the one CellEditor method that AbstractCellEditor doesn't.
		public Object getCellEditorValue() {
			return btnLexiconFileSelect;
		}
		
		//Implement the one method defined by TableCellEditor.
		public Component getTableCellEditorComponent(JTable table,
				Object value,
				boolean isSelected,
				int row,
				int column) {
			return btnLexiconFileSelect;
		}
	}
	
	
}