package edu.byu.deg.dataframe;


import edu.byu.deg.osmx.OSMXDocument;

import java.awt.*;
import javax.swing.*;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import java.awt.Color;
import java.awt.Dimension;
import java.net.URL;
import edu.byu.deg.osmx.binding.*;//Z.H
import java.util.Iterator;//Z.H
import java.util.Vector;
import edu.byu.deg.osmx.binding.impl.*;//Z.H
import java.awt.event.*;//Z.H
import javax.swing.event.*;
//import java.lang.*;

/**
 * <p>Macro Editor Panel: </p>
 * <p>initialize the macro editor panel for the tab in dataframe editor window: </p>
 * @author Zonghui
 * @version 1.0
 */

public class MacroEditorPanel extends JPanel implements ActionListener{
   private JButton btnAdd = new JButton();
   private JButton btnDelete = new JButton();
   private JTable macroTable;
   private JScrollPane scrollpane;
   private OSMXDocument ontologyDoc;
   private OSMType   m_rootType;
   private defaultTableModel macroTableModel;
   private Vector columnNames = new Vector();
   private Vector macrodata = new Vector();
   private MacroType delmacro;
   private  MacroImpl newmacro;
   private BorderLayout mainLayout = new BorderLayout();

  public MacroEditorPanel() {

   try {
      jbInit();//initialize the button
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
  public MacroEditorPanel(OSMXDocument mydoc) {
    ontologyDoc = mydoc;
    try {
      jbInit();//initialize the button
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(mainLayout);
    //Intialize the data for the Tablemodel
    tableLoadData(ontologyDoc);

    macroTableModel = new defaultTableModel(macrodata,columnNames);

    macroTable = new JTable(macroTableModel);
    // set the "select" option of the table as the single
    macroTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    //add TableModelListenter on the Tablemodel to detect the change of the table
    macroTableModel.addTableModelListener(new myTableModelListener());

    //"hide" the column "invisible macro"
    macroTable.getColumnModel().getColumn(3).setMaxWidth(0);
    macroTable.getColumnModel().getColumn(3).setMinWidth(0);
    macroTable.getColumnModel().getColumn(3).setPreferredWidth(0);
    //set the column width of the Color column
    macroTable.getColumnModel().getColumn(2).setMaxWidth(40);
    macroTable.getColumnModel().getColumn(2).setMinWidth(40);
    macroTable.getColumnModel().getColumn(2).setPreferredWidth(40);


   // Create the scrollPane to add the table into it
     scrollpane = new JScrollPane(macroTable);

   //Set up renderer and editor for the Color column.
   macroTable.setDefaultRenderer(Color.class, new MacroColorRenderer(true));
   macroTable.setDefaultEditor(Color.class, new MacroColorEditor());

   //Add the scroll pane to this panel.
    this.add(scrollpane, BorderLayout.CENTER);

    //initialize the 'add' and 'delete' button
    Class thisClass = this.getClass();
    URL addIconURL = thisClass.getResource("images/add.gif");
    URL removeIconURL = thisClass.getResource("images/remove.gif");
    btnAdd.setText(null);
    btnDelete.setText(null);
    btnAdd.setIcon(new ImageIcon(addIconURL));
    btnDelete.setIcon(new ImageIcon(removeIconURL));
    Dimension minButtonSize = new Dimension(20, 20);
    Dimension maxButtonSize = new Dimension(24, 24);
    btnAdd.setMinimumSize(minButtonSize);
    btnDelete.setMinimumSize(minButtonSize);
    btnAdd.setMaximumSize(maxButtonSize);
    btnDelete.setMaximumSize(maxButtonSize);
    btnAdd.setToolTipText("Add new Macro");
    btnDelete.setToolTipText("Delete selected Macro");
    btnAdd.setActionCommand("Add Macro");
    btnAdd.addActionListener(this);
    btnDelete.setActionCommand("Delete Macro");
    btnDelete.addActionListener(this);
    JPanel btnPanel = new JPanel();

    btnPanel.add(btnAdd,null);
    btnPanel.add(btnDelete,null);

    this.add(btnPanel,BorderLayout.SOUTH);

  }

  public void actionPerformed (ActionEvent e) {
    String cmd = e.getActionCommand();
    if (cmd == "Add Macro") {
      newmacro = new MacroImpl();
      newmacro.setLabel("");
      newmacro.setValue("");
//      newmacro.setColor("ffffffff");
      newmacro.setColor(Color.white);

      Vector v = new Vector();
      v.addElement("");
      v.addElement("");
      v.addElement(Color.white);
      v.addElement(newmacro);
      macroTableModel.addRow(v);

    }
    if (cmd == "Delete Macro") {
      //save the macro before it be deleted
      delmacro = (MacroType)macroTableModel.getValueAt(macroTable.getSelectedRow(),3);
      macroTableModel.removeRow(macroTable.getSelectedRow());
    }

  }

  public void tableLoadData (OSMXDocument doc) {
  //Column define
  columnNames.addElement("Label");//{"Label","Expression","Color"}
  columnNames.addElement("Expression");
  columnNames.addElement("Color");
  columnNames.addElement("invisibleMacro");

  OSMXDocument m_doc = doc;
  m_rootType = m_doc.getModelRoot();
  java.util.List l = m_rootType.getAllModelElements();
  Iterator it = l.iterator();
  Object node = it.next();
  while (node != null) {
    if (node instanceof MacroType)
      loadvalue(node);
    if (it.hasNext())
         node = it.next();
    else node = null;
  }
}

public void loadvalue(Object value) {
    MacroType m_macro = (MacroType)value;
    String label =m_macro.getLabel();
    String expr = m_macro.getValue();
//    String val = m_macro.getColor();

    Color color = Color.white;
    color =  m_macro.getColor();

    // Parser cannot handle full eight character string
    // even though the toHexString produced it.
    // Since we only need the six rightmost chars
    // we take a substring.
/*    if (val !=null)
    {  if (val.length() >= 8)
              val = val.substring(2);
      try
       {    int rgb = Integer.parseInt(val, 16);
            color = new Color(rgb);
        }
     catch (NumberFormatException e)
       { System.out.println(e);}
    };*/

    Vector row = new Vector();
    //make a row
    row.addElement(label);
    row.addElement(expr);
    row.addElement(color);
    row.addElement(m_macro);
    //add the row to the table
    macrodata.addElement(row);
}


  public   class defaultTableModel  extends DefaultTableModel {
    public defaultTableModel(Vector data, Vector columnNames) {
       setDataVector(data, columnNames);
    }
     /*
      * JTable uses this method to determine the default renderer/
      * editor for each cell.  If we didn't implement this method,
      * then the last column would contain text ("true"/"false"),
      * rather than a check box.
      */
     public Class getColumnClass(int c) {
       return getValueAt(0, c).getClass();
     }
 }
 public class myTableModelListener implements TableModelListener{
   public void tableChanged(TableModelEvent e) {
     int row = e.getFirstRow();
     int column = e.getColumn();
     if (column == 3 ) return;//the change at column "invisible macro" should quit
     //save the UPDATE of the macro into the ontologyDoc
     if (e.getType() == 0) {
         DefaultTableModel model = (DefaultTableModel) e.getSource();
         MacroType mt = (MacroType) model.getValueAt(row, 3);
        int i = ontologyDoc.getModelRoot().getAllModelElements().indexOf(mt);
        if (column == 0)
            mt.setLabel((String) model.getValueAt(row, column));
        else if (column == 1)
            mt.setValue( (String) model.getValueAt(row, column));
        else if (column == 2) {
          //change the Color into String
          //int rgb = color.getRGB();
           Color c = (Color)model.getValueAt(row,column);
//          int rgb = c.getRGB();
//            String val = Integer.toHexString(rgb);
//            mt.setColor(val);
            mt.setColor(c);
        }

         ontologyDoc.getModelRoot().getAllModelElements().set(i,mt);
         macroTableModel.setValueAt(mt,row,3);
     }
     //save the DELETE of the macro into the ontologyDoc
     if (e.getType() == -1) {
         ontologyDoc.getModelRoot().getAllModelElements().remove(delmacro);
         System.out.println("delete the row");
     }
     // save the INSERT of the macro into the ontologyDoc
     if (e.getType() == 1){
         ontologyDoc.getModelRoot().getAllModelElements().add(newmacro);
     }
   }
 }
}


