/*
 * MethodListNode.java
 *
 * Created on July 19, 2003, 4:49 PM
 */

package edu.byu.deg.dataframe;

import edu.byu.deg.osmx.binding.MethodType;
import java.util.List;
import java.util.Iterator;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;


/**
 *
 * @author  Alan
 */
public class MethodListNode extends AbstractDataFrameTreeNode {
  
  protected List methodList;
  
  /** Creates a new instance of MethodListNode */
  public MethodListNode(List ml, DefaultTreeModel model) {
    super(ml, model);
    methodList = ml;
    if (methodList != null && methodList != null) {
      for (Iterator i = methodList.iterator(); i.hasNext();) {
        MethodType mthd = (MethodType) i.next();
        this.add(new MethodNode(mthd, treeModel));
      }
    }
  } // constructor
  
  public String toString() {
    return "Methods";
  } // method toString
  
  public List getMethodList() {
    return methodList;
  } // method getMethodList
  
  public void setUserObject(Object userObject) {
    if (userObject instanceof List) {
      super.setUserObject(userObject);
      methodList = (List) userObject;
    }
  }
  
  public void nodeAdded(TreeNode child) {
    isNodeSetChanging = true;
    MethodNode newChild = (MethodNode) child;
    if (newChild != null) {
      if (!methodList.contains(newChild.getMethod())) {
        methodList.add(newChild.getMethod());
      }
    }
    if (treeModel != null) treeModel.insertNodeInto(newChild, this, this.getChildCount() - 1);
    isNodeSetChanging = false;
  }
  
  public void nodeRemoved(TreeNode child) {
    isNodeSetChanging = true;
    MethodNode newChild = (MethodNode) child;
    if (methodList != null) {
      methodList.remove(newChild.getMethod());
    }
    if (treeModel != null) treeModel.nodeStructureChanged(this);
    isNodeSetChanging = false;
  }
  
 // method setUserObject
  
}
