/*
 * ObjectSetListCellRenderer.java
 *
 * Created on September 10, 2003, 9:06 PM
 */

package edu.byu.deg.dataframe;

import edu.byu.deg.osmx.binding.ObjectSetType;
import java.awt.Color;
import java.awt.Component;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

/**
 *
 * @author  Alan
 */
public class ObjectSetListCellRenderer extends JLabel implements ListCellRenderer {
    
  public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
    Color defaultBackground = list.getBackground();
    Color defaultForeground = list.getForeground();
    setOpaque(true);
    if (isSelected) {
      Color selBackground = list.getSelectionBackground();
      if (selBackground == null) selBackground = defaultBackground;
      Color selForeground = list.getSelectionForeground();
      if (selForeground == null) selForeground = defaultForeground;
      setBackground(selBackground);
      setForeground(selForeground);
    } else {
      setBackground(defaultBackground);
      setForeground(defaultForeground);
    }
    
    if (value == null) {
      return this;
    }
    
    ObjectSetType objSet = (ObjectSetType) value;
    String name = objSet.getName();
    String id = "[" + objSet.getId() + "]";
    if (name == null || name.length() == 0) {
      name = id;
    } else {
      name += " " + id;
    }
    setText(name);
    return this;
  }
  
}
