/*
 * ParameterListNode.java
 *
 * Created on July 19, 2003, 7:17 PM
 */

package edu.byu.deg.dataframe;

import edu.byu.deg.osmx.binding.ParameterType;
import java.util.List;
import java.util.Iterator;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;

/**
 *
 * @author  Alan
 */
public class ParameterListNode extends AbstractDataFrameTreeNode {
  
  protected List parameterList;
  
  /** Creates a new instance of ParameterListNode */
  public ParameterListNode(List pl, DefaultTreeModel model) {
    super(pl, model);
    parameterList = pl;
    if (parameterList != null) {
      for (Iterator i = parameterList.iterator(); i.hasNext();) {
        ParameterType param = (ParameterType) i.next();
        this.add(new ParameterNode(param, treeModel));
      }
    }
  } // constructor
  
  public String toString() {
    return "Parameters";
  }
  
  public List getParameterList() {
    return parameterList;
  } // method getParameterList
  
  public void setUserObject(Object o) {
    if (o instanceof List) {
      super.setUserObject(o);
      parameterList = (List) o;
    }
  } // method setUserObject
  
  public void add(MutableTreeNode newChild) {
    if (!(newChild instanceof ParameterNode)) return;
    super.add(newChild);
  }
  
  public void nodeAdded(TreeNode child) {
    isNodeSetChanging = true;
    ParameterNode newChild = (ParameterNode) child;
    if (newChild != null) {
      if (!parameterList.contains(newChild.getParameter())) {
        parameterList.add(newChild.getParameter());
      }
    }
    if (treeModel != null) treeModel.insertNodeInto(newChild, this, this.getChildCount() - 1);
    isNodeSetChanging = false;
  }
  
  public void nodeRemoved(TreeNode child) {
    isNodeSetChanging = true;
    ParameterNode newChild = (ParameterNode) child;
    if (parameterList != null) {
      parameterList.remove(newChild.getParameter());
    }
    if (treeModel != null) treeModel.nodeStructureChanged(this);
    isNodeSetChanging = false;
  }
  
}
