/*
 * ParameterNode.java
 *
 * Created on July 19, 2003, 7:43 PM
 */

package edu.byu.deg.dataframe;

import edu.byu.deg.osmx.OSMXParameterType;
import edu.byu.deg.osmx.binding.MethodType;
import edu.byu.deg.osmx.binding.ParameterType;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;


/**
 *
 * @author  Alan
 */
public class ParameterNode extends AbstractDataFrameTreeNode {
  
  protected OSMXParameterType parameter;
  protected PropertyChangeListener contentListener;
  
  /** Creates a new instance of ParameterNode */
  public ParameterNode(ParameterType p, DefaultTreeModel model) {
    super(p, model);
    contentListener = new PropertyChangeListener() {
      public void propertyChange(PropertyChangeEvent evt) {
        String propName = evt.getPropertyName();
        Object source = evt.getSource();
        if (source instanceof MethodType) {
          if (OSMXParameterType.NAME_PROPERTY.equals(propName)) {
            if (treeModel != null) {
              treeModel.nodeChanged(ParameterNode.this);
            }
          }
        }
      }
    };
    parameter = (OSMXParameterType) p;
    if (parameter != null) {
      this.add(new KeywordPhraseListNode(parameter.getKeywordPhrase(), treeModel));      
      
    }
    setUserObject(p);
  } // constructor
  
  public String toString() {
    String result = "";
    if (parameter == null) result = "<html><i>Null</i></html>";
    else result = parameter.toString();
    return result;
  } // method toString
  
  public ParameterType getParameter() {
    return parameter;
  } // method getParameter
  
  public void setUserObject(Object o) {
    if (parameter != null) {
      parameter.removePropertyChangeListener(contentListener);
    }
    if (userObject instanceof OSMXParameterType) {
      super.setUserObject(userObject);
      parameter = (OSMXParameterType) userObject;
      if (parameter != null) {
        parameter.addPropertyChangeListener(contentListener);
      }
    }
  }
  
  public void nodeAdded(TreeNode child) { /* do nothing */ }
  
  public void nodeRemoved(TreeNode child) { /* do nothing */ }
  
 // method setUserObject
  
}
