/*
 * ValuePhraseListNode.java
 *
 * Created on July 19, 2003, 4:04 PM
 */

package edu.byu.deg.dataframe;

import edu.byu.deg.osmx.binding.ValuePhraseType;
import java.util.Iterator;
import java.util.List;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;


/**
 *
 * @author  Alan
 */
public class ValuePhraseListNode extends AbstractDataFrameTreeNode {
  
  protected List valuePhraseList;
  
  /** Creates a new instance of ValuePhraseListNode */
  public ValuePhraseListNode(List vpl, DefaultTreeModel model) {
    super(vpl, model);
    valuePhraseList = vpl;
    if (vpl != null) {
      for (Iterator i = vpl.iterator(); i.hasNext();) {
        ValuePhraseType phrase = (ValuePhraseType) i.next();
        this.add(new ValuePhraseNode(phrase, treeModel));
      }
    }
  }
  
  public String toString() {
    return "Value Phrases";
  }
  
  public List getValuePhraseList() {
    return valuePhraseList;
  } // method getValuePhraseList
  
  public void setUserObject(Object userObject) {
    if (userObject instanceof List) {
      super.setUserObject(userObject);
      valuePhraseList = (List) userObject;
    }
  }
  
  public void add(MutableTreeNode newChild) {
    if (!(newChild instanceof ValuePhraseNode)) return;
    super.add(newChild);
  }
  
  public void nodeAdded(TreeNode child) {
    isNodeSetChanging = true;
    ValuePhraseNode newChild = (ValuePhraseNode) child;
    if (newChild != null) {
      if (!valuePhraseList.contains(newChild.getValuePhrase())) {
        valuePhraseList.add(newChild.getValuePhrase());
      }
    }
    if (treeModel != null) treeModel.insertNodeInto(newChild, this, this.getChildCount() - 1);
    isNodeSetChanging = false;
  }
  
  public void nodeRemoved(TreeNode child) {
    isNodeSetChanging = true;
    ValuePhraseNode newChild = (ValuePhraseNode) child;
    if (valuePhraseList != null) {
      valuePhraseList.remove(newChild.getValuePhrase());
    }
    if (treeModel != null) treeModel.nodeStructureChanged(this);
    isNodeSetChanging = false;
  }
  
}
