/*
 * VSMExtractor.java
 *
 * Created on March 18, 2004, 12:27 PM
 */

package edu.byu.deg.extractionmodule;

/**
 *
 * @author  troywalk
 */
import edu.byu.deg.framework.*;
import edu.byu.deg.framework.DSP.VSM.VSMRecordSeparator;
import edu.byu.deg.osmx.OSMXDocument;
import edu.byu.deg.query.OSMQuery;

public class VSMExtractor implements ExtractionModule {
  OSMXDocument ontology;
  VSMRecordSeparator separator;
  edu.byu.deg.geneTIQS.FillData filler; //temporary

  /** Creates a new instance of VSMExtractor */
  public VSMExtractor() {
  }
  
  //this extractor is the catch-all default extractor.  Others offer improvements on specialized cases
  public double getConfidence(Document d) {
    return 0.1; 
  }
  
  public void init(OSMXDocument ont) {
    ontology = ont;
    separator = new VSMRecordSeparator(ont);
    filler = new edu.byu.deg.geneTIQS.FillData();
  }
  
  public void extract(Document d, OSMQuery query, DocumentRetriever r) {
    try{
      separator.parse(d);
    } catch (UnrecognizedFormatException e){ return; }

    filler.fillData((edu.byu.deg.framework.document.DOMDocument)d, ontology, query);
  }
  
}
