/*
 * MatchCache.java
 *
 * Created on January 20, 2004, 12:59 PM
 */

package edu.byu.deg.framework.DSP.VSM;

/**
 *
 * @author  troywalk
 */

import org.w3c.dom.Node;
import edu.byu.deg.osmx.OSMXDocument;
import edu.byu.deg.osmx.binding.*;
import edu.byu.deg.osmx.binding.MatchedTextType;
import edu.byu.deg.util.DOMString;
import java.util.*;

public class NodeMatchCounter {
	private Map counts;
	private double[] zerovector;
	private VSMManager manager;
	/** Creates a new instance of MatchCache */
	public NodeMatchCounter(OSMXDocument ontology, DOMString str, VSMManager m) {
		zerovector = new double[m.dimension];
		for(int x = 0;x<zerovector.length;x++)
			zerovector[x] = 0;
		manager = m;
		
		counts = new HashMap();
		Iterator i = ontology.getModelRoot().getAllModelElements().iterator();
		while(i.hasNext()){
			Object o = i.next();
			if(o instanceof ObjectSet){
				ObjectSet os = (ObjectSet)o;
				String matchid = os.getId() + "Match";
				String keywordid = os.getId() + "Keyword";
				if(os.getDataFrame()!=null){
					Iterator j = os.getDataFrame().getValuePhrase().iterator();
					while(j.hasNext()){
						ValuePhraseType vp = (ValuePhraseType)j.next();
						Iterator k = vp.getValueExpression().getMatchedText().iterator();
						while(k.hasNext()){
							MatchedTextType match = (MatchedTextType)k.next(); 
							Node n = str.getNodeFor(match.getStartPos());
							if(n.getNodeType()!=Node.TEXT_NODE)
								System.out.println("HELP!");
							increment(n, matchid);
						}
					}
					j = os.getDataFrame().getKeywordPhrase().iterator();
					while(j.hasNext()){
						KeywordPhraseType kp = (KeywordPhraseType)j.next();
						Iterator k = kp.getKeywordExpression().getMatchedText().iterator();
						while(k.hasNext()){
							MatchedTextType match = (MatchedTextType)k.next();
							Node n = str.getNodeFor(match.getStartPos());
							if(n.getNodeType()!=Node.TEXT_NODE)
								System.out.println("HELP!");
							increment(n, keywordid);
						}
					}
				}
			}
		}
	}
	
	//public int getCountOff
	private void increment(Node n, String id){
		if(n==null) return;
		VSMMeasure vsm = (VSMMeasure)counts.get(n);
		if(vsm==null){
			vsm = new VSMMeasure(zerovector);
			counts.put(n, vsm);
		}
		int i = manager.getIndexOf(id);
		if(i!=-1)
			vsm.set(i, vsm.get(i)+1);
	}
	
	public VSMMeasure getCount(Node node){
		VSMMeasure vsm = (VSMMeasure)counts.get(node);
		if(vsm==null){
			vsm = new VSMMeasure(zerovector);
			Node child = node.getFirstChild();
			while(child!=null){
				vsm.add(getCount(child));
				child = child.getNextSibling();
			}
			counts.put(node, vsm);
		}
		return vsm;
	}
	
}



