/*
 * HighestCountTagHeuristic.java
 *
 * Created on December 1, 2003, 11:40 AM
 */

package edu.byu.deg.framework.DSP.heuristic;

/**
 *
 * @author  troywalk
 */

import java.util.HashMap;
import java.util.ArrayList;
public class HighestCountTagHeuristic implements SeparationHeuristic {

  protected static double[] certainty = {0.49, 0.325, 0.165, 0.02};
  private HashMap ranks;
  /** Creates a new instance of HighestCountTagHeuristic */
  public HighestCountTagHeuristic(TagCounter tc) {
    ranks = new HashMap();
    ArrayList l = tc.getTagList(2);
    int max = 1;
    int current;
    int rank = 1;
    //create a list of tags and their ranks.  The original heuristic allowed multiple tags with rank 1 without skipping other ranks
    //even though this is statistically incorrect, we need to leave it this way unless we do new experiments to replace the certainty numbers.
    while(max>0){
      max = 0;
      for(int i=0;i<l.size();i++){
        current = tc.getCount((String)l.get(i));
        if(current>max)
          max = current;
      }
      if(max>0)
        for(int i=0;i<l.size();i++){
          String tag = (String)l.get(i);
          if(tc.getCount(tag)==max){
            ranks.put(tag, new StringIntegerWrapper(tag, rank));
            l.set(i, null);
          }
        }
      rank++;
    }
  }
  
  public int getRank(String tag) {
    StringIntegerWrapper rank = (StringIntegerWrapper)ranks.get(tag);
    if(rank==null)
      return -1;
    return rank.num;
  }
  
  public double getCertainty(int i){
    if(i<0||i>=certainty.length)
      return 0;
    return certainty[i];
  }
  
}
