/*
 * IdentifiableTagHeuristic.java
 *
 * Created on November 21, 2003, 2:24 PM
 */

package edu.byu.deg.framework.DSP.heuristic;


import org.w3c.dom.Node;
import java.util.HashMap;
import java.util.ArrayList;
/**
 *
 * @author  troywalk
 */
public class IdentifiableTagHeuristic implements SeparationHeuristic {

  private static String[] orderedIdentifiableTags = {"hr", "td", "tr", "table", "a", "p", "br", "h4", "h1", "strong", "b"};
  protected static double[] certainty = {0.96, 0.04};
  
  private ArrayList ranking;
  /** Creates a new instance of IdentifiableTagHeuristic */
  public IdentifiableTagHeuristic(Node tree) {
    HashMap map = new HashMap();
    ranking = new ArrayList();
    markUsedTags(tree.getFirstChild(), map);
    for(int i=0;i<orderedIdentifiableTags.length;i++)
      if(map.containsKey(orderedIdentifiableTags[i]))
        ranking.add(orderedIdentifiableTags[i]);
  }
  
  private void markUsedTags(Node n, HashMap map){
    if(n==null)
      return;
    while(n!=null){
      if(n.getNodeType()==Node.ELEMENT_NODE){
        String tag = n.getNodeName().toLowerCase();
        map.put(tag, tag);
      }
      n = n.getNextSibling();
    }
  }
  
  public int getRank(String tag) {
    for(int i=0;i<ranking.size();i++)
      if(ranking.get(i).equals(tag.toLowerCase()))
        return i;
    return -1;
  }
  
  public double getCertainty(int i){
    if(i<0||i>=certainty.length)
      return 0;
    return certainty[i];
  }
  
}
