/*
 * TagCounter.java
 *
 * Created on December 1, 2003, 1:29 PM
 */

package edu.byu.deg.framework.DSP.heuristic;

/**
 *
 * @author  troywalk
 */
import org.w3c.dom.Node;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map.Entry;
public class TagCounter {
  HashMap counts;
  
  /** Creates a new instance of TagCounter */
  public TagCounter(Node tree) {
    counts = new HashMap();
    Node node = tree.getFirstChild();
    while(node!=null){
      if(node.getNodeType()==Node.ELEMENT_NODE){
        String tag = node.getNodeName().toLowerCase();
        Int count = (Int)counts.get(tag);         //look in the hashtable for the current tag
        if(count==null){                          //if it isn't in there, put it in with a count of 1
          counts.put(tag, new Int(1));
        }
        else {                                    //if it is in there, increment the count
          count.inc();
        }
      }
      node = node.getNextSibling();
    }
  }
  public ArrayList getTagList(int minimumCount){
     ArrayList tags = new ArrayList();
     Iterator i = counts.entrySet().iterator();
     while(i.hasNext()){
       Entry e = (Entry)i.next();
       if(((Int)e.getValue()).getInt()>=minimumCount)
         tags.add(e.getKey());
     }
    return tags;
  }

  public ArrayList getTagList(){
    return getTagList(0);
  }
  
  public int getCount(String tag){
     Int count = (Int)counts.get(tag);
     if(count==null)
       return 0;
     return count.getInt();    
  }

  class Int{
    int integer;
    public Int(int i){
      integer = i;
    }
    public int getInt(){
      return integer;
    }
    public void setInt(int i){
      integer = i;
    }
    public void inc(){
      integer++;
    }
  }

}
