/*
 * OntologySubscriber.java
 *
 * Created on May 19, 2004, 9:12 AM
 */

package edu.byu.deg.framework;

/**
 * Common interface for components of the framework that need to acquire and
 * maintain references to the <CODE>Ontology</CODE> used in extraction.  This
 * interface allows the engine to pass the ontology to these components without
 * having to know the actual classes that define them.
 * @author Alan Wessman
 */
public interface OntologySubscriber {
    
    /**
     * Stores the ontology in the component.
     * @param ontology The ontology to store.
     */    
    public void setOntology(Ontology ontology);
    
    /**
     * Accessor for the ontology that the component currently references.
     * @return The ontology currently referenced by the component.
     */    
    public Ontology getOntology();
    
}
