/*
 * TextDocument.java
 *
 * Created on February 16, 2004, 11:56 AM
 */

package edu.byu.deg.framework;

/**
 * Represents a <CODE>Document</CODE> whose contents are textual.
 * @author Alan Wessman
 */
public interface TextDocument extends Document {
    
    /**
     * Returns the contents of the <CODE>Document</CODE> as a <CODE>String</CODE>.
     * @throws java.io.IOException Thrown if there is a problem with obtaining the content string from the internal
     * source.
     * @return The textual contents of the <CODE>Document</CODE>.
     */    
    public String getContentString() throws java.io.IOException;
    
}
