/*
 * DOMRetriever.java
 *
 * Created on February 4, 2004, 11:20 AM
 */


package edu.byu.deg.framework.retriever;

import java.util.*;
import java.io.*;
import java.net.*;
/**
 *
 * @author  troywalk
 */
public class DOMRetriever implements edu.byu.deg.framework.DocumentRetriever {
  private ArrayList uris;
  private ArrayList strings;
  /** Creates a new instance of DOMRetriever */
  public DOMRetriever() {
    uris = new ArrayList();
    strings = new ArrayList();
  }
  
  public DOMRetriever(String filename) {
    this();
    try {
      BufferedReader i = new BufferedReader(new FileReader(filename));
      while(i.ready()){
        this.addDocumentLocation(i.readLine());
      }
    } catch(Exception e){ System.err.println("Cannot open URL file");}
  }
  
  public void addDocumentLocation(String uri) throws URISyntaxException {
    if(uri.length()==0)
      return;
    uri = uri.replace('\\','/');
    if(uri.indexOf("//")==-1){
      if(uri.charAt(0)!='/')
        uri = "/" + uri;
      uri = "file://" + uri;
    }
	uris.add(new URI(uri));
	strings.add(uri);
  }
  
  public void clearDocumentLocations() {
    uris.clear();
  }
  
  public Iterator getDocumentLocations() {
    return strings.iterator();
  }
  
  public Iterator retrieveDocuments() {
    return new myIterator();
  }
  
  public void setRetrievalLocation(String uri) { /* do nothing */ }
 
  public void initialize(){ /* do nothing */ }
  public void removeDocumentLocation(String uri){ /* do nothing */ }

  class myIterator implements Iterator{
    int index = 0;
    
    public boolean hasNext() {
      return index<uris.size();
    }
    
    public Object next() {
      return new edu.byu.deg.framework.document.DOMDocument((URI)uris.get(index++));
    }
    
    public void remove() {
        // we throw an exception so calling programs
        // don't rely on remove() to do something -- it does nothing
        throw new UnsupportedOperationException(); 
    }
    
  }
  
}
