/*
 * GeneTIQS.java
 *
 * Created on August 20, 2003, 3:24 PM
 */

package edu.byu.deg.geneTIQS;

//import edu.byu.deg.geneTIQS.record.*;
import edu.byu.deg.osmx.*;
import edu.byu.deg.ontos.*;
import edu.byu.deg.util.*;
import edu.byu.deg.framework.DSP.VSM.VSMRecordSeparator;
import edu.byu.deg.framework.document.DOMDocument;
import edu.byu.deg.framework.retriever.DOMRetriever;
import edu.byu.deg.framework.*;

/**
 *
 * @author  troywalk
 */
public class GeneTIQS {
  
  /** Creates a new instance of GeneTIQS */
  public GeneTIQS() {
  }
  
  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) {
    try{
      if(Timer.time) Timer.timer.startTask("Extracting");
      OSMXDocument ontology = new OSMXDocument();

      if(Timer.time) Timer.timer.startTask("Loading ontology");
      ontology.openDocument("c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/ontology/person.xml");
      if(Timer.time) Timer.timer.endTask("Loading ontology");

      if(Timer.time) Timer.timer.startTask("Initiating Document Retriever");
      //DocumentRetriever retriever = new DOMRetriever("c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/urllists/testcomplex.txt");
      DocumentRetriever retriever = new DOMRetriever("c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/urllists/urls.txt");
      //DocumentRetriever retriever = new DOMRetriever("c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/urllists/urls2.txt");
      //DocumentRetriever retriever = new DOMRetriever("c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/urllists/singlerecord.txt");
      //DocumentRetriever retriever = new DOMRetriever("c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/urllists/simple.txt");
      //DocumentRetriever retriever = new DOMRetriever("c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/urllists/complex.txt");
      if(Timer.time) Timer.timer.endTask("Initiating Document Retriever");
      
      
      
      /*
      if(Timer.time) Timer.timer.startTask("Initiating Record Separator");
      edu.byu.deg.framework.DocumentStructureParser separator;
      //separator = new edu.byu.deg.framework.DSP.fanout.FanoutRecordSeparator();
      separator = new VSMRecordSeparator(ontology);
      if(Timer.time) Timer.timer.endTask("Initiating Record Separator");
      
      if(Timer.time) Timer.timer.startTask("Initiating DataFrameMatcher");
      //DataFrameMatcher dfm = new DataFrameMatcher(ontology, "c:/documents and settings/troywalk/out/edu/byu/deg/geneTIQS/ontology");
      DataFrameMatcher dfm = new DataFrameMatcher(ontology);
      if(Timer.time) Timer.timer.endTask("Initiating DataFrameMatcher");
      
      long total=0;
      java.util.Iterator it = retriever.retrieveDocuments();
      int count = 0;
      while(it.hasNext()){
        dfm.clearMatches();
        if(Timer.time) Timer.timer.startTask("Document " + count);
        if(Timer.time) Timer.timer.startTask("Loading document");
        DOMDocument doc = (DOMDocument)it.next();
        if(Timer.time) Timer.timer.endTask("Loading document");

        if(Timer.time) Timer.timer.startTask("Matching");
        dfm.doMatches(doc);
        if(Timer.time) Timer.timer.endTask("Matching");

        if(Timer.time) Timer.timer.startTask("Eliminating overlaps");
        OverlapFilter.filter(ontology);
        if(Timer.time) Timer.timer.endTask("Eliminating overlaps");

        if(Timer.time) Timer.timer.startTask("Separating");
        separator.parse(doc);
        //System.out.println(doc.toString());
        if(Timer.time) Timer.timer.endTask("Separating");
        
        FillData filler = new FillData();
        filler.fillData(doc, ontology);

        if(Timer.time) total += Timer.timer.endTask("Document " + count);
        count++;
      }
      System.out.println("Average time per document " + total/count + "ms");
      /**/
      
      //dfm.clearMatches();
      
      edu.byu.deg.extractionmodule.MetaExtractor extractor = new edu.byu.deg.extractionmodule.MetaExtractor(ontology);
      extractor.startExtraction(retriever, null);
      /**/
      
      if(Timer.time) Timer.timer.startTask("Saving ontology");
      ontology.saveAsDocument("c:/result.xml");
      if(Timer.time) Timer.timer.endTask("Saving ontology");

      if(Timer.time) Timer.timer.endTask("Extracting");
    }catch(Exception e) {e.printStackTrace();return;}
  }
  
}
