static char const rcsid[] = "$Id: ontology.C,v 1.1.1.2 2005/07/01 22:44:05 mja47 Exp $";

/*========================================================================
* $Source: /raid/cvs/edu/byu/deg/osmx/ConvertedOSML/translator/ontology.C,v $
*
* $Author: mja47 $
* $Date: 2005/07/01 22:44:05 $
* $Revision: 1.1.1.2 $
*
* $Description: 
* Harmony parser driver. $
* 
* $Log: ontology.C,v $
* Revision 1.1.1.2  2005/07/01 22:44:05  mja47
* no message
*
* Revision 1.1.1.1  2003/08/09 20:48:42  pwinward
* no message
*
* Revision 1.3  2003/02/26 21:57:46  tim
* Added misc. bug fixes and minor features to demo,ontology editor, and ontos
*
* Revision 1.2  2002/07/16 21:50:15  tim
* I'm not real sure what's going on here. I updated this code so it taks arguments
* like the demo is expecting.  I'm not sure if this is actually an old copy of
* this code or what, but it seems to be working now (it wasn't allowing the
* user to specify the output directory)
*
* Revision 1.1.1.1  2002/04/25 23:00:01  tim
* no message
*
* Revision 1.1.1.1  1999/05/11 15:16:49  swliddle
* Ontos.rev2 stuff
*
* Revision 1.6  1998/02/11  23:13:14  liddl
* Added version argument.
*
* Revision 1.5  1998/02/05  22:20:14  liddl
* Checkpoint of reasonably decent version.
*
* Revision 1.4  1998/02/05 18:24:02  liddl
* Working version for VLDB Ontology paper.
*
* Revision 1.3  1996/05/03  15:22:55  liddl
* Fixed end-of-string bug.
*
* Revision 1.2  1996/04/24  13:43:54  liddl
* About to hand off to Ting.
*
* Revision 1.1  1996/01/30  17:31:24  liddl
* Initial revision
*
*/

/*------------------------------------------------------------------------
*			INCLUDES
*/
#include <iostream.h>
#include <iomanip.h>
#include <strstream.h>
#include <fstream.h>
#include <stdio.h>
#include <string>
#include <ctype.h>
#include <signal.h>
#include "unistd.h"
#include <stdlib.h>

#include "ontology.H"
#include "semantic.H"

#include "FlexLexer.h"

/*------------------------------------------------------------------------
*			PUBLIC GLOBAL VARIABLES
*/
#define MAX_NAME_SIZE	1000

/*------------------------------------------------------------------------
*			PUBLIC GLOBAL VARIABLES
*/
FlexLexer		*Harmony_lexer;	/* Lexical analyzer		*/
FILE			*ECF_fp,	/* Extended ORC output		*/
*EXP_fp,	/* Regular expression output	*/
*ORC_fp,	/* Structure/constraint output	*/
*SQL_fp;	/* SQL DDL output		*/

ofstream* OSMX = NULL;
string fileName;

/*------------------------------------------------------------------------
*			EXTERNAL GLOBAL VARIABLES
*/
extern int		yydebug,
Debug_lex;
extern long		Col_num,
Line_num,
Prev_col,
Prev_line;
extern char		*Parse_str;

/*------------------------------------------------------------------------
*			EXTERNAL FUNCTION DECLARATIONS
*/
extern int		yyparse(void);

/*========================================================================
*			FUNCTIONS
*/

/*------------------------------------------------------------------------
* FUNCTION Handle_Signal -- terminate gracefully on a signal
*/
void
Handle_Signal(int sig)
{
	signal(sig, Handle_Signal);
	Dump_Text(stderr, Parse_str, Col_num, Line_num);
	fprintf(stderr, "ontology: terminated on signal %d\n", sig);
	if (sig > 100)
		fprintf(stderr, rcsid);
	exit (-sig);
	
} /* Handle_Signal */

  /*------------------------------------------------------------------------
  * FUNCTION Open_Output_Files -- open three output files
*/
void
Open_Output_Files(char *name, char *dir)
{
	char	*basename,
        tmp[MAX_NAME_SIZE],
		final_dir[MAX_NAME_SIZE],
		fname[MAX_NAME_SIZE],
		*ptr;
	
	strcpy(tmp, name);
	strcpy(final_dir, dir);
	
	basename = strrchr(tmp, '/');
	if (basename == NULL) {
		basename = strrchr(tmp, '\\');
		if (basename == NULL)
			basename = tmp;
		else basename += 1;
	}
	else basename += 1;

	if (strlen(dir) > 0 && dir[strlen(dir) - 1] != '/' && 
		dir[strlen(dir) - 1] != '\\')
		strcat(final_dir, "/");
	
	ptr = strrchr(basename, '.');
	if (ptr != NULL)
		*ptr = '\0';
	/*
	sprintf(fname, "%s%s.sql", final_dir, basename);
	SQL_fp = fopen(fname, "w");
	sprintf(fname, "%s%s.orc", final_dir, basename);
	ORC_fp = fopen(fname, "w");
	sprintf(fname, "%s%s.ecf", final_dir, basename);
	ECF_fp = fopen(fname, "w");
	sprintf(fname, "%s%s.exp", final_dir, basename);
	EXP_fp = fopen(fname, "w");
	*/
	sprintf(fname, "%s%s_osmx.xml", final_dir, basename);
	//XML_fp = fopen(fname, "w");

	OSMX = new ofstream(fname, ios::out);
	fileName = basename;

} /* Open_Output_Files */

  /*------------------------------------------------------------------------
  * FUNCTION Parse_String -- parse a string as a Harmony program
*/
int
Parse_String(char *str)
{
	int		res;
	istrstream	strm(str);
	
	if (str == NULL || !*str) {
		fprintf(stderr, "ontology: empty string in Parse_String\n");
		return (-50);
	}
	
	if (Harmony_lexer != NULL)
		delete Harmony_lexer;
	Harmony_lexer = new yyFlexLexer(&strm);
	
	Col_num = Line_num = Prev_col = Prev_line = 1;
	Parse_str = str;
	res = yyparse();
	
	delete Harmony_lexer;
	Harmony_lexer = NULL;
	
	return (res);
	
} /* Parse_String */

  /*------------------------------------------------------------------------
  * FUNCTION main -- read and validate a file
*/
int
main(int argc, char *argv[])
{
	int	got_input = FALSE,
		i;
	
	signal(SIGINT, Handle_Signal);
	//signal(SIGALRM, Handle_Signal);
	
	for (i = 1; i < argc; i++) {
		if (argv[i][0] == '-') {
			switch (toupper(argv[i][1])) {
			case 'A':
				Case_switch = ANYCASE;
				break;
			case 'E':
				Case_switch = EITHERCASE;
				break;
			case 'L':
				Case_switch = LOWERCASE;
				break;
			case 'U':
				Case_switch = UPPERCASE;
				break;
			case 'D':
				Debug_lex = TRUE;
				if (argv[i][2] == '1')
					yydebug = TRUE;
				break;
			case 'V':
				fprintf(stderr, "%s\n", rcsid);
				break;
			}
		} else {
		/*
		* Parse the input file given by argv[i].
			*/
			char	*str;
			char      *output_dir = new char[MAX_NAME_SIZE];
			strcpy(output_dir, "./");
			long	flen;
			/*
			if (i < argc-1)
			{
				strcpy(output_dir, argv[i]);
				i++; //there's another argument, so we'll use this one as the output dir
			}
			*/
			ifstream	inf_str(argv[i]);
			if (inf_str.good()) {
				got_input = TRUE;
				inf_str.seekg(0, ios::end);
				flen = inf_str.tellg();
				if (flen > 0) {
					str = new char[flen + 1];
					str[flen] = '\0';
					inf_str.seekg(0);
					inf_str.read(str, flen);
					//fprintf(stderr, "************************ ontology: Parsing file '%s' and writing regular expressions....\n",  argv[i]);
					Open_Output_Files(argv[i], output_dir);
					//if (!Debug_lex)
					//  alarm(30);
					Parse_String(str);
					delete [] str;
					//fprintf(stderr,"ontology: '%s' appears to be a valid Harmony program.\n",  argv[i]);
					/*if (Debug_lex)
						Dump_Graph(stderr);
					//fprintf(stderr, "ontology: creating SQL and structure files....\n");
					Emit_SQL(SQL_fp, ORC_fp, ECF_fp);
					fclose(SQL_fp);
					fclose(ORC_fp);
					fclose(ECF_fp);
					fclose(EXP_fp);
					*/
					OSMX->close();
					//fprintf(stderr, "ontology: finished processing '%s'.\n", argv[i]);
				}
			} else {
				//fprintf(stderr, "ontology: Unable to process input file %s\n",	argv[i]);
				exit (-50);
			}
		}
	}
	
	if (OSMX != NULL)
		delete OSMX;

	exit (0);
	
} /* main */

  /*========================================================================
  *			END OF FILE $RCSfile: ontology.C,v $
*/
