#line 8 "btyaccpa.ske"

//
// @(#)btyaccpar, based on byacc 1.8 (Berkeley)
//
#define YYBTYACC 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef int Yshort;

#line 2 "harmony.yacc"
static char const rcsid[] =
        "$Id: parser.C,v 1.1.1.2 2005/07/01 22:44:05 mja47 Exp $";

/*========================================================================
* $RCSfile: parser.C,v $
*
* $Author: mja47 $
* $Date: 2005/07/01 22:44:05 $
* $Revision: 1.1.1.2 $
*
* $Description: 
* Harmony Language Grammar. $
* 
* $Log: parser.C,v $
* Revision 1.1.1.2  2005/07/01 22:44:05  mja47
* no message
*
* Revision 1.1.1.1  2003/08/09 20:48:42  pwinward
* no message
*
* Revision 1.1.1.1  2002/04/25 23:00:01  tim
* no message
*
* Revision 1.1.1.1  1999/05/11 15:16:49  swliddle
* Ontos.rev2 stuff
*
* Revision 1.5  1998/02/05  22:20:14  liddl
* Checkpoint of reasonably decent version.
*
* Revision 1.4  1998/02/05 18:24:02  liddl
* Working version for VLDB Ontology paper.
*
* Revision 1.3  1996/04/24  13:43:54  liddl
* About to hand off to Ting.
*
* Revision 1.2  1996/01/17  21:37:57  liddl
* Lots of updates for the Harmony language.  Now we need to
* spend some serious time debugging and improving it.
*
* Revision 1.1  1995/11/04  01:00:46  liddl
* Initial revision
*
*/
/*------------------------------------------------------------------------
*			INCLUDES
*/
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <fstream.h>
#include <iostream.h>

#include "ontology.H"
#include <FlexLexer.h>
#include "semantic.H"

#define yylex Harmonylex

/*------------------------------------------------------------------------
*          GLOBALS
*/
extern ofstream* OSMX;
extern string fileName;
string ENDL = "\n";

string nameList = "";
string objectPrimary = "";
bool inObjectSet = false;
string caseSensitive = "";
float confidenceValue = -1.0;
string contextExpression = "";
string valueExpression = "";
string subFromExpression = "";
string subToExpression = "";
string exceptionExpression = "";
string connections = "";
string partic = "";
string binaryName = "";
string ternaryName = "";
bool isBinary;
bool isTernary;
char buffer[20];
bool inGenSpec = false;
string specializations = "";
string url = "";
string label = "";
string delimiters = "";
string caseSens = "";
string dataFrame = "";
string frameComponent = "";
string constantComponent = "";
string keywordComponent = "";
int ID = 1;
int tempID = 1;
string name = "";
string extract = "";
string context = "";

struct Lexicon {
	Lexicon();
	string label;
	string url;
	string delimiters;
	string caseSens;
	struct Lexicon * next;
};

Lexicon::Lexicon() {
	label = "";
	url = "";
	delimiters = "";
	caseSens = "N";
	next = NULL;
}
typedef struct Lexicon * LexPtr;

LexPtr lexStart = NULL;
LexPtr lexEnd = NULL;

string intToString(int i) {
	char buffer[20];
	sprintf(buffer, "%d", i);

	return buffer;
}

string floatToString(float f) {
	char buffer[20];
	gcvt(f, 5, buffer);
	
	return buffer;
}

string LeftAndRightContext(string extract, string context) {
	/* extract and context must not include quotes
*/
	string left = "";
	string right = "";

	int leftEnd = context.find(extract);
	if (leftEnd == -1 || leftEnd == int(string::npos)) {		/* extract not a subset
*/
		left =	"<LeftContextExpression>" + ENDL +
				"<ExpressionText>***MANUALLY INPUT***</ExpressionText>" + ENDL +
				"</LeftContextExpression>" + ENDL +
				"<RightContextExpression>" + ENDL +
				"<ExpressionText>***MANUALLY INPUT***</ExpressionText>" + ENDL +
				"</RightContextExpression>" + ENDL;
	}
	else {
		if (leftEnd != 0) {							/* if there's a left context
*/
			left =	"<LeftContextExpression>" + ENDL +
					"<ExpressionText>" + context.substr(0, leftEnd) + "</ExpressionText>" + ENDL +
					"</LeftContextExpression>" + ENDL;
		}

		int rightStart = leftEnd + extract.length();

		/* if there's a right context
*/
		if (rightStart < int(context.length())) {
			right = "<RightContextExpression>" + ENDL +
					"<ExpressionText>" + 
					context.substr(rightStart, context.length() - rightStart) +
					"</ExpressionText>" + ENDL +
					"</RightContextExpression>" + ENDL;
		}
	}

	return (left + right);
}


void initVars() {
	nameList = "";
	objectPrimary = "";
	inObjectSet = false;
	caseSensitive = "";
	confidenceValue = -1.0;
	contextExpression = "";
	valueExpression = "";
	subFromExpression = "";
	subToExpression = "";
	exceptionExpression = "";
	connections = "";
	partic = "";
	binaryName = "";
	ternaryName = "";
	isBinary = false;
	isTernary = false;
	inGenSpec = false;
	specializations = "";
	url = "";
	label = "";
	delimiters = "";
	caseSens = "";
	dataFrame = "";
	frameComponent = "";
	constantComponent = "";
	keywordComponent = "";
	ID = 1;
	tempID = 1;
	name = "";
	lexStart = NULL;
	lexEnd = NULL;
	extract = "";
	context = "";
}



#line 209 "harmony.yacc"

typedef union {
	char		*p_char;
	NODE		*p_node;
	EDGE		*p_edge;
	PCONSTR		*p_cc;
	FRAMEC		*p_frame;
	LEXICON_ST	*p_lex;
	int		num;
	float		fval;
       } YYSTYPE;
#line 230 "y.tab.c"
#define BAR 257
#define COLON 258
#define COMMA 259
#define DETERMINES 260
#define DOT 261
#define LBRACE 262
#define LBRACKET 263
#define LPAREN 264
#define RBRACE 265
#define RBRACKET 266
#define RPAREN 267
#define SEMICOLON 268
#define FLOAT 269
#define NONNEGINT 270
#define LOWERWORD 271
#define STRING 272
#define UPPERWORD 273
#define STAR 274
#define CASEINSENS 275
#define CASESENS 276
#define CONTEXT 277
#define CONSTANT 278
#define ENDKEY 279
#define EXCEPT 280
#define EXTRACT 281
#define FILTER 282
#define FILENAME 283
#define HEADER 284
#define ISA 285
#define ISAM 286
#define ISAP 287
#define ISAU 288
#define KEYWORD 289
#define LEXICON 290
#define MATCHES 291
#define OBJECTKEY 292
#define SEPARATOR 293
#define SUBSTITUTE 294
#define USEQUOTE 295
#define YYERRCODE 256
static int yylhs[] = {                                        -1,
   49,    0,   48,   48,   50,   50,   50,   50,   54,   56,
   57,   58,   59,   51,   55,   55,   61,    7,    7,   62,
   63,   64,   65,    8,    9,   13,   13,   12,   12,   12,
   66,   15,   67,   15,   14,   14,   14,   17,   68,   18,
   18,   69,   70,   19,   71,   72,   19,   11,   27,   73,
   74,   27,   26,   26,   26,   44,   44,   75,   76,   16,
   21,   21,   77,   78,   79,   22,   28,   28,   10,   80,
   24,   24,   25,   25,   25,   25,   25,    5,    5,    6,
    6,   45,   45,   45,   81,   20,   23,   23,   47,   47,
   60,   82,   82,   84,   52,   85,   85,   86,   86,   88,
   88,   89,   91,   92,   83,   93,   30,   94,   30,   95,
   31,   96,   32,    3,    3,    2,    2,   87,   87,   38,
   38,   39,   98,   33,   35,   35,   34,   40,   40,   40,
   40,   99,   99,  100,  100,   37,  101,   36,   43,   43,
   43,   41,   42,   42,   46,   46,   29,   29,  102,  104,
   53,  103,  103,  103,  103,  103,   90,   90,    1,   97,
   97,  105,    4,    4,
};
static int yylen[] = {                                         2,
    0,    2,    2,    3,    1,    1,    1,    3,    0,    0,
    0,    0,    0,    9,    1,    0,    0,    3,    0,    0,
    0,    0,    0,   11,    1,    3,    0,    1,    1,    0,
    0,    2,    0,    4,    2,    2,    2,    4,    0,    3,
    5,    0,    0,    6,    0,    0,    8,    1,    3,    0,
    0,    6,    4,    3,    4,    1,    0,    0,    0,    6,
    2,    5,    0,    0,    0,    9,    1,    0,    1,    0,
    4,    7,    4,    4,    4,    3,    4,    1,    3,    1,
    1,    1,    1,    0,    0,    5,    2,    5,    1,    0,
    1,    2,    3,    0,    4,    1,    0,    1,    0,    1,
    3,    6,    0,    0,    4,    0,    2,    0,    4,    0,
    4,    0,    4,    1,    0,    1,    2,    2,    3,    1,
    0,    1,    0,    5,    1,    0,    2,    2,    2,    2,
    0,    1,    0,    2,    3,    3,    0,    3,    2,    3,
    0,    1,    1,    1,    1,    1,    5,    0,    0,    0,
    5,    1,    1,    1,    1,    1,    1,    3,    1,    2,
    2,    2,    1,    2,
};
static int yydefred[] = {                                      1,
    0,    0,    0,    0,    0,    5,    6,    7,    0,    0,
    0,    0,    0,    3,  163,   10,    0,  116,    0,    0,
  103,    0,  157,    0,    8,    4,    0,  164,  117,  112,
  104,    0,    0,    0,    0,    0,    0,   11,   15,    0,
    0,  106,    0,    0,    0,   95,    0,  100,    0,  158,
  152,  153,  154,  155,  156,    0,   92,    0,    0,    0,
  113,  105,    0,    0,  160,  161,    0,    0,    0,  151,
  122,   12,  120,   93,  142,  125,  123,  123,    0,  137,
    0,  108,  107,    0,    0,  101,   13,    0,    0,    0,
  127,    0,    0,  110,    0,    0,    0,    0,    0,    0,
  136,  134,    0,    0,    0,  138,    0,  109,    0,   14,
   13,  130,  129,  128,  124,  146,  145,    0,  135,  143,
  144,  139,    0,  111,  102,   17,    0,  140,   18,   13,
    0,    0,  147,   25,   20,   21,    0,    0,   22,    0,
    0,   26,   29,   28,   23,   31,    0,   31,   24,    0,
    0,   31,   58,   85,   21,   36,   35,   37,   34,   33,
   33,    0,   31,    0,    0,    0,   21,   59,   31,    0,
    0,   38,   48,    0,    0,    0,    0,    0,   61,    0,
   89,    0,   86,   45,   33,   22,   40,   60,   22,   69,
   63,   22,   21,   43,    0,   31,   22,    0,    0,   45,
   21,   41,   62,    0,   64,   88,    0,    0,    0,   21,
   46,    0,    0,   33,    0,   44,    0,   70,    0,    0,
    0,    0,   51,   65,    0,   47,   54,   56,    0,   83,
   82,    0,   21,    0,    0,    0,    0,    0,    0,    0,
   55,   53,   52,   66,   67,   80,   81,   22,    0,   22,
   22,    0,    0,    0,    0,    0,    0,    0,   76,    0,
   65,   73,   79,   75,   74,   77,   21,   72,
};
static int yydgoto[] = {                                       1,
   23,   19,   81,   17,  248,  249,  110,  129,  135,  191,
  174,  145,  139,  150,  147,  156,  157,  165,  175,  158,
  178,  179,  171,  217,  240,  215,  199,  244,  101,   62,
   83,   21,   71,   76,   77,   78,   79,   72,   73,   99,
   80,  122,  106,  229,  232,  118,  182,    4,    2,    5,
    6,    7,    8,    9,   38,   27,   58,   87,   97,   39,
  111,  136,  200,  141,  146,  148,  152,  167,  185,  201,
  193,  219,  223,  233,  160,  177,  197,  210,  234,  225,
  161,   40,   22,   10,   33,   46,   34,   47,   48,   24,
   31,   42,   63,   95,  107,   41,   44,   88,   91,   92,
   93,   11,   56,   36,   66,
};
static int yysindex[] = {                                      0,
    0, -244, -237, -244, -225,    0,    0,    0, -213, -141,
 -213, -116,  -87,    0,    0,    0, -103,    0,  -74, -213,
    0,  -64,    0,  -65,    0,    0,  -59,    0,    0,    0,
    0, -213,  -63,  -56, -213, -233, -213,    0,    0,  -55,
  -60,    0,  -89, -141, -213,    0,  -54,    0, -213,    0,
    0,    0,    0,    0,    0, -213,    0,  -60, -213,  -66,
    0,    0,    0,  -86,    0,    0, -166,  -63, -141,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -53,    0,
 -213,    0,    0, -103,  -60,    0,    0,  -52,  -57,  -66,
    0,  -50,  -78,    0, -141, -213,    0, -172,  -51,  -80,
    0,    0,  -66, -173,  -49,    0,  -60,    0, -230,    0,
    0,    0,    0,    0,    0,    0,    0,  -48,    0,    0,
    0,    0, -173,    0,    0,    0,  -80,    0,    0,    0,
  -47,  -81,    0,    0,    0,    0,  -46,  -45,    0,  -44,
 -101,    0,    0,    0,    0,    0,  -61,    0,    0,    0,
 -149,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -58,  -41,  -43,    0,    0,    0,  -80,
  -39,    0,    0,    0,  -36,  -43,  -35,  -29,    0,    0,
    0,  -28,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -58,  -33,    0,
    0,    0,    0,  -27,    0,    0,  -25, -184,  -26,    0,
    0,  -34,  -32,    0,    0,    0,  -24,    0,  -43,  -31,
  -82,  -84,    0,    0, -163,    0,    0,    0,  -23,    0,
    0,  -20,    0,  -80,  -77,  -19,  -77,  -18,  -17,  -16,
    0,    0,    0,    0,    0,    0,    0,    0,  -15,    0,
    0,  -82,  -14,    0,  -84,  -77,  -84,  -84,    0,  -13,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yyrindex[] = {                                      0,
    0,  -11,    0,    1,    0,    0,    0,    0,    0,  -12,
    0,    0,    0,    0,    0,    0, -180,    0,  -10,    0,
    0, -115,    0, -219,    0,    0, -207,    0,    0,    0,
    0,    0,   -6,  -91,    0,    0,    0,    0,    0, -206,
    0,    0,    0, -112,    0,    0,   -4,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -254,    0,  -97,
    0,    0,    0,    0,    0,    0,    0,    0, -111,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -95,    0,
    0,    0,    0, -129,   -8,    0,    0,  -42,  -98,    0,
    0,  -93, -100,    0,  -12,    0, -250,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -154,    0,    0,    0,
 -146,    0,    0,    0,    0,    0,    0,    0,    0, -152,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -143,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   -2,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -249,    0,    0,    0,    0,    0,
   -1,    2,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -110,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -121,    0,
    0,   -1,    0, -190,    2,    0,    2,    2,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yycindex[] = {                                      0,
    0,   -5,    0,    3,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -85,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    7,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -170,    0,    0,    0,    0,    0,    9,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   11,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yygindex[] = {                                      0,
   -9,  -21,  206,  -22, -174,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   69,    0,    0,   41, -168,    0,
   79,   47,   51,    8,    0,    0, -188,    0,    0,  187,
  156,    0,  -37,  158,    0,    0,   12,  172,    0,    0,
    0,  135,    0,   22,  -79, -124,    0,    0,    0,  273,
    0,    0,    0,    0,    0,    0,    0,    0,  -30,    0,
  152,    0, -134, -177,   25, -131, -155,    0,    0,    0,
   80,    0,    0,    0,    0,    0,    0,    0,   20,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  214,  -38,
    0,    0,    0,    0,    0,    0,  234,  207,    0,    0,
    0,    0,    0,    0,  241,
};
#define YYTABLESIZE 285
static int yytable[] = {                                      16,
    2,  137,  131,   61,  163,  164,   67,  187,  195,   43,
   30,  196,  209,  121,  198,   49,  151,   19,    3,  205,
  162,   64,   64,   50,   51,   50,   43,   57,   35,  194,
  166,  169,  176,   50,   12,  125,  121,  180,  150,  184,
   17,   84,   14,   50,  243,  181,   70,   64,  180,   74,
  226,   52,   53,   54,   55,   16,   91,  109,  222,   15,
   16,   91,  251,  166,  204,  150,  150,  150,  150,  124,
  255,   94,  257,  258,   71,  218,  159,  159,  159,  159,
  126,  263,  159,   16,   91,  159,   23,  159,   15,   23,
   23,   23,   35,   85,  159,  159,  120,   75,  212,  132,
  121,  102,   13,   23,  159,  159,  159,  159,  213,  245,
  159,  112,   13,  235,  119,   90,  236,  237,  238,  113,
   27,   27,   13,   27,   90,   33,   32,  162,  153,   18,
  239,   30,  218,  162,   27,   27,   33,   33,  162,  154,
  155,  162,   30,   30,  118,  119,   78,   97,   68,   25,
  118,  119,   97,   78,   78,  118,  119,   68,  141,  141,
  148,  148,  126,  141,  133,  141,  132,  148,  126,   28,
  133,   96,  132,  143,  144,  262,   96,  264,  265,  104,
   26,   18,  105,   28,   29,    5,   15,    7,  116,  117,
  230,  231,   32,   35,  246,   15,   29,   37,  214,   45,
   49,   59,   60,   75,   68,   90,  100,   98,  103,  134,
  127,  123,  228,  170,  115,   20,  138,  149,  173,  133,
  159,  142,  186,  131,  140,  247,  172,  247,  183,  189,
  192,  207,  188,  211,  190,  202,  227,  220,  216,  221,
  224,  168,  203,  256,  241,  260,  247,  242,  206,   82,
  108,  254,  250,  252,  253,  114,   96,  128,  266,   94,
  115,   99,  114,   98,  121,   87,   57,    0,   10,   84,
   17,   94,   10,  259,  268,    0,   13,  130,  261,  208,
  267,   86,   69,   65,   89,
};
static int yycheck[] = {                                       9,
    0,  136,  127,   41,  160,  161,   45,  176,  186,   32,
   20,  189,  201,  268,  192,  265,  148,  268,  263,  197,
  155,   43,   44,  273,  258,   35,   49,   37,  259,  185,
  162,  163,  167,  283,  272,  266,  291,  169,  258,  174,
  291,   64,  268,  293,  233,  170,   56,   69,  180,   59,
  219,  285,  286,  287,  288,  263,  263,   96,  214,  273,
  268,  268,  237,  195,  196,  285,  286,  287,  288,  107,
  248,   81,  250,  251,  265,  210,  257,  258,  259,  260,
  111,  256,  263,  291,  291,  266,  277,  268,  273,  280,
  281,  282,  259,  260,  275,  276,  270,  270,  283,  130,
  274,   90,  273,  294,  285,  286,  287,  288,  293,  234,
  291,  284,  283,  277,  103,  259,  280,  281,  282,  292,
  275,  276,  293,  278,  268,  278,  279,  257,  278,  271,
  294,  278,  267,  263,  289,  290,  289,  290,  268,  289,
  290,  271,  289,  290,  257,  257,  268,  263,  259,  266,
  263,  263,  268,  275,  276,  268,  268,  268,  259,  260,
  259,  260,  260,  264,  260,  266,  260,  266,  266,  273,
  266,  263,  266,  275,  276,  255,  268,  257,  258,  258,
  268,  271,  261,  273,  271,  271,  273,  273,  269,  270,
  275,  276,  257,  259,  272,  273,  271,  257,  208,  263,
  257,  257,  263,  270,  259,  259,  264,  260,  259,  291,
  259,  261,  295,  272,  266,   10,  263,  279,  262,  267,
  152,  266,  259,  266,  270,  235,  268,  237,  268,  259,
  259,  265,  268,  259,  262,  195,  268,  272,  265,  272,
  265,  163,  196,  259,  268,  260,  256,  268,  198,   63,
   95,  268,  272,  272,  272,   98,   85,  123,  272,  271,
  273,  268,  273,  268,  273,  268,  268,  273,  262,  268,
  262,  271,  262,  252,  267,  273,    4,  126,  254,  200,
  261,   68,   49,   43,   78,
};
static int yyctable[] = {                                     -1,
    9,   94,  149,   -1,   18,  106,   -1,  106,  115,   -1,
   31,   39,   -1,   21,   42,   -1,  190,   31,   -1,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 295
#if YYDEBUG
static char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"BAR","COLON","COMMA",
"DETERMINES","DOT","LBRACE","LBRACKET","LPAREN","RBRACE","RBRACKET","RPAREN",
"SEMICOLON","FLOAT","NONNEGINT","LOWERWORD","STRING","UPPERWORD","STAR",
"CASEINSENS","CASESENS","CONTEXT","CONSTANT","ENDKEY","EXCEPT","EXTRACT",
"FILTER","FILENAME","HEADER","ISA","ISAM","ISAP","ISAU","KEYWORD","LEXICON",
"MATCHES","OBJECTKEY","SEPARATOR","SUBSTITUTE","USEQUOTE",
};
static char *yyrule[] = {
"$accept : OSM_Module",
"$$1 :",
"OSM_Module : $$1 ORM_DeclList",
"ORM_DeclList : ORM_Declaration SEMICOLON",
"ORM_DeclList : ORM_DeclList ORM_Declaration SEMICOLON",
"ORM_Declaration : ObjectSetDecl",
"ORM_Declaration : RelSetDecl",
"ORM_Declaration : GenSpecDecl",
"ORM_Declaration : LBRACKET STRING RBRACKET",
"$$2 :",
"$$3 :",
"$$4 :",
"$$5 :",
"$$6 :",
"ObjectSetDecl : $$2 ObjectSetName $$3 AliasesOpt $$4 CardinalityConstrOpt $$5 $$6 DataFrameBodyOpt",
"AliasesOpt : ObjectSetAliases",
"AliasesOpt :",
"$$7 :",
"DataFrameBodyOpt : $$7 $$6 DataFrameBody",
"DataFrameBodyOpt :",
"$$8 :",
"$$9 :",
"$$10 :",
"$$11 :",
"DataFrameBody : $$7 $$6 MatchesKey $$8 $$9 MaxLengthOpt $$10 DefCaseSensOpt $$11 FrameComponentList ENDKEY",
"MatchesKey : MATCHES",
"MaxLengthOpt : LBRACKET NONNEGINT RBRACKET",
"MaxLengthOpt :",
"DefCaseSensOpt : CASESENS",
"DefCaseSensOpt : CASEINSENS",
"DefCaseSensOpt :",
"$$12 :",
"FrameComponentList : $$12 FrameComponent",
"$$13 :",
"FrameComponentList : $$12 FrameComponent $$13 FrameComponentList",
"FrameComponent : $$12 LexiconComponent",
"FrameComponent : $$12 ConstantComponent",
"FrameComponent : $$12 KeywordComponent",
"LexiconComponent : LEXICON $$9 LexiconBodyList SEMICOLON",
"$$14 :",
"LexiconBodyList : $$14 $$9 LexiconBody",
"LexiconBodyList : $$12 LexiconBody COMMA $$10 LexiconBodyList",
"$$15 :",
"$$16 :",
"LexiconBody : LexLBraceKey $$15 $$13 $$16 LexiconTagList RBRACE",
"$$17 :",
"$$18 :",
"LexiconBody : LexLBraceKey $$9 $$17 LexiconTagList RBRACE COMMA $$18 LexiconBody",
"LexLBraceKey : LBRACE",
"LexiconTagList : $$9 $$17 LexiconTag",
"$$19 :",
"$$20 :",
"LexiconTagList : $$9 $$17 LexiconTag $$19 $$20 LexiconTagList",
"LexiconTag : ObjectSetName $$13 CaseSensitiveOpt SEMICOLON",
"LexiconTag : FILENAME STRING SEMICOLON",
"LexiconTag : SEPARATOR STRING UseQuoteOpt SEMICOLON",
"UseQuoteOpt : USEQUOTE",
"UseQuoteOpt :",
"$$21 :",
"$$22 :",
"ConstantComponent : CONSTANT $$21 $$13 ConstantBodyList $$22 SEMICOLON",
"ConstantBodyList : $$12 ConstantBody",
"ConstantBodyList : $$12 ConstantBodyList COMMA $$10 ConstantBody",
"$$23 :",
"$$24 :",
"$$25 :",
"ConstantBody : $$12 LBraceKey $$23 $$10 $$24 ConstantTagList RBRACE $$25 ConfidenceValue",
"ConfidenceValue : RealLiteral",
"ConfidenceValue :",
"LBraceKey : LBRACE",
"$$26 :",
"ConstantTagList : $$9 $$26 ConstantTag SEMICOLON",
"ConstantTagList : $$9 $$26 ConstantTag SEMICOLON $$11 $$25 ConstantTagList",
"ConstantTag : CONTEXT PatternList $$10 CaseSensitiveOpt",
"ConstantTag : EXTRACT PatternList $$10 CaseSensitiveOpt",
"ConstantTag : EXCEPT STRING $$10 CaseSensitiveOpt",
"ConstantTag : FILTER STRING UseQuoteOpt",
"ConstantTag : SUBSTITUTE STRING DETERMINES STRING",
"PatternList : PatternComponent",
"PatternList : PatternComponent COMMA PatternList",
"PatternComponent : STRING",
"PatternComponent : ObjectSetName",
"CaseSensitiveOpt : CASESENS",
"CaseSensitiveOpt : CASEINSENS",
"CaseSensitiveOpt :",
"$$27 :",
"KeywordComponent : KEYWORD $$27 $$13 KeywordBodyList SEMICOLON",
"KeywordBodyList : STRING KeywordConfidence",
"KeywordBodyList : STRING KeywordConfidence COMMA $$10 KeywordBodyList",
"KeywordConfidence : RealLiteral",
"KeywordConfidence :",
"ObjectSetAliases : ObjSetAliasList",
"ObjSetAliasList : BAR ObjectSetName",
"ObjSetAliasList : ObjSetAliasList BAR ObjectSetName",
"$$28 :",
"RelSetDecl : $$28 RelSetDeclName RS_AliasesOpt CoOccurrenceListOpt",
"RS_AliasesOpt : RelSetAliases",
"RS_AliasesOpt :",
"CoOccurrenceListOpt : CoOccurrenceList",
"CoOccurrenceListOpt :",
"CoOccurrenceList : CoOccurrenceDecl",
"CoOccurrenceList : CoOccurrenceList COMMA CoOccurrenceDecl",
"CoOccurrenceDecl : LBRACKET ObjectSetNameList DETERMINES CardinalityConstrOpt ObjectSetNameList RBRACKET",
"$$29 :",
"$$30 :",
"RelSetDeclName : FirstRelSetDeclTerm $$29 $$30 RS_DeclTermList",
"$$31 :",
"RS_DeclTermList : $$31 RelSetDeclTerm",
"$$32 :",
"RS_DeclTermList : $$31 RS_DeclTermList $$32 RelSetDeclTerm",
"$$33 :",
"RelSetDeclTerm : LowerWordSeqOpt ObjectSetName $$33 ParticipationConstraint",
"$$34 :",
"FirstRelSetDeclTerm : LowerWordSeqOpt ObjectSetName $$34 ParticipationConstraint",
"LowerWordSeqOpt : LowerWordSeq",
"LowerWordSeqOpt :",
"LowerWordSeq : LOWERWORD",
"LowerWordSeq : LowerWordSeq LOWERWORD",
"RelSetAliases : BAR RelSetName",
"RelSetAliases : RelSetAliases BAR RelSetName",
"CardinalityConstrOpt : CardinalityConstraint",
"CardinalityConstrOpt :",
"CardinalityConstraint : ParticipationConstraint",
"$$35 :",
"ParticipationConstraint : LBRACKET CardConstrBodyOpt $$35 ReplacementTail RBRACKET",
"CardConstrBodyOpt : CardConstraintBody",
"CardConstrBodyOpt :",
"CardConstraintBody : ConstraintTerm1 ConstraintTail",
"ReplacementTail : DETERMINES CardConstraintBody",
"ReplacementTail : DETERMINES OBJECTKEY",
"ReplacementTail : DETERMINES HEADER",
"ReplacementTail :",
"ConstraintTail : ConstrTermList",
"ConstraintTail :",
"ConstrTermList : COMMA ConstraintTerm1",
"ConstrTermList : ConstrTermList COMMA ConstraintTerm1",
"ConstraintTerm1 : ConstraintTerm $$35 ExpectedParticipation",
"$$36 :",
"ConstraintTerm : ConstraintMin $$36 ConstraintMaxOpt",
"ConstraintMaxOpt : COLON ConstraintMax",
"ConstraintMaxOpt : DOT DOT ConstraintMax",
"ConstraintMaxOpt :",
"ConstraintMin : NONNEGINT",
"ConstraintMax : NONNEGINT",
"ConstraintMax : STAR",
"RealLiteral : NONNEGINT",
"RealLiteral : FLOAT",
"ExpectedParticipation : LPAREN RealLiteral COMMA RealLiteral RPAREN",
"ExpectedParticipation :",
"$$37 :",
"$$38 :",
"GenSpecDecl : $$37 ObjectSetNameList $$38 GenSpecKey ObjectSetName",
"GenSpecKey : COLON",
"GenSpecKey : ISA",
"GenSpecKey : ISAM",
"GenSpecKey : ISAP",
"GenSpecKey : ISAU",
"ObjectSetNameList : ObjectSetName",
"ObjectSetNameList : ObjectSetNameList COMMA ObjectSetName",
"ObjectSetName : UpperWordSeq",
"RelSetName : UpperWordSeq RelSetNameTail",
"RelSetName : RelSetName RelSetNameTail",
"RelSetNameTail : LowerWordSeq UpperWordSeq",
"UpperWordSeq : UPPERWORD",
"UpperWordSeq : UpperWordSeq UPPERWORD",
};
#endif
#line 42 "btyaccpa.ske"

//
// YYPOSN is user-defined text position type.
//
#ifndef YYPOSN
#define YYPOSN int
#endif

#ifdef YYREDUCEPOSNFUNC
#define YYCALLREDUCEPOSN(e)   \
	if(reduce_posn) {     \
	  YYREDUCEPOSNFUNC(yyps->pos, &(yyps->psp)[1-yym], &(yyps->vsp)[1-yym], \
			   yym, yyps->psp - yyps->ps, yychar, yyposn, e);       \
	  reduce_posn = 0;    \
	}

#ifndef YYCALLREDUCEPOSNARG
#define YYCALLREDUCEPOSNARG yyps->val
#endif


#define YYPOSNARG(n) ((yyps->psp)[1-yym+(n)-1])
#define YYPOSNOUT    (yyps->pos)
#endif

/* If delete function is not defined by the user, do not delete. */
#ifndef YYDELETEVAL
#  define YYDELETEVAL(v, t) 
#endif

/* If delete function is not defined by the user, do not delete. */
#ifndef YYDELETEPOSN
#  define YYDELETEPOSN(v, t) 
#endif

#define yyclearin (yychar=(-1))

#define yyerrok (yyps->errflag=0)

#ifndef YYSTACKGROWTH
#define YYSTACKGROWTH 16
#endif

#ifndef YYDEFSTACKSIZE
#define YYDEFSTACKSIZE 12
#endif

#ifdef YYDEBUG
int yydebug;
#endif

int yynerrs;

/* These value/posn are taken from the lexer */
YYSTYPE yylval;
YYPOSN  yyposn;

/* These value/posn of the root non-terminal are returned to the caller */
YYSTYPE yyretlval;
YYPOSN  yyretposn;

#define YYABORT  goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#define YYVALID         do { if (yyps->save)          goto yyvalid; } while(0)
#define YYVALID_NESTED  do { if (yyps->save && \
                                 yyps->save->save==0) goto yyvalid; } while(0)

struct yyparsestate {
  yyparsestate *save;        // Previously saved parser state
  int           state;
  int           errflag;
  Yshort       *ssp;         // state stack pointer
  YYSTYPE      *vsp;         // value stack pointer
  YYPOSN       *psp;         // position stack pointer
  YYSTYPE       val;         // value as returned by actions
  YYPOSN        pos;         // position as returned by universal action
  Yshort       *ss;          // state stack base
  YYSTYPE      *vs;          // values stack base
  YYPOSN       *ps;          // position stack base
  int           lexeme;      // index of the conflict lexeme in the lexical queue
  unsigned int  stacksize;   // current maximum stack size
  Yshort        ctry;        // index in yyctable[] for this conflict
};

// Current parser state
static yyparsestate *yyps=0;

// yypath!=NULL: do the full parse, starting at *yypath parser state.
static yyparsestate *yypath=0;

// Base of the lexical value queue
static YYSTYPE *yylvals=0;

// Current posistion at lexical value queue
static YYSTYPE *yylvp=0;

// End position of lexical value queue
static YYSTYPE *yylve=0;

// The last allocated position at the lexical value queue
static YYSTYPE *yylvlim=0;

// Base of the lexical position queue
static YYPOSN *yylpsns=0;

// Current posistion at lexical position queue
static YYPOSN *yylpp=0;

// End position of lexical position queue
static YYPOSN *yylpe=0;

// The last allocated position at the lexical position queue
static YYPOSN *yylplim=0;

// Current position at lexical token queue
static Yshort *yylexp=0;

static Yshort *yylexemes=0;

//
// For use in generated program
//
#define yytrial (yyps->save)
#define yyvsp   (yyps->vsp)
#define yyval   (yyps->val)
#define yydepth (yyps->ssp - yyps->ss)


//
// Local prototypes.
//
int yyparse(void);

int  YYLex1();
int  yyexpand();
void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size);
void YYPCopy(YYPOSN  *to, YYPOSN  *from, int size);
void YYMoreStack(yyparsestate *yyps);
yyparsestate *YYNewState(int size);
void YYFreeState(yyparsestate *p);


#line 1064 "harmony.yacc"

/*========================================================================
 *                      END OF FILE $RCSfile: parser.C,v $
 */
#line 855 "y.tab.c"
#line 186 "btyaccpa.ske"


//
// Parser function
//
int yyparse() {
  int yym, yyn, yystate, yychar, yynewerrflag;
  yyparsestate *yyerrctx = NULL;
  int reduce_posn;

#if YYDEBUG
  char *yys;
  
  if ((yys = getenv("YYDEBUG"))) {
    yyn = *yys;
    if (yyn >= '0' && yyn <= '9')
      yydebug = yyn - '0'; 
  }
#endif
  
  yyps = YYNewState(YYDEFSTACKSIZE);
  yyps->save = 0;
  yynerrs = 0;
  yyps->errflag = 0;
  yychar = (-1);
  
  yyps->ssp = yyps->ss;
  yyps->vsp = yyps->vs;
  yyps->psp = yyps->ps;
  *(yyps->ssp) = yystate = 0;
  

  //
  // Main parsing loop
  //
 yyloop:
  if ((yyn = yydefred[yystate])) {
    goto yyreduce;
  }

  //
  // Read one token
  //
  if (yychar < 0) {
    if ((yychar = YYLex1()) < 0) yychar = 0;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%d]: state %d, reading %d (%s)", 
	     yydepth, (int)yytrial, yystate, yychar, yys);
#ifdef YYDBPR
      printf("<");
      YYDBPR(yylval);
      printf(">");
#endif
      printf("\n"); 
    }
#endif
  }

  //
  // Do we have a conflict?
  //
  if ((yyn = yycindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    int ctry;

    if (yypath) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%d]: CONFLICT in state %d: following successful trial parse\n", 
	       yydepth, (int)yytrial, yystate);
      }
#endif
      // Switch to the next conflict context
      yyparsestate *save = yypath;
      yypath = save->save;
      ctry = save->ctry;
      if (save->state != yystate) 
        goto yyabort;
      YYFreeState(save); 

    } else {

#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%d]: CONFLICT in state %d. ", 
	       yydepth, (int)yytrial, yystate);
        if(yyps->save) {
          printf("ALREADY in conflict. Continue trial parse.");
        } else {
          printf("Start trial parse.");
        }
        printf("\n");
      }
#endif
      yyparsestate *save = YYNewState(yyps->ssp - yyps->ss);
      save->save    = yyps->save;
      save->state   = yystate;
      save->errflag = yyps->errflag;
      save->ssp     = save->ss + (yyps->ssp - yyps->ss);
      save->vsp     = save->vs + (yyps->vsp - yyps->vs);
      save->psp     = save->ps + (yyps->psp - yyps->ps);
      memcpy (save->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(save->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(save->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      ctry = yytable[yyn];
      if (yyctable[ctry] == -1) {
#if YYDEBUG
        if (yydebug && yychar >= 0)
          printf("yydebug[%d]: backtracking 1 token\n", 
		 (int)yytrial);
#endif
        ctry++; 
      }
      save->ctry = ctry;
      if (!yyps->save) {
        // If this is a first conflict in the stack, start saving lexemes
        if (!yylexemes) {
          yylexemes = new Yshort[YYSTACKGROWTH];
          yylvals = new YYSTYPE[YYSTACKGROWTH];
          yylvlim = yylvals + YYSTACKGROWTH; 
          yylpsns = new YYPOSN[YYSTACKGROWTH];
          yylplim = yylpsns + YYSTACKGROWTH; 
        }
        if (yylvp == yylve) {
          yylvp = yylve = yylvals;
	  yylpp = yylpe = yylpsns;
          yylexp = yylexemes;
          if (yychar >= 0) {
            *yylve++ = yylval;
            *yylpe++ = yyposn;
            *yylexp = yychar;
            yychar = -1; 
          } 
        } 
      }
      if (yychar >= 0) {
        yylvp--, yylpp--, yylexp--;
        yychar = -1; 
      }
      save->lexeme = yylvp - yylvals;
      yyps->save = save; 
    }
    if (yytable[yyn] == ctry) {
#if YYDEBUG
      if (yydebug)
        printf("yydebug[%d,%d]: state %d, shifting to state %d\n",
               yydepth, (int)yytrial, yystate, yyctable[ctry]);
#endif
      if (yychar < 0)
        yylvp++, yylpp++, yylexp++;
      yychar = -1;
      if (yyps->errflag > 0) --yyps->errflag;
      yystate = yyctable[ctry];
      goto yyshift; 
    } else {
      yyn = yyctable[ctry];
      goto yyreduce; 
    } 
  }

  //
  // Is action a shift?
  //
  if ((yyn = yysindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%d]: state %d, shifting to state %d\n",
             yydepth, (int)yytrial, yystate, yytable[yyn]);
#endif
    yychar = (-1);
    if (yyps->errflag > 0)  --yyps->errflag;
    yystate = yytable[yyn];
  yyshift:
    if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
      YYMoreStack(yyps);
    }
    *++(yyps->ssp) = yystate;
    *++(yyps->vsp) = yylval;
    *++(yyps->psp) = yyposn;
    goto yyloop;
  }
  if ((yyn = yyrindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    yyn = yytable[yyn];
    goto yyreduce;
  }

  //
  // Action: error
  //
  if (yyps->errflag) goto yyinrecovery;
  yynewerrflag = 1;
  goto yyerrhandler;
yyerrlab:
  yynewerrflag = 0;
yyerrhandler:
  while (yyps->save) { 
    int ctry; 
    yyparsestate *save = yyps->save;
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
             yydepth, (int)yytrial, yystate, yyps->save->state, yylvp - yylvals - yyps->save->lexeme);
#endif
    // Memorize most forward-looking error state in case
    // it's really an error.
    if(yyerrctx==NULL || yyerrctx->lexeme<yylvp-yylvals) {
      // Free old saved error context state
      if(yyerrctx) YYFreeState(yyerrctx);
      // Create and fill out new saved error context state
      yyerrctx = YYNewState(yyps->ssp - yyps->ss);
      yyerrctx->save = yyps->save;
      yyerrctx->state = yystate;
      yyerrctx->errflag = yyps->errflag;
      yyerrctx->ssp = yyerrctx->ss + (yyps->ssp - yyps->ss);
      yyerrctx->vsp = yyerrctx->vs + (yyps->vsp - yyps->vs);
      yyerrctx->psp = yyerrctx->ps + (yyps->psp - yyps->ps);
      memcpy (yyerrctx->ss, yyps->ss, (yyps->ssp - yyps->ss + 1)*sizeof(Yshort));
      YYSCopy(yyerrctx->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      YYPCopy(yyerrctx->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      yyerrctx->lexeme = yylvp - yylvals;
    }
    yylvp  = yylvals   + save->lexeme;
    yylpp  = yylpsns   + save->lexeme;
    yylexp = yylexemes + save->lexeme;
    yychar = -1;
    yyps->ssp = yyps->ss + (save->ssp - save->ss);
    yyps->vsp = yyps->vs + (save->vsp - save->vs);
    yyps->psp = yyps->ps + (save->psp - save->ps);
    memcpy (yyps->ss, save->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
    YYSCopy(yyps->vs, save->vs,  yyps->vsp - yyps->vs + 1);
    YYPCopy(yyps->ps, save->ps,  yyps->psp - yyps->ps + 1);
    ctry = ++save->ctry;
    yystate = save->state;
    // We tried shift, try reduce now
    if ((yyn = yyctable[ctry]) >= 0) {
      goto yyreduce;
    }
    yyps->save = save->save;
    YYFreeState(save);
    //
    // Nothing left on the stack -- error
    //
    if (!yyps->save) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d]: trial parse FAILED, entering ERROR mode\n", 
	       (int)yytrial);
      }
#endif
      // Restore state as it was in the most forward-advanced error
      yylvp  = yylvals   + yyerrctx->lexeme;
      yylpp  = yylpsns   + yyerrctx->lexeme;
      yylexp = yylexemes + yyerrctx->lexeme;
      yychar = yylexp[-1];
      yylval = yylvp[-1];
      yyposn = yylpp[-1];
      yyps->ssp = yyps->ss + (yyerrctx->ssp - yyerrctx->ss);
      yyps->vsp = yyps->vs + (yyerrctx->vsp - yyerrctx->vs);
      yyps->psp = yyps->ps + (yyerrctx->psp - yyerrctx->ps);
      memcpy (yyps->ss, yyerrctx->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      YYSCopy(yyps->vs, yyerrctx->vs,  yyps->vsp - yyps->vs + 1);
      YYPCopy(yyps->ps, yyerrctx->ps,  yyps->psp - yyps->ps + 1);
      yystate = yyerrctx->state;
      YYFreeState(yyerrctx);
      yyerrctx = NULL;
    }
    yynewerrflag = 1; 
  }
  if (yynewerrflag) {
#ifdef YYERROR_DETAILED
    yyerror_detailed("syntax error", yychar, yylval, yyposn);
#else
    yyerror("syntax error");
#endif
  }
  ++yynerrs;
 yyinrecovery:
  if (yyps->errflag < 3) {
    yyps->errflag = 3;
    for (;;) {
      if ((yyn = yysindex[*(yyps->ssp)]) && 
	  (yyn += YYERRCODE) >= 0 &&
          yyn <= YYTABLESIZE && 
	  yycheck[yyn] == YYERRCODE) {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%d]: state %d, ERROR recovery shifts to state %d\n",
                 yydepth, (int)yytrial, *(yyps->ssp), yytable[yyn]);
#endif
        /* Use label yyerrlab, so that compiler does not warn */
        if(yyps->errflag != yyps->errflag) goto yyerrlab;
        yystate = yytable[yyn];
        goto yyshift; 
      } else {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%d]: ERROR recovery discards state %d\n",
                 yydepth, (int)yytrial, *(yyps->ssp));
#endif
        if (yyps->ssp <= yyps->ss) {
	  goto yyabort;
	}
	if(!yytrial) {
	  YYDELETEVAL(yyps->vsp[0],1);
	  YYDELETEPOSN(yyps->psp[0],1);
	}
        --(yyps->ssp);
        --(yyps->vsp);
        --(yyps->psp);
      }
    }
  } else {
    if (yychar == 0) goto yyabort;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%d]: state %d, ERROR recovery discards token %d (%s)\n",
             yydepth, (int)yytrial, yystate, yychar, yys); 
    }
#endif
    if(!yytrial) {
      YYDELETEVAL(yylval,0);
      YYDELETEPOSN(yyposn,0);
    }
    yychar = (-1);
    goto yyloop;
  }

  //
  // Reduce the rule
  //
yyreduce:
  yym = yylen[yyn];
#if YYDEBUG
  if (yydebug) {
    printf("yydebug[%d,%d]: state %d, reducing by rule %d (%s)",
           yydepth, (int)yytrial, yystate, yyn, yyrule[yyn]);
#ifdef YYDBPR
    if (yym) {
      int i;
      printf("<");
      for (i=yym; i>0; i--) {
        if (i!=yym) printf(", ");
        YYDBPR((yyps->vsp)[1-i]);
      }
      printf(">");
    }
#endif
    printf("\n");
  }
#endif
  if (yyps->ssp + 1 - yym >= yyps->ss + yyps->stacksize) {
    YYMoreStack(yyps);
  }

# ifdef _YACC_DEFAULT_ACTION_
  /* "$$ = NULL" default action */
  memset(&yyps->val, 0, sizeof(yyps->val));
# else
  /* RA: bison compatibility: default action is '$$ = $1;' */
  if (yym > 0) yyps->val = (yyps->vsp)[1 - yym];
# endif

  /* Default reduced position is NULL -- no position at all. No
     position will be assigned at trial time and if no position
     handling is present */
  memset(&yyps->pos, 0, sizeof(yyps->pos));

  reduce_posn = 1;

  switch (yyn) {

case 1:
  if (!yytrial)
#line 293 "harmony.yacc"
{ 	initVars();
						
						*OSMX	<< "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" << endl
								<< "<OSM ontologyName=\"" << fileName << "\"" << endl
								<< "xmlns=\"http://www.deg.byu.edu/xml/osmx.xsd\"" << endl
								/*<< "xmlns:jaxb=\"http://java.sun.com/xml/ns/jaxb\"" << endl
*/
								/*<< "xmlns:xjc=\"http://java.sun.com/xml/ns/jaxb/xjc\"" << endl
*/
								<< "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"" << endl
								<< "xsi:schemaLocation=\"http://www.deg.byu.edu/xml/osmx.xsd http://www.deg.byu.edu/xml/osmx.xsd\">" << endl;
					}
#line 1256 "y.tab.c"
break;
case 2:
  if (!yytrial)
#line 304 "harmony.yacc"
{		
						/* print out lexicons
*/
						LexPtr temp = lexStart;
						
						while (temp != NULL) {
							*OSMX	<< "<Lexicon label=\"" << temp->label
									<< "\" uri=\"file///" << temp->url
									<< "\" delimiters=\"" << temp->delimiters
									<< "\" caseSensitive=\"" << temp->caseSens 
									<< "\"/>" << endl;
									

							temp = temp->next;
						}
						
					
						*OSMX << "</OSM>" << endl;
						/*Write_Expressions(); 
*/
					}
#line 1280 "y.tab.c"
break;
case 8:
  if (!yytrial)
#line 333 "harmony.yacc"
{ fprintf(stderr, "General Constraint [%s]\n",
				    Extract_String(yyvsp[-1].p_char));
			  }
#line 1288 "y.tab.c"
break;
case 9:
  if (!yytrial)
#line 341 "harmony.yacc"
{	
						inObjectSet = true;
						objectPrimary = " primary = \"N\"";
						*OSMX << "<ObjectSet id=\""; 	
					}
#line 1298 "y.tab.c"
break;
case 10:
  if (!yytrial)
#line 347 "harmony.yacc"
{	
						name = yyvsp[0].p_char;
						*OSMX << yyvsp[0].p_char << "\"";
						nameList =	"<NameList>" + ENDL +
									"<Name content=\"" + yyvsp[0].p_char + "\"/>" + ENDL;
					}
#line 1309 "y.tab.c"
break;
case 11:
  if (!yytrial)
#line 354 "harmony.yacc"
{	
						nameList += "</NameList>" + ENDL; 
					}
#line 1317 "y.tab.c"
break;
case 12:
#line 358 "harmony.yacc"
yyval.p_char = yyvsp[-4].p_char;
break;
case 13:
#line 358 "harmony.yacc"
yyval.p_cc =  yyvsp[-1].p_cc;
break;
case 14:
  if (!yytrial)
#line 359 "harmony.yacc"
{
						
						*OSMX	<< objectPrimary;
												
						if (yyvsp[0].p_node == NULL) {
							NODE *node = Add_Node(yyvsp[-7].p_char);

							if (yyvsp[-3].p_cc != NULL && yyvsp[-3].p_cc->rp_object)
								node->rp_object = TRUE;

							*OSMX << " lexical=\"N\">" << endl;
						}
						else {
							*OSMX << " lexical=\"Y\">" << endl;
						}

						*OSMX << nameList << dataFrame << "</ObjectSet>" << endl;
						inObjectSet = false;
					}
#line 1349 "y.tab.c"
break;
case 17:
#line 386 "harmony.yacc"
yyval.p_char = yyvsp[-1].p_char;
break;
case 18:
  if (!yytrial)
#line 387 "harmony.yacc"
{ yyval.p_node = yyvsp[0].p_node; }
#line 1359 "y.tab.c"
break;
case 19:
  if (!yytrial)
#line 389 "harmony.yacc"
{ yyval.p_node = NULL; }
#line 1365 "y.tab.c"
break;
case 20:
  if (!yytrial)
#line 393 "harmony.yacc"
{
							/* at this point, either a DataFrame or an error
*/
							dataFrame =		"<DataFrame>" + ENDL +
											"<InternalRepresentation>" + ENDL +
											"<DataType typeName=\"java:java.lang.String\"/>" + ENDL +
											"</InternalRepresentation>" + ENDL;
						}
#line 1377 "y.tab.c"
break;
case 21:
#line 400 "harmony.yacc"
yyval.p_node = yyvsp[-1].p_node;
break;
case 22:
#line 401 "harmony.yacc"
yyval.p_node = yyvsp[-3].p_node;
break;
case 23:
#line 402 "harmony.yacc"
yyval.p_node = yyvsp[-5].p_node;
break;
case 24:
  if (!yytrial)
#line 404 "harmony.yacc"
{
							dataFrame += "</DataFrame>" + ENDL;
						}
#line 1397 "y.tab.c"
  if (!yytrial)
#line 407 "harmony.yacc"
{ yyval.p_node = yyvsp[-8].p_node; }
#line 1401 "y.tab.c"
break;
case 25:
  if (!yytrial)
#line 411 "harmony.yacc"
{
			    yyval.p_node = Add_Node(yyvsp[-2].p_char);
			    if (yyvsp[-1].p_cc != NULL && yyvsp[-1].p_cc->rp_object)
			      yyval.p_node->rp_object = TRUE;
			  }
#line 1411 "y.tab.c"
break;
case 26:
  if (!yytrial)
#line 419 "harmony.yacc"
{ yyvsp[-3].p_node->max_len = yyvsp[-1].num; }
#line 1417 "y.tab.c"
break;
case 28:
  if (!yytrial)
#line 424 "harmony.yacc"
{	yyvsp[-1].p_node->case_sens = TRUE; 
				caseSensitive = " caseSensitive=\"Y\"";}
#line 1424 "y.tab.c"
break;
case 29:
  if (!yytrial)
#line 427 "harmony.yacc"
{ yyvsp[-1].p_node->case_sens = FALSE; }
#line 1430 "y.tab.c"
break;
case 30:
  if (!yytrial)
#line 429 "harmony.yacc"
{ yyvsp[0].p_node->case_sens = FALSE; }
#line 1436 "y.tab.c"
break;
case 31:
#line 432 "harmony.yacc"
yyval.p_node = yyvsp[0].p_node;
break;
case 33:
#line 433 "harmony.yacc"
yyval.p_node = yyvsp[-2].p_node;
break;
case 36:
  if (!yytrial)
#line 441 "harmony.yacc"
{
				dataFrame += constantComponent;
			}
#line 1452 "y.tab.c"
break;
case 37:
  if (!yytrial)
#line 446 "harmony.yacc"
{	
				dataFrame += keywordComponent;
			}
#line 1460 "y.tab.c"
break;
case 39:
  if (!yytrial)
#line 455 "harmony.yacc"
{ /* remove this line and watch it segfault ! */ }
#line 1466 "y.tab.c"
break;
case 42:
  if (!yytrial)
#line 464 "harmony.yacc"
{
						/* create a new lexicon and append to list
*/
						if (lexStart == NULL) {
							lexStart = new struct Lexicon;
							lexEnd = lexStart;
						}
						else {
							LexPtr temp = new struct Lexicon;
							lexEnd->next = temp;
							lexEnd = lexEnd->next;
						}
						
					}
#line 1484 "y.tab.c"
break;
case 43:
#line 477 "harmony.yacc"
yyval.p_lex =  yyvsp[-2].p_lex;
break;
case 45:
#line 481 "harmony.yacc"
yyval.p_lex =  yyvsp[-1].p_lex;
break;
case 46:
#line 484 "harmony.yacc"
yyval.p_node = yyvsp[-6].p_node;
break;
case 48:
  if (!yytrial)
#line 488 "harmony.yacc"
{ yyval.p_lex = Use_Lexicon(); }
#line 1502 "y.tab.c"
break;
case 50:
#line 493 "harmony.yacc"
yyval.p_node = yyvsp[-4].p_node;
break;
case 51:
#line 493 "harmony.yacc"
yyval.p_lex =  yyvsp[-4].p_lex;
break;
case 53:
  if (!yytrial)
#line 496 "harmony.yacc"
{
			    yyvsp[-4].p_lex->name = yyvsp[-3].p_char;
			    yyvsp[-4].p_lex->case_sens = yyvsp[-1].num;
				lexEnd->label = yyvsp[-3].p_char;
				if (yyvsp[-1].num)
					lexEnd->caseSens = "Y";

			  }
#line 1523 "y.tab.c"
break;
case 54:
  if (!yytrial)
#line 505 "harmony.yacc"
{ 
				yyvsp[-3].p_lex->filename = Extract_String(yyvsp[-1].p_char); 
				lexEnd->url = Extract_String(yyvsp[-1].p_char);
			  }
#line 1532 "y.tab.c"
break;
case 55:
  if (!yytrial)
#line 510 "harmony.yacc"
{
			    yyvsp[-4].p_lex->separators = Extract_String(yyvsp[-2].p_char);
			    if (yyvsp[-1].num)
			      strcat(yyvsp[-4].p_lex->separators, "\"");
				lexEnd->delimiters = Extract_String(yyvsp[-2].p_char);
			  }
#line 1543 "y.tab.c"
break;
case 56:
  if (!yytrial)
#line 519 "harmony.yacc"
{ yyval.num = TRUE; }
#line 1549 "y.tab.c"
break;
case 57:
  if (!yytrial)
#line 521 "harmony.yacc"
{ yyval.num = FALSE; }
#line 1555 "y.tab.c"
break;
case 58:
  if (!yytrial)
#line 525 "harmony.yacc"
{
				constantComponent = "<ValuePhraseList>" + ENDL;			
				tempID = 1;
			}
#line 1564 "y.tab.c"
break;
case 59:
  if (!yytrial)
#line 530 "harmony.yacc"
{
				constantComponent += "</ValuePhraseList>" + ENDL;
			}
#line 1572 "y.tab.c"
break;
case 63:
  if (!yytrial)
#line 541 "harmony.yacc"
{
				constantComponent += "<ValuePhrase";
				confidenceValue = -1.0;
				valueExpression = "";
				exceptionExpression = "";
				contextExpression = "";
				subFromExpression = "";
				subToExpression = "";
				caseSensitive = " caseSensitive=\"N\"";
				extract = "";
				context = "";
			}
#line 1589 "y.tab.c"
break;
case 64:
#line 553 "harmony.yacc"
yyval.p_frame =  yyvsp[-2].p_frame;
break;
case 65:
#line 553 "harmony.yacc"
yyval.p_frame = yyvsp[-5].p_frame;
break;
case 66:
  if (!yytrial)
#line 554 "harmony.yacc"
{
				
				constantComponent += " hint=\"" + name + "_" + intToString(tempID++) + "\"";
				if (confidenceValue != -1.0)
					constantComponent += " confidenceTag=\"" + floatToString(confidenceValue) + "\"";
				constantComponent += caseSensitive + ">" + ENDL;
				
				if (extract != "" && context != "")
					contextExpression = LeftAndRightContext(extract, context);

				string valuePhrase = valueExpression + exceptionExpression + contextExpression + 
									 subFromExpression + subToExpression;
				constantComponent += valuePhrase + "</ValuePhrase>" + ENDL;
			}
#line 1616 "y.tab.c"
break;
case 67:
  if (!yytrial)
#line 571 "harmony.yacc"
{	yyvsp[-1].p_frame->confidence = yyvsp[0].fval; 
					confidenceValue = yyvsp[0].fval;
				}
#line 1624 "y.tab.c"
break;
case 68:
  if (!yytrial)
#line 575 "harmony.yacc"
{	yyvsp[0].p_frame->confidence = -1;
					confidenceValue = -1.0;
				}
#line 1632 "y.tab.c"
break;
case 69:
  if (!yytrial)
#line 581 "harmony.yacc"
{ yyval.p_frame = Use_Framec(yyvsp[-1].p_node); }
#line 1638 "y.tab.c"
break;
case 70:
#line 585 "harmony.yacc"
yyval.p_frame =  yyvsp[-1].p_frame;
break;
case 73:
  if (!yytrial)
#line 591 "harmony.yacc"
{		
				/* output determined by LeftAndRightContext function, called in ConstantBody
*/
				context = yyvsp[-2].p_char;
			  	  
				yyvsp[-4].p_frame->context = yyvsp[-2].p_char;
			    yyvsp[-4].p_frame->cs_context = yyvsp[0].num;
			  }
#line 1654 "y.tab.c"
break;
case 74:
  if (!yytrial)
#line 599 "harmony.yacc"
{ 
				valueExpression =	"<ValueExpression>" + ENDL + 
									"<ExpressionText>" + yyvsp[-2].p_char + "</ExpressionText>" + ENDL +
									"</ValueExpression>" + ENDL;
				extract = yyvsp[-2].p_char;
				yyvsp[-4].p_frame->extract = yyvsp[-2].p_char;
			    yyvsp[-4].p_frame->cs_extract = yyvsp[0].num;
			  }
#line 1667 "y.tab.c"
break;
case 75:
  if (!yytrial)
#line 608 "harmony.yacc"
{ exceptionExpression =	"<ExceptionExpression>" + ENDL + 
										"<ExpressionText>" + Extract_String(yyvsp[-2].p_char) + "</ExpressionText>" + ENDL +
										"</ExceptionExpression>" + ENDL;
			  	yyvsp[-4].p_frame->except = yyvsp[-2].p_char;
			    yyvsp[-4].p_frame->cs_except = yyvsp[0].num;
			  }
#line 1678 "y.tab.c"
break;
case 76:
  if (!yytrial)
#line 615 "harmony.yacc"
{ yyvsp[-3].p_frame->filter = yyvsp[-1].p_char;
			    yyvsp[-3].p_frame->use_quote = yyvsp[0].num;
			  }
#line 1686 "y.tab.c"
break;
case 77:
  if (!yytrial)
#line 619 "harmony.yacc"
{ subFromExpression =	"<SubFromExpression>" + ENDL + 
									"<ExpressionText>" + Extract_String(yyvsp[-2].p_char) + "</ExpressionText>" + ENDL +
									"</SubFromExpression>" + ENDL;
				subToExpression =	"<SubToExpression>" + ENDL + 
									"<ExpressionText>" + Extract_String(yyvsp[0].p_char) + "</ExpressionText>" + ENDL +
									"</SubToExpression>" + ENDL;

				
				yyvsp[-4].p_frame->subst1 = yyvsp[-2].p_char;
			    yyvsp[-4].p_frame->subst2 = yyvsp[0].p_char;
			  }
#line 1702 "y.tab.c"
break;
case 78:
  if (!yytrial)
#line 633 "harmony.yacc"
{ yyval.p_char = yyvsp[0].p_char; }
#line 1708 "y.tab.c"
break;
case 79:
  if (!yytrial)
#line 635 "harmony.yacc"
{ yyval.p_char = Append_String(yyvsp[-2].p_char, "", yyvsp[0].p_char); }
#line 1714 "y.tab.c"
break;
case 80:
  if (!yytrial)
#line 639 "harmony.yacc"
{ yyval.p_char = Extract_String(yyvsp[0].p_char); }
#line 1720 "y.tab.c"
break;
case 81:
  if (!yytrial)
#line 641 "harmony.yacc"
{ yyval.p_char = Append_String("{", yyvsp[0].p_char, "}"); }
#line 1726 "y.tab.c"
break;
case 82:
  if (!yytrial)
#line 645 "harmony.yacc"
{	caseSensitive = " caseSensitive=\"Y\"";
				yyval.num = TRUE; }
#line 1733 "y.tab.c"
break;
case 83:
  if (!yytrial)
#line 648 "harmony.yacc"
{ yyval.num = FALSE; }
#line 1739 "y.tab.c"
break;
case 84:
  if (!yytrial)
#line 650 "harmony.yacc"
{ yyval.num = yyvsp[0].p_node->case_sens; }
#line 1745 "y.tab.c"
break;
case 85:
  if (!yytrial)
#line 654 "harmony.yacc"
{	
					keywordComponent = "<KeywordPhraseList>" + ENDL; 
					tempID = 1;
				}
#line 1754 "y.tab.c"
break;
case 86:
  if (!yytrial)
#line 659 "harmony.yacc"
{	keywordComponent += "</KeywordPhraseList>" + ENDL; }
#line 1760 "y.tab.c"
break;
case 87:
  if (!yytrial)
#line 663 "harmony.yacc"
{ 
				Add_Keyword(yyvsp[-2].p_node, yyvsp[-1].p_char, yyvsp[0].fval); 
				keywordComponent += "<KeywordPhrase hint=\"" + name + "_keyword_" + intToString(tempID++) + "\"";
				if (yyvsp[0].fval != -1.0)
					 keywordComponent +=  " confidenceTag=\"" + floatToString(yyvsp[0].fval) + string("\"");
				
				keywordComponent += ">" + ENDL +
					 "<KeywordExpression>" + ENDL +
					 "<ExpressionText>" + Extract_String(yyvsp[-1].p_char) + "</ExpressionText>" + ENDL + 
					 "</KeywordExpression>" + ENDL +
					 "</KeywordPhrase>" + ENDL;
			  }
#line 1777 "y.tab.c"
break;
case 88:
  if (!yytrial)
#line 678 "harmony.yacc"
{ 							  
				Add_Keyword(yyvsp[-5].p_node, yyvsp[-4].p_char, yyvsp[-3].fval); 
				keywordComponent += "<KeywordPhrase hint=\"" + name + "_keyword_" + intToString(tempID++) + "\"";
				if (yyvsp[-3].fval != -1.0)
					keywordComponent += " confidenceTag=\"" + floatToString(yyvsp[-3].fval) + "\"";
				
				keywordComponent += ">" + ENDL +
					 "<KeywordExpression>" + ENDL +
					 "<ExpressionText>" + Extract_String(yyvsp[-4].p_char) + "</ExpressionText>" + ENDL + 
					 "</KeywordExpression>" + ENDL + 
					 "</KeywordPhrase>" + ENDL;
			  }
#line 1794 "y.tab.c"
break;
case 89:
  if (!yytrial)
#line 693 "harmony.yacc"
{ yyval.fval = yyvsp[0].fval; }
#line 1800 "y.tab.c"
break;
case 90:
  if (!yytrial)
#line 695 "harmony.yacc"
{ yyval.fval = (float)-1.0; }
#line 1806 "y.tab.c"
break;
case 92:
  if (!yytrial)
#line 703 "harmony.yacc"
{ 
						nameList += "<Name content=\"" + string(yyvsp[0].p_char) + "\"/>" + ENDL; 
					}
#line 1814 "y.tab.c"
break;
case 93:
  if (!yytrial)
#line 707 "harmony.yacc"
{ 
						nameList += "<Name content=\"" + string(yyvsp[0].p_char) + "\"/>" + ENDL; 
					}
#line 1822 "y.tab.c"
break;
case 94:
  if (!yytrial)
#line 716 "harmony.yacc"
{	isBinary = false;
				isTernary = false;
				binaryName = "";
				ternaryName = "";
			}
#line 1832 "y.tab.c"
break;
case 95:
  if (!yytrial)
#line 722 "harmony.yacc"
{
				*OSMX	<< "<RelationshipSet id=\"" << ID++ << "\">" << endl
						<< nameList
						<< connections
						<< "</RelationshipSet>" << endl;
			}
#line 1843 "y.tab.c"
break;
case 102:
  if (!yytrial)
#line 746 "harmony.yacc"
{ Num_spec_names = 0; }
#line 1849 "y.tab.c"
break;
case 103:
  if (!yytrial)
#line 750 "harmony.yacc"
{
					nameList =	"<NameList>" + ENDL +
								"<Name content=\"";
				}
#line 1858 "y.tab.c"
break;
case 104:
#line 754 "harmony.yacc"
yyval.p_edge = yyvsp[-1].p_edge;
break;
case 105:
  if (!yytrial)
#line 755 "harmony.yacc"
{
					if (isTernary) 
						nameList += ternaryName + "\"/>" + ENDL;
					else if (isBinary) 
						nameList += binaryName + "\"/>" + ENDL;
									
					nameList += "</NameList>" + ENDL;
				}
#line 1875 "y.tab.c"
break;
case 106:
#line 766 "harmony.yacc"
yyval.p_edge = yyvsp[0].p_edge;
break;
case 108:
#line 767 "harmony.yacc"
yyval.p_edge = yyvsp[-2].p_edge;
break;
case 110:
  if (!yytrial)
#line 772 "harmony.yacc"
{
				if (binaryName != "")
					binaryName += " " + string(yyvsp[-1].p_char);
				else
					binaryName += yyvsp[-1].p_char;

				if (string(yyvsp[-1].p_char) != "")
					ternaryName += " " + string(yyvsp[-1].p_char) + " " + string(yyvsp[0].p_char);
				else
					ternaryName += " " + string(yyvsp[0].p_char);
								
				if (isBinary)
					isTernary = true;
				isBinary = true;

				connections +=	"<Connection objectSet=\"" + string(yyvsp[0].p_char) + "\">" + ENDL +
								/*string(" isDomainSide=\"N\">") + ENDL;
*/
								"<ParticipationConstraint>" + ENDL +
								+ "<Text content=\"";
				partic = "";

			  }
#line 1910 "y.tab.c"
break;
case 111:
  if (!yytrial)
#line 795 "harmony.yacc"
{
			    if (strlen(yyvsp[-3].p_char) > 0)
			      Add_Edge_Name(yyvsp[-3].p_char, yyvsp[-4].p_edge);
			    Add_Edge_Name(yyvsp[-2].p_char, yyvsp[-4].p_edge);
			    Add_Connection(yyvsp[-3].p_char, Add_Node(yyvsp[-2].p_char),
					   yyvsp[0].p_cc->pc_optional,
					   yyvsp[0].p_cc->pc_multiple,
					   yyvsp[0].p_cc->pc_mean,
					   yyvsp[0].p_cc->pc_stddev,
					   yyvsp[0].p_cc->replace,
					   yyvsp[0].p_cc->rp_optional,
					   yyvsp[0].p_cc->rp_multiple,
					   yyvsp[-4].p_edge);
				
				connections +=	partic + "\"/>" + ENDL +
								"</ParticipationConstraint>" + ENDL +
								"</Connection>" + ENDL;
			  }
#line 1933 "y.tab.c"
break;
case 112:
  if (!yytrial)
#line 817 "harmony.yacc"
{
				binaryName += yyvsp[-1].p_char;
				if (string(yyvsp[-1].p_char) != "")
					ternaryName += yyvsp[-1].p_char + string(" ") + yyvsp[0].p_char;
				else
					ternaryName += yyvsp[0].p_char;

				connections =	"<Connection objectSet=\"" + string(yyvsp[0].p_char) + "\">" + ENDL +
								/*string(" isDomainSide=\"Y\">") + ENDL
*/
								"<ParticipationConstraint>" + ENDL
								+ "<Text content=\"";
				partic = "";

			  }
#line 1952 "y.tab.c"
break;
case 113:
  if (!yytrial)
#line 832 "harmony.yacc"
{ EDGE	*e;
			    if (strlen(yyvsp[-3].p_char) > 0) {
			      e = Add_Edge(yyvsp[-3].p_char);
			      Add_Edge_Name(yyvsp[-2].p_char, e);
			    } else {
			      e = Add_Edge(yyvsp[-2].p_char);
			    }
			    Add_Connection(yyvsp[-3].p_char, Add_Node(yyvsp[-2].p_char),
					   yyvsp[0].p_cc->pc_optional,
					   yyvsp[0].p_cc->pc_multiple,
					   yyvsp[0].p_cc->pc_mean,
					   yyvsp[0].p_cc->pc_stddev,
					   yyvsp[0].p_cc->replace,
					   yyvsp[0].p_cc->rp_optional,
					   yyvsp[0].p_cc->rp_multiple,
					   e);
			    yyval.p_edge = e;

				connections +=	partic + "\"/>" + ENDL +
								"</ParticipationConstraint>" + ENDL +
								"</Connection>" + ENDL;
			  }
#line 1979 "y.tab.c"
break;
case 114:
  if (!yytrial)
#line 857 "harmony.yacc"
{ yyval.p_char = yyvsp[0].p_char; }
#line 1985 "y.tab.c"
break;
case 115:
  if (!yytrial)
#line 859 "harmony.yacc"
{ yyval.p_char = ""; }
#line 1991 "y.tab.c"
break;
case 116:
  if (!yytrial)
#line 864 "harmony.yacc"
{ yyval.p_char = yyvsp[0].p_char; }
#line 1997 "y.tab.c"
break;
case 117:
  if (!yytrial)
#line 866 "harmony.yacc"
{ yyval.p_char = Append_String(yyvsp[-1].p_char, " ", yyvsp[0].p_char); }
#line 2003 "y.tab.c"
break;
case 120:
  if (!yytrial)
#line 877 "harmony.yacc"
{ yyval.p_cc = yyvsp[0].p_cc; }
#line 2009 "y.tab.c"
break;
case 121:
  if (!yytrial)
#line 879 "harmony.yacc"
{ yyval.p_cc = NULL; }
#line 2015 "y.tab.c"
break;
case 122:
  if (!yytrial)
#line 883 "harmony.yacc"
{ yyval.p_cc = yyvsp[0].p_cc; }
#line 2021 "y.tab.c"
break;
case 123:
#line 886 "harmony.yacc"
yyval.p_cc = yyvsp[0].p_cc;
break;
case 124:
  if (!yytrial)
#line 888 "harmony.yacc"
{ yyval.p_cc = yyvsp[-3].p_cc; }
#line 2031 "y.tab.c"
break;
case 125:
  if (!yytrial)
#line 892 "harmony.yacc"
{ yyval.p_cc = yyvsp[0].p_cc; }
#line 2037 "y.tab.c"
break;
case 126:
  if (!yytrial)
#line 894 "harmony.yacc"
{
			    PCONSTR *cc = new PCONSTR;

			    cc->replace = FALSE;
			    cc->rp_object = FALSE;
			    cc->rp_header = FALSE;
			    yyval.p_cc = cc;
			  }
#line 2050 "y.tab.c"
break;
case 127:
  if (!yytrial)
#line 905 "harmony.yacc"
{ yyval.p_cc = yyvsp[-1].p_cc; }
#line 2056 "y.tab.c"
break;
case 128:
  if (!yytrial)
#line 909 "harmony.yacc"
{
			    yyvsp[-2].p_cc->replace = TRUE;
			    yyvsp[-2].p_cc->rp_optional = yyvsp[0].p_cc->pc_optional;
			    yyvsp[-2].p_cc->rp_multiple = yyvsp[0].p_cc->pc_multiple;
			  }
#line 2066 "y.tab.c"
break;
case 129:
  if (!yytrial)
#line 915 "harmony.yacc"
{	
				if (inObjectSet) {
					objectPrimary = " primary=\"Y\""; }
		
				yyvsp[-2].p_cc->rp_object = TRUE; 
			}
#line 2077 "y.tab.c"
break;
case 130:
  if (!yytrial)
#line 922 "harmony.yacc"
{ 
				yyvsp[-2].p_cc->rp_header = TRUE; 
			}
#line 2085 "y.tab.c"
break;
case 137:
#line 939 "harmony.yacc"
yyval.num = yyvsp[0].num;
break;
case 138:
  if (!yytrial)
#line 940 "harmony.yacc"
{ yyval.p_cc = new PCONSTR;
			    yyval.p_cc->pc_optional = (yyvsp[-2].num < 1);
			    yyval.p_cc->pc_multiple = (yyvsp[0].num != 1);
			    yyval.p_cc->replace = FALSE;
			    yyval.p_cc->rp_object = FALSE;
			    yyval.p_cc->rp_header = FALSE;
			    yyval.p_cc->pc_mean = -1.0;
			    yyval.p_cc->pc_stddev = -1.0;
				
				sprintf(buffer, "%d", yyvsp[-2].num);
				partic += buffer + string(":");
				if (yyvsp[0].num == PC_STAR)
					partic += "*";
				else {
					sprintf(buffer, "%d", yyvsp[0].num);
					partic += buffer;
				}
			  }
#line 2112 "y.tab.c"
break;
case 139:
  if (!yytrial)
#line 962 "harmony.yacc"
{ yyval.num = yyvsp[0].num; }
#line 2118 "y.tab.c"
break;
case 140:
  if (!yytrial)
#line 964 "harmony.yacc"
{ yyval.num = yyvsp[0].num; }
#line 2124 "y.tab.c"
break;
case 141:
  if (!yytrial)
#line 966 "harmony.yacc"
{ yyval.num = yyvsp[0].num; }
#line 2130 "y.tab.c"
break;
case 142:
  if (!yytrial)
#line 970 "harmony.yacc"
{ yyval.num = yyvsp[0].num; }
#line 2136 "y.tab.c"
break;
case 143:
  if (!yytrial)
#line 974 "harmony.yacc"
{ yyval.num = yyvsp[0].num; }
#line 2142 "y.tab.c"
break;
case 144:
  if (!yytrial)
#line 976 "harmony.yacc"
{ yyval.num = PC_STAR; }
#line 2148 "y.tab.c"
break;
case 145:
  if (!yytrial)
#line 980 "harmony.yacc"
{ yyval.fval = (float)yyvsp[0].num; }
#line 2154 "y.tab.c"
break;
case 146:
  if (!yytrial)
#line 982 "harmony.yacc"
{ yyval.fval = yyvsp[0].fval; }
#line 2160 "y.tab.c"
break;
case 147:
  if (!yytrial)
#line 987 "harmony.yacc"
{ yyvsp[-5].p_cc->pc_mean = yyvsp[-3].fval;
			    yyvsp[-5].p_cc->pc_stddev = yyvsp[-1].fval;
			  }
#line 2168 "y.tab.c"
break;
case 149:
  if (!yytrial)
#line 997 "harmony.yacc"
{ 
					inGenSpec = true;
					*OSMX << "<GenSpec>" << endl;
					specializations = "";
				}
#line 2178 "y.tab.c"
break;
case 150:
  if (!yytrial)
#line 1003 "harmony.yacc"
{
					inGenSpec = false;
				}
#line 2186 "y.tab.c"
break;
case 151:
  if (!yytrial)
#line 1007 "harmony.yacc"
{	NODE	*obj_set;
			  
					for (int i = 0; i < Num_spec_names; i++) {
						obj_set = Add_Node(Spec_name[i]);
						obj_set->parent = Add_Node(yyvsp[0].p_char);
					}
					Num_spec_names = 0;
					
					*OSMX	<< "<GenConnection objectSet=\"" << yyvsp[0].p_char << "\"/>" << endl
							<< specializations
							<< "</GenSpec>" << endl;
					inGenSpec = false;
				}
#line 2204 "y.tab.c"
break;
case 157:
  if (!yytrial)
#line 1033 "harmony.yacc"
{ strcpy(Spec_name[Num_spec_names++], yyvsp[0].p_char); }
#line 2210 "y.tab.c"
break;
case 158:
  if (!yytrial)
#line 1035 "harmony.yacc"
{ strcpy(Spec_name[Num_spec_names++], yyvsp[0].p_char); }
#line 2216 "y.tab.c"
break;
case 159:
  if (!yytrial)
#line 1039 "harmony.yacc"
{ 
						if (inGenSpec)
							specializations += "<SpecConnection objectSet=\"" + string(yyvsp[0].p_char) + "\"/>" + ENDL;

						yyval.p_char = yyvsp[0].p_char; 
					}
#line 2227 "y.tab.c"
break;
case 163:
  if (!yytrial)
#line 1055 "harmony.yacc"
{ yyval.p_char = yyvsp[0].p_char; }
#line 2233 "y.tab.c"
break;
case 164:
  if (!yytrial)
#line 1057 "harmony.yacc"
{ yyval.p_char = Append_String(yyvsp[-1].p_char, "", yyvsp[0].p_char); }
#line 2239 "y.tab.c"
break;
#line 2241 "y.tab.c"
#line 573 "btyaccpa.ske"

  default:
    break;
  }

#if YYDEBUG && defined(YYDBPR)
  if (yydebug) {
    printf("yydebug[%d]: after reduction, result is ", yytrial);
    YYDBPR(yyps->val);
    printf("\n");
  }
#endif

  // Perform user-defined position reduction
#ifdef YYREDUCEPOSNFUNC
  if(!yytrial) {
    YYCALLREDUCEPOSN(YYREDUCEPOSNFUNCARG);
  }
#endif

  yyps->ssp -= yym;
  yystate = *(yyps->ssp);
  yyps->vsp -= yym;
  yyps->psp -= yym;

  yym = yylhs[yyn];
  if (yystate == 0 && yym == 0) {
#if YYDEBUG
    if (yydebug) {
      printf("yydebug[%d,%d]: after reduction, shifting from state 0 to state %d\n", 
	     yydepth, (int)yytrial, YYFINAL);
    }
#endif
    yystate = YYFINAL;
    *++(yyps->ssp) = YYFINAL;
    *++(yyps->vsp) = yyps->val;
    yyretlval = yyps->val;	// return value of root non-terminal to yylval
    *++(yyps->psp) = yyps->pos;
    yyretposn = yyps->pos;	// return value of root position to yyposn
    if (yychar < 0) {
      if ((yychar = YYLex1()) < 0) {
        yychar = 0;
      }
#if YYDEBUG
      if (yydebug) {
        yys = 0;
        if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
        if (!yys) yys = "illegal-symbol";
        printf("yydebug[%d,%d]: state %d, reading %d (%s)\n", 
	       yydepth, (int)yytrial, YYFINAL, yychar, yys); 
      }
#endif
    }
    if (yychar == 0) goto yyaccept;
    goto yyloop;
  }

  if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yystate) {
    yystate = yytable[yyn];
  } else {
    yystate = yydgoto[yym];
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%d]: after reduction, shifting from state %d to state %d\n",
           yydepth, (int)yytrial, *(yyps->ssp), yystate);
#endif
  if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
    YYMoreStack(yyps);
  }
  *++(yyps->ssp) = yystate;
  *++(yyps->vsp) = yyps->val;
  *++(yyps->psp) = yyps->pos;
  goto yyloop;


  //
  // Reduction declares that this path is valid.
  // Set yypath and do a full parse
  //
yyvalid:
  if (yypath) {
    goto yyabort;
  }
  while (yyps->save) {
    yyparsestate *save = yyps->save;
    yyps->save = save->save;
    save->save = yypath;
    yypath = save;
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%d]: CONFLICT trial successful, backtracking to state %d, %d tokens\n",
           yydepth, (int)yytrial, yypath->state, yylvp - yylvals - yypath->lexeme);
#endif
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  yychar = -1;
  yyps->ssp = yyps->ss + (yypath->ssp - yypath->ss);
  yyps->vsp = yyps->vs + (yypath->vsp - yypath->vs);
  yyps->psp = yyps->ps + (yypath->psp - yypath->ps);
  memcpy (yyps->ss, yypath->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
  YYSCopy(yyps->vs, yypath->vs,  yyps->vsp - yyps->vs + 1);
  YYPCopy(yyps->ps, yypath->ps,  yyps->psp - yyps->ps + 1);
  yylvp = yylvals + yypath->lexeme;
  yylpp = yylpsns + yypath->lexeme;
  yylexp = yylexemes + yypath->lexeme;
  yystate = yypath->state;
  goto yyloop;


yyabort:
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }

  YYSTYPE *pv;
  for(pv=yyps->vs; pv<yyps->vsp; pv++) {
    YYDELETEVAL(*pv,2);
  }

  YYPOSN *pp;
  for(pp=yyps->ps; pp<yyps->psp; pp++) {
    YYDELETEPOSN(*pp,2);
  }

  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (1);


yyaccept:
  if (yyps->save) goto yyvalid;
  if(yyerrctx) {
    YYFreeState(yyerrctx); yyerrctx = NULL;
  }
  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    YYFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    YYFreeState(save); 
  }
  return (0);
}


int YYLex1() {
  if(yylvp<yylve) {
    yylval = *yylvp++;
    yyposn = *yylpp++;
    return *yylexp++;
  } else {
    if(yyps->save) {
      if(yylvp==yylvlim) {
	yyexpand();
      }
      *yylexp = yylex();
      *yylvp++ = yylval;
      yylve++;
      *yylpp++ = yyposn;
      yylpe++;
      return *yylexp++;
    } else {
      return yylex();
    }
  }
}

int yyexpand() {
  int p = yylvp-yylvals;
  int s = yylvlim-yylvals;
  s += YYSTACKGROWTH;
  { Yshort  *tl = yylexemes; 
    YYSTYPE *tv = yylvals;
    YYPOSN  *tp = yylpsns;
    yylvals = new YYSTYPE[s];
    yylpsns = new YYPOSN[s];
    yylexemes = new Yshort[s];
    memcpy(yylexemes, tl, (s-YYSTACKGROWTH)*sizeof(Yshort));
    YYSCopy(yylvals, tv, s-YYSTACKGROWTH);
    YYPCopy(yylpsns, tp, s-YYSTACKGROWTH);
    delete[] tl;
    delete[] tv;
    delete[] tp;
  }
  yylvp = yylve = yylvals + p;
  yylvlim = yylvals + s;
  yylpp = yylpe = yylpsns + p;
  yylplim = yylpsns + s;
  yylexp = yylexemes + p;
  return 0;
}

void YYSCopy(YYSTYPE *to, YYSTYPE *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYPCopy(YYPOSN *to, YYPOSN *from, int size) {
  int i;                             
  for (i = size-1; i >= 0; i--) {
    to[i] = from[i];
  }
}

void YYMoreStack(yyparsestate *yyps) {
  int p = yyps->ssp - yyps->ss;                               
  Yshort  *tss = yyps->ss;
  YYSTYPE *tvs = yyps->vs;
  YYPOSN  *tps = yyps->ps;
  yyps->ss = new Yshort [yyps->stacksize + YYSTACKGROWTH];   
  yyps->vs = new YYSTYPE[yyps->stacksize + YYSTACKGROWTH];  
  yyps->ps = new YYPOSN [yyps->stacksize + YYSTACKGROWTH];  
  memcpy(yyps->ss, tss, yyps->stacksize * sizeof(Yshort));  
  YYSCopy(yyps->vs, tvs, yyps->stacksize);                  
  YYPCopy(yyps->ps, tps, yyps->stacksize);                  
  yyps->stacksize += YYSTACKGROWTH;                           
  delete[] tss;
  delete[] tvs;
  delete[] tps;
  yyps->ssp = yyps->ss + p;                                   
  yyps->vsp = yyps->vs + p;                                   
  yyps->psp = yyps->ps + p;                                   
}

yyparsestate *YYNewState(int size) {
  yyparsestate *p = new yyparsestate;
  p->stacksize = size+4;
  p->ss = new Yshort [size + 4];
  p->vs = new YYSTYPE[size + 4];
  p->ps = new YYPOSN [size + 4];
  memset(&p->vs[0], 0, (size+4)*sizeof(YYSTYPE));
  memset(&p->ps[0], 0, (size+4)*sizeof(YYPOSN));
  return p;
}

void YYFreeState(yyparsestate *p) {
  delete[] p->ss;
  delete[] p->vs;
  delete[] p->ps;
  delete p;
}
