/*
 * KeywordListOwner.java
 *
 * Created on July 24, 2003, 3:31 PM
 */

package edu.byu.deg.osmx;

/** An interface that serves to classify elements that may contain a list of
 * {@link edu.byu.deg.osmx.binding.KeywordPhraseType KeywordPhraseType}
 * elements.  These include data frames, value phrases, methods, and parameters.
 * @author Alan
 * @see edu.byu.deg.osmx.binding.KeywordPhraseType
 * @see edu.byu.deg.osmx.binding.DataFrameType
 * @see edu.byu.deg.osmx.binding.ValuePhraseType
 * @see edu.byu.deg.osmx.binding.MethodType
 * @see edu.byu.deg.osmx.binding.ParameterType
 */
public interface KeywordListOwner {
  
  /** Returns the owned list of {@link edu.byu.deg.osmx.binding.KeywordPhraseType }, if
   * any.
   * @return The list of <CODE>KeywordPhraseType</CODE> owned by <CODE>this</CODE>.
   */  
  public java.util.List getKeywordPhrase();
}
