/*
 * ModelContainer.java
 *
 * Created on March 17, 2004, 12:41 AM
 */

package edu.byu.deg.osmx;

import edu.byu.deg.osmx.binding.OSMType;

/**
 * Represents an element or object that is allowed to contain an <CODE>OSM</CODE>
 * element (and thus a sub-model).  These include {@link OSMXDocument} and the elements with the
 * <CODE>highLevel</CODE> attribute, including <CODE>ObjectSet</CODE>,
 * <CODE>RelationshipSet</CODE>, <CODE>State</CODE>, and <CODE>Transition</CODE>.
 * @author Alan Wessman
 */
public interface ModelContainer {
    
    /**
     * Returns a reference to the contained sub-model root.
     * @return The root <CODE>OSM</CODE> element of the contained sub-model.
     */    
    public OSMType getOSM();
    
    /**
     * Sets the given <CODE>OSM</CODE> element as the new sub-model root.
     * @param value The root of the new sub-model.
     */    
    public void setOSM(OSMType value);
    
}
