<?xml version="1.0" encoding="UTF-8"?>
<!--
Document   : OSM-DTD-To-Schema.xsl

Modified on:  August 8, 2003  by  Paul
Description:  Updated stylesheet to conform to rev. 1.24 of osmx.xsd.  
Each element has been tested and appears to work.

Created on : April 12, 2003, 7:40 PM
Author     : Alan
Description:
Responsible for transforming OSM-X documents that use the old DTD into
documents based on the latest OSM-X Schema.

-->
<!DOCTYPE stylesheet [
	<!ENTITY space "<xsl:text> </xsl:text>">
	<!ENTITY cr "<xsl:text>
</xsl:text>">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://www.deg.byu.edu/xml/osmx.xsd">
	<xsl:output method="xml" version="1.0" encoding="UTF-8"/>
	<!--xsl:strip-space elements=""/>
	<xsl:preserve-space elements="node()"/-->

	<!-- template rule matching source root element -->
	<xsl:template match="/">&cr;
		<xsl:comment>Migrated from DTD to XML Schema</xsl:comment>&cr;
		<xsl:apply-templates select="./OSM"/>
		<!--xsl:call-template name="DocumentNode"/-->
	</xsl:template>

	<!-- preserve comments from the original document -->
	<xsl:template match="comment()">
		<xsl:copy/>&cr;
	</xsl:template>

	<!-- migrate the root OSM element -->
	<xsl:template match="/OSM">
		<xsl:apply-templates select="preceding-sibling::comment()" />
		<xsl:element name="OSM">
			<xsl:attribute name="version">1.0</xsl:attribute>
			<xsl:attribute name="xsi:schemaLocation">http://www.deg.byu.edu/xml/osmx.xsd http://www.deg.byu.edu/xml/osmx.xsd</xsl:attribute>
			<xsl:if test="@ontologyName">
				<xsl:attribute name="ontologyName"><xsl:value-of select="@ontologyName"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@width">
				<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@height">
				<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;  		
				<!-- A carriage return is output only if there are children .  	Placing a "&cr;" after the last attribute yields text in between the  
					starting and closing tags.  If the XML to be transformed contains an empty tag, the transformed code will not validate. -->
			</xsl:if>
			<xsl:apply-templates select="./*"/>
		</xsl:element>
		<xsl:apply-templates select="following-sibling::comment()"/>
	</xsl:template>

	<!--	migrate other OSM elements -->
	<xsl:template match="OSM">
		<xsl:element name="OSM">
			<xsl:if test="@ontologyName">
				<xsl:attribute name="ontologyName"><xsl:value-of select="@ontologyName"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@width">
				<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@height">
				<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>
			</xsl:if>
				<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>
			<xsl:apply-templates select="./*"/>
		</xsl:element>&cr;
	</xsl:template>

	<!-- migrate the ObjectSet element -->
	<xsl:template match="ObjectSet">
		<xsl:element name="ObjectSet">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@width">
				<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@height">
				<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@HighLevel">
				<xsl:attribute name="highLevel"><xsl:value-of select="@HighLevel"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Centered">
				<xsl:attribute name="centered"><xsl:value-of select="@Centered"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Lexical">
				<xsl:attribute name="lexical"><xsl:value-of select="@Lexical"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ReadOnly">
				<xsl:attribute name="readOnly"><xsl:value-of select="@ReadOnly"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Primary">
				<xsl:attribute name="primary"><xsl:value-of select="@Primary"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ObjectSetObject">
				<xsl:attribute name="objectSetObject"><xsl:value-of select="@ObjectSetObject"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@CardinalityConstraint">
				<xsl:attribute name="cardinalityConstraint"><xsl:value-of select="@CardinalityConstraint"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@URI">
				<xsl:attribute name="uri"><xsl:value-of select="@URI"/></xsl:attribute>
			</xsl:if>&cr;
			<NameList>&cr;
				<xsl:element name="Name">
					<xsl:choose>
						<xsl:when test="@Name">
							<xsl:attribute name="content"><xsl:value-of select="@Name"/></xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="content">ObjSet</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:element>&cr;
			</NameList>&cr;
			<xsl:apply-templates select="./DataFrame"/>
			<xsl:apply-templates select="./Style"/>
			<xsl:apply-templates select="./OSM"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!--	migrate the State element -->
	<xsl:template match="State">
		<xsl:element name="State">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@width">
				<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@height">
				<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@HighLevel">
				<xsl:attribute name="highLevel"><xsl:value-of select="@HighLevel"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Centered">
				<xsl:attribute name="centered"><xsl:value-of select="@Centered"/></xsl:attribute>
			</xsl:if>&cr;
			<xsl:apply-templates select="./Style"/>
			<xsl:apply-templates select="./RTC"/>
			<xsl:apply-templates select="./OSM"/>
			<NameList>&cr;
				<xsl:element name="Name">
					<xsl:choose>
						<xsl:when test="@Name">
							<xsl:attribute name="content"><xsl:value-of select="@Name"/></xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="content">State</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:element>&cr;
			</NameList>&cr;
		</xsl:element>&cr;
	</xsl:template>
	
	
	<!-- migrate the Transition element -->
	<xsl:template match="Transition">
		<xsl:element name="Transition">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@width">
				<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@height">
				<xsl:attribute name="height"><xsl:value-of select="@height"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@HighLevel">
				<xsl:attribute name="highLevel"><xsl:value-of select="@HighLevel"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Centered">
				<xsl:attribute name="centered"><xsl:value-of select="@Centered"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Collapsed">
				<xsl:attribute name="collapsed"><xsl:value-of select="@Collapsed"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Trigger">
				<xsl:attribute name="trigger"><xsl:value-of select="@Trigger"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Action">
				<xsl:attribute name="action"><xsl:value-of select="@Action"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@hasAction">
				<xsl:attribute name="hasAction"><xsl:value-of select="@hasAction"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Style"/>
			<xsl:if test="./Identifier">
				<Identifier>
					<xsl:apply-templates select="./Identifier/Text"/>
				</Identifier>&cr;
			</xsl:if>
			<xsl:apply-templates select="./RTC"/>
			<xsl:apply-templates select="./OSM"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Conjunction element-->
	<xsl:template match="Conjunction">
		<xsl:element name="Conjunction">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@prior">
				<xsl:attribute name="prior"><xsl:value-of select="@prior"/></xsl:attribute>
			</xsl:if>&cr;
			<xsl:apply-templates select="./Style"/>
			<NameList>&cr;
				<xsl:element name="Name">
					<xsl:choose>
						<xsl:when test="./Name/Text">
							<xsl:attribute name="content"><xsl:value-of select="./Name/Text/@text"/></xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="content">Conjunction</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:apply-templates select="./Name/Text/Style"/>
				</xsl:element>&cr;
			</NameList>&cr;
			<xsl:apply-templates select="./ConjunctionConnection"/>&cr;
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the ConjunctionConnection element -->
	<xsl:template match="ConjunctionConnection">
		<xsl:element name="ConjunctionConnection">
			<xsl:if test="@ObjectSet">
				<xsl:attribute name="objectSet"><xsl:value-of select="@ObjectSet"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@newThread">
				<xsl:attribute name="newThread"><xsl:value-of select="@newThread"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@mergeThread">
				<xsl:attribute name="mergeThread"><xsl:value-of select="@mergeThread"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@exception">
				<xsl:attribute name="exception"><xsl:value-of select="@exception"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@head">
				<xsl:attribute name="head"><xsl:value-of select="@head"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Style"/>
			<xsl:apply-templates select="./Condition[1]"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!--  migrate the Condition element -->
	<xsl:template match="Condition">
		<Condition>&cr;
			<xsl:apply-templates select="./Text"/>
		</Condition>&cr;
	</xsl:template>
	
	<!--  migrate the RTC element-->
	<xsl:template match="RTC">
		<xsl:element name="RTC">
			<xsl:if test="@Type">
				<xsl:attribute name="type"><xsl:value-of select="@Type"/></xsl:attribute>
			</xsl:if>&cr;
			<xsl:apply-templates select="./Text"/>
		</xsl:element>&cr;
	</xsl:template>
	
	
	<!--  migrate the Object element -->
	<xsl:template match="Object">
		<xsl:element name="Object">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ObjectSet">
				<xsl:attribute name="objectSet"><xsl:value-of select="@ObjectSet"/></xsl:attribute>
			</xsl:if>&cr;
			<NameList>&cr;
				<xsl:element name="Name">
					<xsl:choose>
						<xsl:when test="./ObjectName/Text">
							<xsl:attribute name="content"><xsl:value-of select="./ObjectName/Text/@text"/></xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="content">Object</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>&cr;
					<xsl:apply-templates select="./ObjectName/Text/Style"/>
				</xsl:element>&cr;
			</NameList>
		</xsl:element>&cr;
	</xsl:template>
	
	<!--  migrate the Note element -->
	<xsl:template match="Note">
		<Note>&cr;
			<xsl:apply-templates select="./Text"/>
		</Note>&cr;
	</xsl:template>
	
	<!--  migrate the GeneralConstraint element -->
	<xsl:template match="GeneralConstraint">
		<GeneralConstraint>&cr;
			<xsl:apply-templates select="./Text"/>
		</GeneralConstraint>&cr;
	</xsl:template>
	
	<!-- migrate the Text element -->
	<xsl:template match="Text">
		<xsl:element name="Text">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:attribute name="content"><xsl:value-of select="@text"/></xsl:attribute>
			<xsl:apply-templates select="./Style"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Style element -->
	<xsl:template match="Style">
		<xsl:element name="Style">
			<xsl:if test="@FillColor">
				<xsl:attribute name="fillColor"><xsl:value-of select="@FillColor"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Line|./Font"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Font element -->
	<xsl:template match="Font">
		<xsl:element name="Font">
			<xsl:if test="@Family">
				<xsl:attribute name="family"><xsl:value-of select="@Family"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Size">
				<xsl:attribute name="size"><xsl:value-of select="@Size"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Style">
				<xsl:attribute name="style"><xsl:value-of select="@Style"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Color">
				<xsl:attribute name="color"><xsl:value-of select="@Color"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Line element -->
	<xsl:template match="Line">
		<xsl:element name="Line">
			<xsl:if test="@Width">
				<xsl:attribute name="width"><xsl:value-of select="@Width"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Color">
				<xsl:attribute name="color"><xsl:value-of select="@Color"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the RelationshipSet element -->
	<xsl:template match="RelationshipSet">
		<xsl:element name="RelationshipSet">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<!--
			<xsl:if test="@width">
				<xsl:attribute name="width"><xsl:value-of select="@width"/></xsl:attribute>
			</xsl:if> -->
			<xsl:if test="@LeftArrow">
				<xsl:attribute name="leftArrow"><xsl:value-of select="@LeftArrow"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@RightArrow">
				<xsl:attribute name="rightArrow"><xsl:value-of select="@RightArrow"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ShowDiamond">
				<xsl:attribute name="showDiamond"><xsl:value-of select="@ShowDiamond"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@URI">
				<xsl:attribute name="uri"><xsl:value-of select="@URI"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@HighLevel">
				<xsl:attribute name="highLevel"><xsl:value-of select="@HighLevel"/></xsl:attribute>
			</xsl:if>&cr;
			<xsl:apply-templates select="./Style"/>
			<xsl:apply-templates select="./OSM"/>
			<NameList>&cr;
				<xsl:element name="Name">
					<xsl:choose>
						<xsl:when test="./RelationshipSetName/Text">
							<xsl:attribute name="content"><xsl:value-of select="./RelationshipSetName/Text/@text"/></xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="content">RelSet</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:apply-templates select="./RelationshipSetName/Text/Style"/>
				</xsl:element>&cr;
			</NameList>&cr;
			<xsl:apply-templates select="./Connection"/>
			<xsl:apply-templates select="./CoOccurrenceConstraint"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Connection element -->
	<xsl:template match="Connection">
		<xsl:element name="Connection">
			<xsl:if test="@ObjectSet">
				<xsl:attribute name="objectSet"><xsl:value-of select="@ObjectSet"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Functional">
				<xsl:attribute name="functional"><xsl:value-of select="@Functional"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Optional">
				<xsl:attribute name="optional"><xsl:value-of select="@Optional"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@isDomainSide">
				<xsl:attribute name="isDomainSide"><xsl:value-of select="@isDomainSide"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Style"/>
			<xsl:apply-templates select="./ParticipationConstraint"/>
			<xsl:apply-templates select="./Anchor"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Anchor element -->
	<xsl:template match="Anchor">
		<xsl:element name="Anchor">
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the ParticipationConstraint element -->
	<xsl:template match="ParticipationConstraint">
		<ParticipationConstraint>&cr;
			<xsl:apply-templates select="./Text"/>
		</ParticipationConstraint>&cr;
	</xsl:template>
	
	<!-- migrate the CoOccurrenceConstraint -->
	<xsl:template match="CoOccurrenceConstraint">
		<xsl:element name="CoOccurrenceConstraint">
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@LeftSet">
				<xsl:attribute name="leftSet"><xsl:value-of select="@LeftSet"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@RightSet">
				<xsl:attribute name="rightSet"><xsl:value-of select="@RightSet"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@CardinalityConstraint">
				<xsl:attribute name="cardinalityConstraint"><xsl:value-of select="@CardinalityConstraint"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the GenSpec element -->
	<xsl:template match="GenSpec">
		<xsl:element name="GenSpec">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@GenSpecConstraint">
				<xsl:attribute name="GenSpecConstraint"><xsl:value-of select="@GenSpecConstraint"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Style"/>
			<xsl:apply-templates select="./GenConnection"/>
			<xsl:apply-templates select="./SpecConnection"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the SpecConnection element -->
	<xsl:template match="SpecConnection">
		<xsl:element name="SpecConnection">
			<xsl:if test="@ObjectSet">
				<xsl:attribute name="objectSet"><xsl:value-of select="@ObjectSet"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Style"/>
		</xsl:element>&cr;
	</xsl:template>

	<!-- migrate the GenConnection element -->
	<xsl:template match="GenConnection">
		<xsl:element name="GenConnection">
			<xsl:if test="@ObjectSet">
				<xsl:attribute name="objectSet"><xsl:value-of select="@ObjectSet"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Style"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Association element -->
	<xsl:template match="Association">
		<xsl:element name="Association">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Connection"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Aggregation element -->
	<xsl:template match="Aggregation">
		<xsl:element name="Aggregation">
			<xsl:if test="@ID">
				<xsl:attribute name="id"><xsl:value-of select="@ID"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@x">
				<xsl:attribute name="x"><xsl:value-of select="@x"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@y">
				<xsl:attribute name="y"><xsl:value-of select="@y"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@order">
				<xsl:attribute name="order"><xsl:value-of select="@order"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
			<xsl:apply-templates select="./Connection"/>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the DataFrame element -->
	<xsl:template match="DataFrame">
		<xsl:element name="DataFrame">&cr;
			<InternalRepresentation>
				<DataType typeName="java.lang.String"/>
			</InternalRepresentation>&cr;
			<xsl:if test="./ValuePhrase">
				<ValuePhraseList>&cr;
					<xsl:apply-templates select="./ValuePhrase"/>
				</ValuePhraseList>&cr;
			</xsl:if>
			<xsl:if test="./ContextPhrase">
				<KeywordPhraseList>&cr;
					<xsl:apply-templates select="./ContextPhrase"/>
				</KeywordPhraseList>&cr;
			</xsl:if>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the ValuePhrase element -->
	<xsl:template match="ValuePhrase">
		<xsl:element name="ValuePhrase">
			<xsl:if test="@Label">
				<xsl:attribute name="hint"><xsl:value-of select="@Label"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ConfidenceTag">
				<xsl:attribute name="confidenceTag"><xsl:value-of select="@ConfidenceTag"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@CaseSensitive">
				<xsl:attribute name="caseSensitive"><xsl:value-of select="@CaseSensitive"/></xsl:attribute>
			</xsl:if>&cr;
			<xsl:if test="@ValueExpression">
				<xsl:element name="ValueExpression">
					<xsl:if test="@ValueExpColor">
						<xsl:attribute name="color"><xsl:value-of select="@ValueExpColor"/></xsl:attribute>
					</xsl:if>&cr;
					<ExpressionText><xsl:value-of select="@ValueExpression"/></ExpressionText>&cr;
				</xsl:element>&cr;
			</xsl:if>
			<xsl:if test="@ExceptionExpression">
				<xsl:element name="ExceptionExpression">
					<xsl:if test="@ExceptionExpColor">
						<xsl:attribute name="color"><xsl:value-of select="@ExceptionExpColor"/></xsl:attribute>
					</xsl:if>&cr;
					<ExpressionText><xsl:value-of select="@ExceptionExpression"/></ExpressionText>&cr;
				</xsl:element>&cr;
			</xsl:if>
			<xsl:if test="@LContextExpression">
				<xsl:element name="LeftContextExpression">&cr;
					<ExpressionText><xsl:value-of select="@LContextExpression"/></ExpressionText>&cr;
				</xsl:element>&cr;
			</xsl:if>
			<xsl:if test="@RContextExpression">
				<xsl:element name="RightContextExpression">&cr;
					<ExpressionText><xsl:value-of select="@RContextExpression"/></ExpressionText>&cr;
				</xsl:element>&cr;
			</xsl:if>
			<xsl:if test="@ReqContextExpression">
				<xsl:element name="RequiredContextExpression">
					<xsl:if test="@ReqContextExpColor">
						<xsl:attribute name="color"><xsl:value-of select="@ReqContextExpColor"/></xsl:attribute>
					</xsl:if>&cr;
					<ExpressionText><xsl:value-of select="@ReqContextExpression"/></ExpressionText>&cr;
				</xsl:element>&cr;
			</xsl:if>
			<xsl:if test="@SubFromExpression">
				<xsl:element name="SubFromExpression">
					<xsl:if test="@SubColor">
						<xsl:attribute name="color"><xsl:value-of select="@SubColor"/></xsl:attribute>
					</xsl:if>&cr;
					<ExpressionText><xsl:value-of select="@SubFromExpression"/></ExpressionText>&cr;
				</xsl:element>
			</xsl:if>
			<xsl:if test="@SubToExpression">
				<xsl:element name="SubToExpression">
					<xsl:if test="@SubColor">
						<xsl:attribute name="color"><xsl:value-of select="@SubColor"/></xsl:attribute>
					</xsl:if>&cr;
					<ExpressionText><xsl:value-of select="@SubToExpression"/></ExpressionText>&cr;
				</xsl:element>&cr;
			</xsl:if>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the ContextPhrase element -->
	<xsl:template match="ContextPhrase">
		<xsl:element name="KeywordPhrase">
			<xsl:if test="@Label">
				<xsl:attribute name="hint"><xsl:value-of select="@Label"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@ConfidenceTag">
				<xsl:attribute name="confidenceTag"><xsl:value-of select="@ConfidenceTag"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@CaseSensitive">
				<xsl:attribute name="caseSensitive"><xsl:value-of select="@CaseSensitive"/></xsl:attribute>
			</xsl:if>&cr;
			<xsl:if test="@ContextExpression">
				<xsl:element name="KeywordExpression">
					<xsl:if test="@ContextExpColor">
						<xsl:attribute name="color"><xsl:value-of select="@ContextExpColor"/></xsl:attribute>
					</xsl:if>&cr;
					<ExpressionText><xsl:value-of select="@ContextExpression"/></ExpressionText>
				</xsl:element>&cr;
			</xsl:if>
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Lexicon element -->
	<xsl:template match="Lexicon">
		<xsl:element name="Lexicon">
			<xsl:if test="@Label">
				<xsl:attribute name="label"><xsl:value-of select="@Label"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@FileName">
				<xsl:attribute name="uri">file:///<xsl:value-of select="@FileName"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@CaseSensitive">
				<xsl:attribute name="caseSensitive"><xsl:value-of select="@CaseSensitive"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Separators">
				<xsl:attribute name="delimiters"><xsl:value-of select="@Separators"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
		</xsl:element>&cr;
	</xsl:template>
	
	<!-- migrate the Macro element -->
	<xsl:template match="Macro">
		<xsl:element name="Macro">
			<xsl:if test="@Label">
				<xsl:attribute name="label"><xsl:value-of select="@Label"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Color">
				<xsl:attribute name="color"><xsl:value-of select="@Color"/></xsl:attribute>
			</xsl:if>
			<xsl:if test="@Body">
				<xsl:value-of select="@Body"/>
			</xsl:if>
			<xsl:if test="count(./*) > 0">&cr;
			</xsl:if>			
		</xsl:element>&cr;
	</xsl:template>
	
</xsl:stylesheet>
