/*
 * OSMXAggregationType.java
 *
 * Created on June 11, 2003, 11:43 AM
 */

package edu.byu.deg.osmx;

import java.util.ArrayList;
import java.util.List;

import edu.byu.deg.osmx.binding.RelSetConnection;
import edu.byu.deg.osmx.binding.StyleType;

/**
 * Represents an <CODE>Aggregation</CODE> element in OSMX.
 * @author Alan Wessman
 * Modified by Zonghui
 */
public class OSMXAggregationType extends edu.byu.deg.osmx.binding.impl.AggregationTypeImpl 
implements StyledElement, PositionedElement{
    
   protected List positionListeners;
   
   public OSMXAggregationType(){
	   super();
	   positionListeners = new ArrayList();
   }
		
	
  void setParent(OSMXElement elem) {
    parent = elem;
    addToParentDocument();
    this.setAsParentOf((OSMXElement) getParentConnection());//TODO: test it 
    this.setAsParentOf(this.getChildConnection());
    this.setAsParentOf((OSMXElement) this.getStyle());
  }

	public void setStyle(StyleType value) {
		//do nothing
	}

	public void addPositionListener(PositionListener pl) {
		positionListeners.add(pl);
	}

	public void removePositionListener(PositionListener pl) {
		positionListeners.remove(pl);		
	}

	public boolean isSetPosition() {
		return (isSetX() && isSetY());
	}

}
