/*
 * OSMXDataFrameType.java
 *
 * Created on June 11, 2003, 11:43 AM
 */

package edu.byu.deg.osmx;

import edu.byu.deg.osmx.binding.TypeSpecification;
import edu.byu.deg.osmx.binding.ObjectFactory;

/**
 * Represents a <CODE>DataFrame</CODE> element in OSMX.
 * @author Alan Wessman
 */
public class OSMXDataFrameType extends edu.byu.deg.osmx.binding.impl.DataFrameTypeImpl
implements KeywordListOwner {
  
  /** Creates a new instance of OSMXDataFrameType */
  public OSMXDataFrameType() {
    if (!isSetInternalRepresentation()) {
      try {
        setInternalRepresentation(createTypeSpecification());
      } catch (javax.xml.bind.JAXBException e) {
        e.printStackTrace();
      }
    }
  }
  
  private TypeSpecification createTypeSpecification() throws javax.xml.bind.JAXBException {
    OSMXDocument doc = getParentDocument();
    ObjectFactory factory;
    if (doc != null) {
      factory = doc.getObjectFactory();
    } else {
      factory = new ObjectFactory();
    }
    return factory.createTypeSpecification();
  }
  
  /**
   * Overrides the inherited method in order to pass the call recursively down to its
   * child elements.
   * @param elem The new parent of this element.
   */  
  void setParent(OSMXElement elem) {
    parent = elem;
    addToParentDocument();
    this.setAsParentOf((OSMXElement) getInternalRepresentation());
    this.setAsParentOf(this.getInnerList(getValuePhrase()));
    this.setAsParentOf(this.getInnerList(getKeywordPhrase()));
    this.setAsParentOf(this.getInnerList(getMethod()));
  }
  
  /**
   * Stores a new <CODE>TypeSpecification</CODE> element as a new definition of the
   * data frame's internal representation.
   * @param value The new element to store.
   */  
  public void setInternalRepresentation(TypeSpecification value) {
    this.replaceChild((OSMXElement) getInternalRepresentation(), (OSMXElement) value);
    super.setInternalRepresentation(value);
  }
  
}
