/*
 * OSMXDataTypeType.java
 *
 * Created on August 4, 2003, 11:34 AM
 */

package edu.byu.deg.osmx;

/**
 * Represents a <CODE>DataType</CODE> element in OSMX.
 * @author aew2
 */
public class OSMXDataTypeType extends edu.byu.deg.osmx.binding.impl.DataTypeTypeImpl {
  
  public static final String NAME_PROPERTY = "typeName";
  public static final String UNIT_PROPERTY = "unitOfMeasure";
    
  /**
   * Stores a new value for the <CODE>typeName</CODE> attribute.
   * @param value The new value to store.
   */  
  public void setTypeName(String value) {
    String oldVal = getTypeName();
    String newVal = new String(value); // in case value == null
    if (!newVal.equals(oldVal)) {
      super.setTypeName(value);
      firePropertyChange(NAME_PROPERTY, oldVal, value);
    }
  }
  
  /**
   * Stores a new value for the <CODE>unitOfMeasure</CODE> attribute.
   * @param value The new value to store..
   */  
  public void setUnitOfMeasure(String value) {
    String oldVal = getUnitOfMeasure();
    String newVal = new String(value); // in case value == null
    if (!newVal.equals(oldVal)) {
      super.setUnitOfMeasure(value);
      firePropertyChange(UNIT_PROPERTY, oldVal, value);
    }
  }
  
}
