/*
 * OSMXLexiconType.java
 *
 * Created on June 11, 2003, 11:43 AM
 */

package edu.byu.deg.osmx;

import java.net.URI;

/**
 * Represents a <CODE>Lexicon</CODE> element in OSMX.
 * @author Alan Wessman
 */
public class OSMXLexiconType extends edu.byu.deg.osmx.binding.impl.LexiconTypeImpl {
    /**
     * Represents the lexicon as a string.
     * @return The label (name) of the lexicon.
     */    
  public String toString(){
    return this.getLabel();
  }
  
  /**
   * Assigns a new URI to this lexicon.  If the URI is relative, it will be
   * interpreted relative to the URI of the referencing <CODE>OSMXDocument</CODE>.
   * @param value The new URI to assign.
   */  
  public void setUri(String value) {
      // relativize value wrt URI of parentDocument
      OSMXDocument doc = getParentDocument();
      URI docURI = null;
      String uriString = value;
      if (doc != null) docURI = doc.getURI();
      if (docURI != null) {
          try {
            URI lexURI = docURI.resolve(uriString);
            uriString = docURI.relativize(lexURI).toString();
          } catch (IllegalArgumentException iae) {
              iae.printStackTrace();
          }
      }
      super.setUri(uriString);
  }
}
