/*
 * OSMXObjectBindingType.java
 *
 * Created on June 11, 2003, 11:43 AM
 */

package edu.byu.deg.osmx;

/**
 * Represents an <CODE>ObjectBinding</CODE> element in OSMX.
 * @author Alan Wessman
 */
public class OSMXObjectBindingType extends edu.byu.deg.osmx.binding.impl.ObjectBindingTypeImpl {
    
    /**
     * Attaches the specified connection to the binding, first releasing any connection
     * that may have been previously attached.
     * @param value The ID for the connection to be attached.
     */    
    public void setConnectionRef(String value) {
        String oldVal = getConnectionRef();
        super.setConnectionRef(value);
        OSMXDocument parentDoc = getParentDocument();
        if (parentDoc != null) {
            if (oldVal != null && oldVal != value) {
                OSMXRelSetConnectionType conn = (OSMXRelSetConnectionType) parentDoc.getElement(oldVal);
                if (conn != null) {
                    java.util.Set objBindings = conn.getObjectBindings(getObjectRef());
                    if (objBindings != null) objBindings.remove(this);
                }
            }
            OSMXRelSetConnectionType conn = (OSMXRelSetConnectionType) parentDoc.getElement(value);
            if (conn != null) {
                conn.addObjectBinding(this);
            }
        }
    }
    
    /**
     * Attaches an Object element to the binding.
     * @param value The ID of the object to be bound.
     */    
    public void setObjectRef(String value) {
        super.setObjectRef(value);
    }
}
