/*
 * OSMXObjectSetReferenceType.java
 *
 * Created on August 4, 2003, 11:33 AM
 */

package edu.byu.deg.osmx;

/**
 * Represents an <CODE>ObjectSetReference</CODE> element in OSMX.
 * @author aew2
 */
public class OSMXObjectSetReferenceType extends edu.byu.deg.osmx.binding.impl.ObjectSetReferenceTypeImpl {
  
  public static final String REF_PROPERTY = "objectSetRef";
  
  /**
   * Establishes a link to the object set to be referenced.
   * @param value The ID of the object set to be referenced by this element.
   */  
  public void setIdref(String value) {
    String oldVal = getIdref();
    String newVal = new String(value); // in case value == null
    if (!newVal.equals(oldVal)) {
      super.setIdref(value);
      firePropertyChange(REF_PROPERTY, oldVal, value);
    }
  }
  
}
