/*
 * OSMXRealTimeConstraintType.java
 *
 * Created on June 11, 2003, 11:38 AM
 */

package edu.byu.deg.osmx;

import edu.byu.deg.osmx.binding.PositionedText;

/**
 * Represents a <CODE>RealTimeConstraint</CODE> element in OSMX.
 * @author Alan Wessman
 */
public class OSMXRealTimeConstraintType extends edu.byu.deg.osmx.binding.impl.RealTimeConstraintTypeImpl {
  
    /**
     * Overrides the inherited method in order to pass the call recursively down to its
     * child elements.
     * @param elem The new parent of this element.
     */    
  void setParent(OSMXElement elem) {
    parent = elem;
    addToParentDocument();
    this.setAsParentOf((OSMXElement) getText());
  }
  
  /**
   * Assigns a <CODE>PositionedText</CODE> element to the <CODE>text</CODE> attribute
   * of this real-time constraint element.
   * @param value The <CODE>PositionedText</CODE> element to assign.
   */  
  public void setText(PositionedText value) {
    this.replaceChild((OSMXElement) getText(), (OSMXElement) value);
    super.setText(value);
  }
  
}
