/*
 * OSMXRelationshipType.java
 *
 * Created on June 11, 2003, 11:43 AM
 */

package edu.byu.deg.osmx;

/**
 * Represents a <CODE>Relationship</CODE> element in OSMX.
 * @author Alan Wessman
 */
public class OSMXRelationshipType extends edu.byu.deg.osmx.binding.impl.RelationshipTypeImpl {
    
    /**
     * Overrides the inherited method in order to pass the call recursively down to its
     * child elements.
     * @param elem The new parent of this element.
     */    
    void setParent(OSMXElement elem) {
        parent = elem;
        addToParentDocument();
        this.setAsParentOf(getObjectBinding());
    }
    
    /**
     * Sets the relationship's reference to the relationship set it belongs to.
     * @param value The ID of the relationship set to which this relationship belongs.
     */    
    public void setRelationshipSet(String value) {
        String oldVal = getRelationshipSet();
        super.setRelationshipSet(value);
        OSMXDocument parentDoc = getParentDocument();
        if (parentDoc != null) {
            if (oldVal != null && oldVal != value) {
                OSMXRelationshipSetType relSet = (OSMXRelationshipSetType) parentDoc.getElement(oldVal);
                if (relSet != null) relSet.getWorkingInstance().remove(this);
            }
            OSMXRelationshipSetType relSet = (OSMXRelationshipSetType) parentDoc.getElement(value);
            if (relSet != null) {
                relSet.getWorkingInstance().add(this);
            }
        }
    }
    
}
