/*
 * OSMXSourceDocumentType.java
 *
 * Created on June 11, 2003, 11:42 AM
 */

package edu.byu.deg.osmx;

/**
 * Represents a <CODE>SourceDocument</CODE> element in OSMX.
 * @author Alan Wessman
 */
public class OSMXSourceDocumentType extends edu.byu.deg.osmx.binding.impl.SourceDocumentTypeImpl {
  
    /**
     * Overrides the inherited method in order to pass the call recursively down to its
     * child elements.
     * @param elem The new parent of this element.
     */    
  void setParent(OSMXElement elem) {
    parent = elem;
    addToParentDocument();
    this.setAsParentOf(getDataInstanceElements());
  }
  
  /**
   * Returns a reference to the source document that contains this source document in
   * the original document tree.
   * @return The parent document for this source document.  Result is <CODE>null</CODE> if this
   * source document has no parent document.
   */  
  public OSMXSourceDocumentType getParentSourceDocument() {
      OSMXElement parDoc = getParent();
      if (parDoc instanceof OSMXSourceDocumentType) return (OSMXSourceDocumentType) parDoc;
      else return null;
  }
  
}
