/*
 * ScalableElement.java
 *
 * Created on June 19, 2003, 10:00 PM
 */

package edu.byu.deg.osmx;

/**
 * Represents an element with height and width in a graphical plane.
 * @author Alan
 */
public interface ScalableElement {
    /**
     * Returns the width of the element.
     * @return The width of the element, in pixels.
     */    
  public int getWidth();
  /**
   * Returns the height of the element.
   * @return The height of the element, in pixels.
   */  
  public int getHeight();
  /**
   * Updates the width of the element.
   * @param value The desired width of the element, in pixels.
   */  
  public void setWidth(int value);
  /**
   * Updates the height of the element.
   * @param value The desired height of the element, in pixels.
   */  
  public void setHeight(int value);
}
