/*
 * StyledElement.java
 *
 * Created on June 19, 2003, 10:01 PM
 */

package edu.byu.deg.osmx;
import edu.byu.deg.osmx.binding.StyleType;

/**
 * Interface for elements whose appearance can be modified by settings in a
 * <CODE>Style</CODE> element.
 * @author Alan
 */
public interface StyledElement {
    /**
     * Accessor for the <CODE>Style</CODE> child element.
     * @return The currently set style element, or <CODE>null</CODE>.
     */    
  public StyleType getStyle();
  /**
   * Stores a new <CODE>Style</CODE> element reference for the element that
   * implements this interface.
   * @param value The <CODE>Style</CODE> element to store.
   */  
  public void setStyle(StyleType value);

}
