/*
 * TextAlignableElement.java
 *
 * Created on September 27, 2003, 9:58 PM
 */

package edu.byu.deg.osmx;

/**
 * Interface for elements that allow text labels to be aligned relative to the
 * shape's geometry.
 * @author Alan
 */
public interface TextAlignableElement {
    /**
     * Sets the <CODE>centered</CODE> flag of the element.
     * @param value The desired value of the <CODE>centered</CODE> attribute.
     */    
  public void setCentered(boolean value);
  /**
   * Determines whether the element's text is centered.
   * @return <CODE>true</CODE> if the element's text is centered; <CODE>false</CODE>
   * otherwise.
   */  
  public boolean isCentered();
}
