/*
 * Extractor.java
 *
 * Created on March 4, 2004, 3:42 PM
 */

package edu.byu.deg.query;

import java.io.*;
import java.net.*;


import edu.byu.deg.osmx.*;
import edu.byu.deg.framework.*;
import edu.byu.deg.ontos.*;
import edu.byu.deg.extractionmodule.MetaExtractor;

/**
 *
 * @author  troywalk
 * @version
 */
public class Extractor extends HttpServlet {
  
  /** Initializes the servlet.
   */
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    
  }
  
  /** Destroys the servlet.
   */
  public void destroy() {
    
  }
  
  /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
   * @param request servlet request
   * @param response servlet response
   */
  protected void processRequest(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.close();
  }
  
  /** Handles the HTTP <code>GET</code> method.
   * @param request servlet request
   * @param response servlet response
   */
  protected void doGet(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    processRequest(request, response);
  }
  
  /** Handles the HTTP <code>POST</code> method.
   * @param request servlet request
   * @param response servlet response
   */
  protected void doPost(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    //response.setContentType("text/html");
    //PrintWriter out = response.getWriter();
    //out.println("<html>");
    //out.println("  <body>");
    HttpSession session = request.getSession();
    ExtractorThread thread = (ExtractorThread)session.getAttribute("extractionthread");
    OSMXDocument ontology = (OSMXDocument)session.getAttribute("ontology");
    if(thread!=null){
      thread.halt();
      while(thread.isAlive())
        try{
          Thread.sleep(500);
        }catch(InterruptedException e){}
      ontology.clearDataInstances();
    }
    //out.print("Initializing document retreiver...<br>");out.flush();
    DocumentRetriever retriever;
    String urls = request.getParameter("urls");
    if(urls==null){
      String filename = request.getParameter("file");
      retriever = new edu.byu.deg.framework.retriever.DOMRetriever(filename);
    }
    else{
      String[] urlList = urls.split("\r?\n");
      retriever = new edu.byu.deg.framework.retriever.DOMRetriever();
      for(int i=0;i<urlList.length;i++){
        urlList[i] = urlList[i].trim();
        if(urlList[i].indexOf("http://")!=0)
          urlList[i] = "http://" + urlList[i];
        System.out.println(urlList[i]);
        retriever.addDocumentLocation(urlList[i]);
      }
    }
    
    OSMQuery query = (OSMQuery)session.getAttribute("query");
    
    //out.print("Loading lexicons...<br>");out.flush();
    MetaExtractor extractor;
    Object o = session.getAttribute("extractor");
    while(o==QueryProcessor.WAIT){
      Thread.yield();
      o = session.getAttribute("extractor");
    }
    extractor = (MetaExtractor)o;
    
    thread = new ExtractorThread("extraction", extractor, retriever, query);
    session.setAttribute("extractionthread", thread);
    thread.start();
    
    response.sendRedirect(response.encodeRedirectURL("../resultframe.html"));
  }
  
  /** Returns a short description of the servlet.
   */
  public String getServletInfo() {
    return "Initiates extraction task and redirects to ResultPresenter";
  }
  
  public class ExtractorThread extends Thread {
    MetaExtractor extractor;
    DocumentRetriever retriever;
    OSMQuery query;
    public ExtractorThread(String str, MetaExtractor ext, DocumentRetriever ret, OSMQuery q) {
      super(str);
      extractor = ext;
      retriever = ret;
      query = q;
    }
    
    public void halt(){
      if(extractor!=null)
        extractor.halt();
    }
    
    public void run() {
      extractor.startExtraction(retriever, query);
      extractor = null;
      retriever = null;
      query = null;
    }
  }
  
  
}
