/*
 * FormGenerator.java
 *
 * Created on July 3, 2003, 11:48 AM
 */

package edu.byu.deg.query;

import edu.byu.deg.osmx.*;
import java.util.*;
import java.io.File;
import java.io.FileWriter;

/**
 *
 * @author  Troy Walker
 */
public class FormGenerator {
  static String separator = System.getProperties().getProperty("line.separator");

  public static String makeForm(OSMXOSMType ontology, String ontologyfilename) {
    OSMXObjectSetType primary = null;
    String s = makeTop();
    HashMap objectsets = new HashMap();
    
    List l = ontology.getAllModelElements();
    for(Iterator i=l.iterator();i.hasNext();){
      Object o = i.next();
      if(o instanceof OSMXObjectSetType){
        OSMXObjectSetType objset = (OSMXObjectSetType)o;
        objectsets.put(objset.getId(), objset);
        if(objset.isPrimary())
          primary = objset;
      }
    }
    if(primary!=null){
      s += makeAddFunction(primary, ontology, new ArrayList(), objectsets);
      s += makeBody(primary, ontologyfilename);
    }
    return s;
  }
  
  private static String makeTop(){
    String s;
    s = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">" + separator;
    s += "<html>" + separator;
    s += "  <head>" + separator;
    s += "    <link rel=\"Stylesheet\" type=\"text/css\" href=\"http://www.deg.byu.edu/GeneTIQS/style.css\" />" + separator;
    s += "    <script>" + separator;
    s += "      function makeInput(name, id){" + separator;
    s += "        input =  \"<tr><td>\" + name + \":</td>\";" + separator;
    //s += "        input += \"<td><select name=\" + id + \"Condition>\";" + separator;
    //s += "        input += \"<option>&lt;</option>\";" + separator;
    //s += "        input += \"<option selected>=</option>\";" + separator;
    //s += "        input += \"<option>&gt;</option>\";" + separator;
    //s += "        input += \"</select></td>\";" + separator;
    s += "        input += \"<td><input type=text name=\"+id;" + separator;
    s += "        input += \" size=20 /></td></tr>\\n\"" + separator;
    s += "        return input;" + separator;
    s += "      }" + separator;
    s += "      function makeHidden(id){" + separator;
    s += "        input = \"<input type=hidden name=\"+id;" + separator;
    s += "        input += \" size=20 />\\n\"" + separator;
    s += "        return input;" + separator;
    s += "      }" + separator;
    return s;
  }
  
  private static String makeAddFunction(OSMXObjectSetType objset, OSMXOSMType ontology, List visited, HashMap objectsets){
    String s;
    List FD = objset.getFDObjectSets(ontology);
    List NonFD = objset.getNonFDObjectSets(ontology);
    String myID = objset.getId();
    Iterator i;
    visited.add(myID);
    FD.removeAll(visited);
    NonFD.removeAll(visited);
    s = "      function add" + myID + "(inTable){" + separator;
    s += "        str = \"\"" + separator;
    String name = objset.getName();
    if((FD.size()==0) && (NonFD.size()==0)){
      if(objset.isLexical())
        s += "        str += makeInput(\"" + name + "\", \"" + myID + "\");" + separator;
      else
        s += "        str += makeHidden(\"" + myID + "\");" + separator;
    } else {
      s += "        if(inTable) str += \"<tr><td colspan=3>\"" + separator;
      s += "        str += \"<fieldset><legend>" + name + "</legend><table>\"" + separator;
      if(objset.isLexical())
        s += "        str += makeInput(\"" + name + "\", \"" + myID + "\");" + separator;
      else
        s += "        str += makeHidden(\"" + myID + "\");" + separator;
      for(i = FD.iterator(); i.hasNext(); ){
        String id = (String)i.next();
        OSMXObjectSetType obj = (OSMXObjectSetType)objectsets.get(id);
        if(obj.isLexical())
          s += "         str += add" + id + "(1)" + separator;
      }
      s += "        str += \"</table>\"" + separator;
      for(i = FD.iterator(); i.hasNext(); ){
        String id = (String)i.next();
        OSMXObjectSetType obj = (OSMXObjectSetType)objectsets.get(id);
        if(!obj.isLexical()){
          s += "        str += \"<div id=here" + id + "></div>\"" + separator;
          s += "        str += \"<input type=button value=\\\"Add "+obj.getName();
          s += "\\\" class=button onclick=\\\"this.parentElement.children('here";
          s += id + "').innerHTML += add" + id + "(0);this.style.display='none'\\\">\"" + separator;
        }
      }
      for(i = NonFD.iterator(); i.hasNext(); ){
        String id = (String)i.next();
        OSMXObjectSetType obj = (OSMXObjectSetType)objectsets.get(id);
        s += "        str += \"<div id=here" + id + "></div>\"" + separator;
        s += "        str += \"<input type=button value=\\\"Add "+obj.getName();
        s += "\\\" class=button onclick=\\\"this.parentElement.children('here";
        s += id + "').innerHTML += add" + id + "(0)\\\">\"" + separator;
      }
      s += "        str += \"</fieldset>\"" + separator;
      s += "        if(inTable) str += \"</td></tr>\"" + separator;
    }
    s += "        return str;" + separator;
    s += "      }" + separator + separator;

    for(i = FD.iterator(); i.hasNext(); ){
      s += makeAddFunction((OSMXObjectSetType)objectsets.get((String)i.next()), ontology, visited, objectsets);
    }
      
    for(i = NonFD.iterator(); i.hasNext(); ){
      s += makeAddFunction((OSMXObjectSetType)objectsets.get((String)i.next()), ontology, visited, objectsets);
    }

    return s;
  }

  private static String makeBody(OSMXObjectSetType primary, String ontologyfilename){
    String name = primary.getName();
    String id = primary.getId();
    String s;
    s = "    </script>" + separator;
    s += "    <title>" + name + " Query</title>" + separator;
    s += "  </head>" + separator + separator;
  
    s += "  <body>" + separator;
    s += "    <h1>" + name + " Query</h1>" + separator;
    s += "    <hr>" + separator;
    s += "    <form action=\"servlet/edu.byu.deg.query.QueryProcessor\" method=post>" + separator;
    s += "      <input type=hidden name=ontology value=\"" + ontologyfilename + "\">" + separator;
    s += "      <script>" + separator;
    s += "        document.write(add" + id + "(0));" + separator;
    s += "      </script>" + separator;
    s += "      <br><input type=submit class=button>" + separator;
    s += "    </form>" + separator;
    s += "    <hr>" + separator;
    s += "  </body>" + separator;
    s += "</html>" + separator;
    return s;
  }
  
  
  public static void main(String[] args) {
    try{
      OSMXDocument doc = new OSMXDocument();
      if(args.length<2||args.length>2)
        System.err.println("Usage: java FormGenerator <ontologyfilename> <outputfilename>");
      doc.openDocument(args[0]);
      File outFile = new File(args[1]);
      FileWriter out = new FileWriter(outFile);
      out.write(makeForm((OSMXOSMType)doc.getModelRoot(), args[0]));
      System.out.println("done making form");
      out.close();
    } catch (Exception e){
      e.printStackTrace(); 
    }
  }
}
