/*
 * SourceSelector.java
 *
 * Created on March 2, 2004, 4:51 PM
 */

package edu.byu.deg.query;

import java.io.*;
import java.net.*;

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;
/**
 *
 * @author  troywalk
 * @version
 */
public class SourceSelector extends HttpServlet {

  
  private ResourceBundle resources;
  
  /** Initializes the servlet.
   */
  public void init(ServletConfig config) throws ServletException {
    super.init(config);
    
  }
  
  /** Destroys the servlet.
   */
  public void destroy() {
    
  }
  
  /** Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
   * @param request servlet request
   * @param response servlet response
   */
  protected void processRequest(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    initResource(request);
    if(request.getSession().getAttribute("ontology")==null)
      response.sendRedirect("../query.html");
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("  <head>");
    out.println("    <title>Select extraction source</title>");
    out.println("    <link rel=\"Stylesheet\" type=\"text/css\" href=\"/gene/style.css\" />");
    out.println("  </head>");
    out.println("  <body>");
    out.println("    <h1>Select extraction source</h1>");
    out.println("    <hr />");
    out.println("    <center>");
    printFileSelectionForm(out);
    out.println("<br>or<br>");
    printURLEntryForm(out);
    out.println("    </center>");
    out.println("  </body>");
    out.println("</html>");

    out.close();
  }
  
  /** Handles the HTTP <code>GET</code> method.
   * @param request servlet request
   * @param response servlet response
   */
  protected void doGet(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    processRequest(request, response);
  }
  
  /** Handles the HTTP <code>POST</code> method.
   * @param request servlet request
   * @param response servlet response
   */
  protected void doPost(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    processRequest(request, response);
  }
  
  /** Returns a short description of the servlet.
   */
  public String getServletInfo() {
    return "Allows the user to select a list of URLs or enter a URL to search";
  }
  
  private void initResource(HttpServletRequest request){
    Object o = request.getSession().getAttribute("search.parameters");
    if(o instanceof ResourceBundle)
      resources = (ResourceBundle)o;
    else {
      try {
        resources = ResourceBundle.getBundle("edu.byu.deg.query.Options");
      }
      catch (MissingResourceException mre) {
        mre.printStackTrace(System.err);
        System.err.println("Options not found");
      }
    }
  }
  
  private void printFileSelectionForm(PrintWriter out){
    StringBuffer b = new StringBuffer();
    String path = resources.getString("urllistdirectory");
    if(path==null)
      return;
    b.append("<form action=\"edu.byu.deg.query.Extractor\" method=post>");
    //b.append("<input type=hidden name=path value=\"");
    //b.append(path);
    //b.append("\">");
    b.append("Select a URL list: ");
    b.append("<select name=file>");
    
    File dir = new File(path);
    File[] files = dir.listFiles();
    for(int i=0;i<files.length;i++){
      b.append("<option value=\"");
      b.append(files[i].getAbsolutePath());
      b.append("\">");
      b.append(files[i].getName());
      b.append("</option>");
      
    }
    b.append("</select>");
    b.append("<input type=submit class=button value=extract/>");
    b.append("</form>");
    out.println(b);
  }
  
  private void printURLEntryForm(PrintWriter out){
    out.println("<form action=\"edu.byu.deg.query.Extractor\" method=post>");
    out.println("Enter URLs one to a line: <br><textarea rows=8 cols=60 name=urls></textarea>");
    out.println("<br><input type=submit class=button value=extract/>");
    out.println("</form>");
  }
}
