package edu.byu.deg.records;

import java.util.*;
import java.io.*;

/**
  * This class take a tag-tree as input
  * find the separators
  *
  * @version 1.2.0
  * @author  Yuan Jiang
  */
class ApplyIT {
   Vector type_list = new Vector(1,1);
   Vector ist_list = new Vector(1,1);

   /**
	* Constructor
	*/
   ApplyIT() {
	  type_list = new Vector(1,1);
	  ist_list = new Vector(1,1);
   }

   /**
	* Constructor
	* @param sub
	*/
   ApplyIT(Vector gl) {
	  this();

	  for(int i=0; i<gl.size(); i++) {
		 type_list.addElement(new String(((GTI)gl.elementAt(i)).str));
	  }

   }

   /**
	* Constructor
	* @param sub
	* @param input
	*/
   ApplyIT(Vector gl, Vector input) {
	  this(gl);

	  for(int i=0; i<input.size(); i++) {
		 ist_list.addElement(new String((String)input.elementAt(i)));
	  }
   }
   /**
	* Constructor
	* @param sub
	* @param input
	*/
   ApplyIT(Vector gl, File input) {
	  this(gl);
	  try {
		 InputStream in = new FileInputStream(input);
		 int i = in.read();
		 String ist_str = new String();

		 while(i != -1) {
			ist_str += (char)i;
			i = in.read();
		 }

		 int start_tag_pos = 0;
		 int end_tag_pos = 0;

		 do {
			start_tag_pos = ist_str.indexOf("<", start_tag_pos);
			if(start_tag_pos != -1) {
			   end_tag_pos = ist_str.indexOf(">", start_tag_pos);
			}
			else {
			   break;
			}

			String str = ist_str.substring(start_tag_pos, end_tag_pos+1);
			ist_list.addElement(str);
			start_tag_pos = end_tag_pos + 1;
		 }  while ((start_tag_pos != -1) || (end_tag_pos != -1));
	  } catch (IOException io) {
		   System.out.println(io.getMessage());
		}
   }


   public Vector find_candidate() {
	  int rank = 1;
	  Vector candidate_list = new Vector(1,1);

	  for(int i=0; i<ist_list.size(); i++) {
		 String str = new String((String)ist_list.elementAt(i));
		 if (type_list.contains(str)) {
			candidate_list.addElement(new GTI(str, rank));
			rank++;
		 }
	  }
/*
	  System.out.println("Candidate_list");
	  for(int i=0; i<candidate_list.size(); i++) {
		 System.out.println(((GTI)candidate_list.elementAt(i)).str + "\t" +
						  ((GTI)candidate_list.elementAt(i)).num);
	  }
*/
	  return candidate_list;

   }
}
