package edu.byu.deg.records;

import java.util.*;

/**
  * This class take a tag-tree as input
  * find the separators
  *
  * @version 1.1.2
  * @author  Yuan Jiang
  */
class ApplyRP {
   TTree  subtree = new TTree();
   Vector tag_list = new Vector();
   Vector tag_type = new Vector();

   /**
	* Constructor
	*/
   ApplyRP() {
	  subtree = new TTree();
	  tag_list = new Vector();
	  tag_type = new Vector();
   }

   /**
	* Constructor
	* @param tree
	*/
   ApplyRP(TTree tree) {
	  this();

	  subtree = tree;

	  PreProcessTags pt = new PreProcessTags(tree);
	  pt.eliminateIrrelevantTags(3);
	  tag_list = pt.tag_list;
	  tag_type = pt.type_list;
   }

   /**
	* Constructor
	* @param tgl
	* @param tyl
	*/
   ApplyRP(Vector tgl, Vector tyl) {
	  this();
	  tag_list = tgl;
	  tag_type = tyl;
   }

   /**
	*   find the tag with the repeat pattern
	*/
   public Vector find_candidate() {
	  int rank = 1;
	  Vector candidate_list = new Vector();
	  Vector fs = new Vector();

	  int last = 0;
	  int pos = -1;
	  boolean connect = false;

	  for(int j=0; j<tag_list.size()-1; j++) {
		 String tag1 = new String(((String)tag_list.elementAt(j)));
		 String tag2 = new String(((String)tag_list.elementAt(j+1)));

		 boolean find1 = false;
		 boolean find2 = false;
		 int p1 = -1;
		 int p2 = -1;

		 // need to add check plaintext
		 for(int i= last; i< subtree.children.size(); i++) {
			String tg = ((TTree)subtree.children.elementAt(i)).current.getTag();

			if(find1 == false && tg.equals(tag1)) {
			   p1 = i;
			   find1 = true;
			}
			else if(find1 == true && tg.equals(tag2)) {
			   p2 = i;
			   last = i;
			   find2 = true;
			}

			if(find1 == true && find2 == true) {
			   connect = findEmpty(p1, p2);
			   break;
			}
		 }

		 if(connect == true) {
			pos = -1;
			for(int i=0; i<fs.size(); i++) {
			   String tmp1 = new String(((TFS)fs.elementAt(i)).front);
			   String tmp2 = new String(((TFS)fs.elementAt(i)).back);

			   if(tmp1.equals(tag1) && tmp2.equals(tag2)) {
				  pos = i;
				  break;
			   }

			}

			if(pos == -1) {
			   fs.addElement(new TFS(tag1, tag2, 1));
			}
			else {
			   ((TFS)fs.elementAt(pos)).count++;
			}

		 }
		 connect = false;

	  }

	  //print out pairs
/*      System.out.println("Repeating Pairs");
	  for(int i=0; i<fs.size(); i++) {
		 System.out.print(((TFS)fs.elementAt(i)).front + "\t");
		 System.out.print(((TFS)fs.elementAt(i)).back + "\t");
		 System.out.println(((TFS)fs.elementAt(i)).count);
	  }
*/

	  boolean flag = false;
	  int[] diff = new int[tag_type.size()];

	  for(int i=0; i<tag_type.size(); i++) {
		 diff[i] = -1;
		 String tg = ((GTI)tag_type.elementAt(i)).str;
		 int app = ((GTI)tag_type.elementAt(i)).num;
		 flag = false;
		 for(int j=0; j<fs.size(); j++) {
			String str1 = ((TFS)fs.elementAt(j)).front;
			String str2 = ((TFS)fs.elementAt(j)).back;
			int n = ((TFS)fs.elementAt(j)).count;
			if(str1.equals(tg)) {
			   if(flag == false) {
				  diff[i] = Math.abs(app - n);
				  flag = true;
			   }
			   else {
				  int dif = Math.abs(app - n);
				  if(dif < diff[i]) {
					 diff[i] = dif;
				  }
			   }
			}
			if(str2.equals(tg)) {
			   if(flag == false) {
				  diff[i] = Math.abs(app - n);
				  flag = true;
			   }
			   else {
				  int dif = Math.abs(app - n);
				  if(dif < diff[i]) {
					 diff[i] = dif;
				  }
			   }
			}
		 }
	  }
/*
	  System.out.println("");
	  for(int i=0; i< tag_type.size(); i++) {
		 System.out.print(((GTI)tag_type.elementAt(i)).str + "\t");
		 System.out.print(((GTI)tag_type.elementAt(i)).num + "\t -> ");
		 System.out.println(diff[i]);
	  }
*/

	  for(int i=0; i<tag_type.size(); i++) {
		 ((GTI)tag_type.elementAt(i)).num = Math.abs(diff[i]);
	  }

	  for(int i=0; i<tag_type.size()-1; i++) {
		 for(int j=i+1; j<tag_type.size(); j++) {
			int app1 = ((GTI)tag_type.elementAt(i)).num;
			int app2 = ((GTI)tag_type.elementAt(j)).num;
			if(app1 > app2) {
			   GTI tmpi = new GTI((GTI)tag_type.elementAt(i));
			   GTI tmpj= new GTI((GTI)tag_type.elementAt(j));
			   tag_type.removeElementAt(j);
			   tag_type.insertElementAt(tmpi, j);
			   tag_type.removeElementAt(i);
			   tag_type.insertElementAt(tmpj, i);
			}
		 }
	  }

	  candidate_list.addElement(new GTI(((GTI)tag_type.elementAt(0)).str, rank));

	  for(int i=1; i<tag_type.size(); i++) {
		 int app1 = ((GTI)tag_type.elementAt(i-1)).num;
		 int app2 = ((GTI)tag_type.elementAt(i)).num;

		 if(app1 < app2) {
			rank++;
		 }

		 candidate_list.addElement(new GTI(((GTI)tag_type.elementAt(i)).str, rank));

	  }
/*
	  System.out.println("Candidate_list");
	  for(int i=0; i<candidate_list.size(); i++) {
		 System.out.println(((GTI)candidate_list.elementAt(i)).str + "\t" +
							((GTI)candidate_list.elementAt(i)).num);
	  }
*/

	  return candidate_list;
   }

   private boolean findEmpty(int pos1, int pos2) {
	  for(int i=pos1; i<pos2; i++) {
		 String str = new String(((TTree)subtree.children.elementAt(i)).getPlainText());
		 int sz = str.length();

		 if (sz > 0) {
			for(int j=0; j<sz; j++) {
			   if(str.charAt(j) != 32  &&
				  str.charAt(j) != 10  &&
				  str.charAt(j) != 13  &&
				  str.charAt(j) != '\t') {
				  return false;
			   }
			}
		 }
	  }

	  return true;
   }

}

class TFS {
   String front = new String();
   String back = new String();
   int count = 0;

   TFS() {
	  front = new String();
	  back = new String();
	  count = 0;
   }

   TFS(String f, String b, int cnt) {
	  front = f;
	  back = b;
	  count = cnt;
   }

   TFS(TFS tfs) {
	  front = tfs.front;
	  back = tfs.back;
	  count = tfs.count;
   }


}
