package edu.byu.deg.records;

import java.util.*;

/**
 * This class take a tag-tree as input and generate
 * and generate a tag name list and an array of
 * (Tag, Appearance) pair
 *
 * @version 1.0.0
 * @author  Yuan Jiang
 */
class PreProcessTags {
   Vector tag_list = new Vector();
   Vector type_list = new Vector();

   PreProcessTags() {
	  tag_list = new Vector();
	  type_list = new Vector();
   }

   PreProcessTags(TTree tree) {
	  this();

	  Vector tag_type = new Vector();
	  Vector appear   = new Vector();
	  String str = new String();
	  if(!tree.children.isEmpty()) {
		 for(int i = 0; i < tree.children.size(); i++) {
			str = ((TTree)tree.children.elementAt(i)).current.getTag();
			if(str.charAt(1) != '!' && str.charAt(1) != '/') {
			   tag_list.addElement(new String(str));

			   int pos = tag_type.indexOf(str);

			   if(pos == -1) {
				  tag_type.addElement(str);
				  appear.addElement(new Integer(1));  //*** why 1 and not 0
			   }
			   else {
				  int cnt = ((Integer)appear.elementAt(pos)).intValue();
				  appear.removeElementAt(pos);
				  appear.insertElementAt(new Integer(cnt+1), pos);
			   }
			}
		 }
	  }

//      System.out.println("--- Type and Count ---");
	  for (int i=0; i< tag_type.size(); i++) {
		 String tg = (String)tag_type.elementAt(i);
		 int    cnt = ((Integer)appear.elementAt(i)).intValue();
		 type_list.addElement(new GTI(tg, cnt));
/*
		 System.out.println(((GTI)type_list.elementAt(i)).str + "\t"
						  + ((GTI)type_list.elementAt(i)).num);
*/
	  }


   }

   public void eliminateIrrelevantTags(int t) {
	  if(tag_list.size() != type_list.size()) {
		 for(int k=0; k<type_list.size(); k++) {
			if(((GTI)type_list.elementAt(k)).num <= t) {
			   String irrelevant_tag = ((GTI)type_list.elementAt(k)).str;
			   type_list.removeElementAt(k);
			   k--;

			   int pos = tag_list.indexOf(irrelevant_tag);
			   while(pos != -1) {
				  tag_list.removeElementAt(pos);
				  pos = tag_list.indexOf(irrelevant_tag);
			   }
			}
		 }
	  }

/*     System.out.println("\n");
	  for(int i=0; i<type_list.size(); i++) {
		 System.out.println(((GTI)type_list.elementAt(i)).str + "\t"
						  + ((GTI)type_list.elementAt(i)).num);


	  }
*/

   }

   public Vector get_list() {
	  return type_list;
   }
}








