/*
 * DOMFilter.java
 *
 * Created on August 1, 2003, 4:48 PM
 */

package edu.byu.deg.util;


import org.w3c.dom.Node;

/** Filters out tags such as script and style which contain text elements but do not
 * show that text in a browser
 * @author  troywalk
 */
public class DOMFilter {
  
  private static final String SCRIPT = "script";
  private static final String STYLE = "style";
  /** Removes tags containing code from the subtree rooted at node
   * @param node subtree to be cleaned
   */  
  static public void filter(Node node){
    Node next = node.getFirstChild();
    while(next!=null){
      String name = next.getNodeName();
      if ((name.compareToIgnoreCase(SCRIPT)==0)||
          (name.compareToIgnoreCase(STYLE)==0)){
        Node toremove = next;
        next = toremove.getNextSibling();
        node.removeChild(toremove);
      }
      else{
        filter(next);
        next = next.getNextSibling();
      }
    }
  }
}
