/*
 * DOMPrinter.java
 *
 * Created on December 19, 2003, 10:19 AM
 */

package edu.byu.deg.util;

/**
 *
 * @author  troywalk
 */
import java.io.PrintStream;
import org.w3c.dom.Node;
public class DOMPrinter {
  
  public static void print(Node n, PrintStream out, String indent, boolean printsib){
    if(n==null)
      return;
    out.print(indent);
    if(n.getNodeType()==Node.TEXT_NODE){
      out.println(n.getNodeValue());
    }
    else {
      if(n.hasChildNodes()){
        out.println("<" + n.getNodeName() + ">");
        print(n.getFirstChild(), out, indent + "  ", true);
        out.print(indent);
        out.println("</" + n.getNodeName() + ">");
      } else
        out.println("<" + n.getNodeName() + " />");
    }
    if(printsib)
      print(n.getNextSibling(), out, indent, true);
  }
  
  public static void print(Node n, PrintStream out){
    print(n, out, "", false);
  }
  public static void print(Node n){
    print(n, System.out);
  }




  /*public static void print(edu.byu.deg.framework.DSP.VSM.NodeMatchCounter c, Node n, PrintStream out, String indent, boolean printsib){
    if(n==null)
      return;
    out.print(indent);
    if(n.getNodeType()==Node.TEXT_NODE){
      try {
        out.println(n.getNodeValue() + c.getCount(n).toString());
      } catch(Exception e){}
    }
    else {
      if(n.hasChildNodes()){
        out.println("<" + n.getNodeName() + ">");
        print(c, n.getFirstChild(), out, indent + "  ", true);
        out.print(indent);
        out.print("</" + n.getNodeName() + ">");
      } else
        out.print("<" + n.getNodeName() + " />");
      out.println(c.getCount(n).toString());
      out.println("");
    }
   
    if(printsib)
      print(c, n.getNextSibling(), out, indent, true);
  }*/


}
