/*
 * TagInfo.java
 *
 * Created on November 19, 2003, 11:38 AM
 */

/**
 *
 * @author  troywalk
 */
package edu.byu.deg.util;
import org.w3c.dom.Node;
import java.util.HashMap;
public class TagInfo {
  String name;
  boolean empty, force_start, force_end;
  String start_whitespace;
  String end_whitespace;

  TagInfo(String name, boolean empty, String start_whitespace, boolean force_start, String end_whitespace, boolean force_end){
    this.name = name;
    this.empty = empty;
    this.start_whitespace = start_whitespace;
    this.end_whitespace = end_whitespace;
  }

  public String getName() {return this.name;}
  public boolean isEmpty() {return this.empty;}
  public String getStartSpace() {return this.start_whitespace;}
  public boolean getForceStart() {return this.force_start;}
  public String getEndSpace() {return this.end_whitespace;}
  public boolean getForceEnd() {return this.force_end;}

  private static HashMap tags;
  public static final String BL = "";
  public static final String NL = "\n";
  public static final String SP = " ";
  private static TagInfo dummy = new TagInfo("", false, BL, false, BL, false);
  
  public static TagInfo getTagForNode(Node node){
    TagInfo tag = (TagInfo)tags.get(node.getNodeName().toLowerCase());
    if(tag==null)
      tag = dummy;
      
    return tag;
  }
  
  static {
    tags = new HashMap();
//    tags.put("a",       new TagInfo("a",           false, BL, false, BL, false));
//    tags.put("abbr",    new TagInfo("abbr",        false, BL, false, BL, false));
//    tags.put("acronym", new TagInfo("acronym",     false, BL, false, BL, false));
//    tags.put("address", new TagInfo("address",     false, BL, false, BL, false));
    tags.put("applet",  new TagInfo("applet",      true, SP, true, BL, false));
//    tags.put("area",    new TagInfo("area",        true, BL, false, BL, false));
//    tags.put("b",       new TagInfo("b",           false, BL, false, BL, false));
//    tags.put("base",    new TagInfo("base",        true, BL, false, BL, false));
//    tags.put("basefont",new TagInfo("basefont",    true, BL, false, BL, false));
//    tags.put("bdo",     new TagInfo("bdo",         false, BL, false, BL, false));
//    tags.put("big",     new TagInfo("big",         false, BL, false, BL, false));
    tags.put("blockquote",new TagInfo("blockquote",false, NL, false, NL, false));
//    tags.put("body",    new TagInfo("body",        false, BL, false, BL, false));
    tags.put("br",      new TagInfo("br",          true, NL, true, BL, false));
    tags.put("button",  new TagInfo("button",      true, SP, true, BL, false));
//    tags.put("caption", new TagInfo("caption",     false, BL, false, BL, false));
    tags.put("center",  new TagInfo("center",      false, NL, false, NL, false));
//    tags.put("cite",    new TagInfo("cite",        false, BL, false, BL, false));
//    tags.put("code",    new TagInfo("code",        false, BL, false, BL, false));
    tags.put("col",     new TagInfo("col",         true, BL, false, SP, false));
//    tags.put("colgroup",new TagInfo("colgroup",    false, BL, false, BL, false));
//    tags.put("dd",      new TagInfo("dd",          false, BL, false, BL, false));
//    tags.put("del",     new TagInfo("del",         false, BL, false, BL, false));
//    tags.put("dfn",     new TagInfo("dfn",         false, BL, false, BL, false));
    tags.put("dir",     new TagInfo("dir",         false, NL, false, NL, false));
    tags.put("div",     new TagInfo("div",         false, NL, false, NL, false));
    tags.put("dl",      new TagInfo("dl",          false, NL, false, NL, false));
    tags.put("dt",      new TagInfo("dt",          false, BL, false, NL, false));
//    tags.put("em",      new TagInfo("em",          false, BL, false, BL, false));
    tags.put("frame",   new TagInfo("frame",       true, BL, false, SP, false));
//    tags.put("frameset",new TagInfo("frameset",    false, BL, false, BL, false));
//    tags.put("fieldset",new TagInfo("fieldset",    false, BL, false, BL, false));
//    tags.put("font",    new TagInfo("font",        false, BL, false, BL, false));
//    tags.put("form",    new TagInfo("form",        false, BL, false, BL, false));
    tags.put("h1",      new TagInfo("h1",          false, NL, false, NL, false));
    tags.put("h2",      new TagInfo("h2",          false, NL, false, NL, false));
    tags.put("h3",      new TagInfo("h3",          false, NL, false, NL, false));
    tags.put("h4",      new TagInfo("h4",          false, NL, false, NL, false));
    tags.put("h5",      new TagInfo("h5",          false, NL, false, NL, false));
    tags.put("h6",      new TagInfo("h6",          false, NL, false, NL, false));
    tags.put("hr",      new TagInfo("hr",          true, NL, true, BL, false));
    tags.put("iframe",  new TagInfo("iframe",      true, NL, true, BL, false));
    tags.put("isindex", new TagInfo("isindex",     true, BL, false, SP, false));
//    tags.put("i",       new TagInfo("i",           false, BL, false, BL, false));
    tags.put("img",     new TagInfo("img",         true, SP, true, BL, false));
    tags.put("input",   new TagInfo("input",       true, SP, true, BL, false));
//    tags.put("ins",     new TagInfo("ins",         false, BL, false, BL, false));
//    tags.put("kbd",     new TagInfo("kbd",         false, BL, false, BL, false));
    tags.put("label",   new TagInfo("label",       false, SP, false, SP, false));
    tags.put("legend",  new TagInfo("legend",      false, SP, false, SP, false));
    tags.put("li",      new TagInfo("li",          false, NL, false, NL, false));
//    tags.put("link",    new TagInfo("link",        true, BL, false, BL, false));
    tags.put("menu",    new TagInfo("menu",        false, NL, false, NL, false));
//    tags.put("map",     new TagInfo("map",         false, BL, false, BL, false));
//    tags.put("meta",    new TagInfo("meta",        true, BL, false, BL, false));
//    tags.put("noscript",new TagInfo("noscript",    false, BL, false, BL, false));
//    tags.put("noframes",new TagInfo("noframes",    false, BL, false, BL, false));
//    tags.put("object",  new TagInfo("object",      false, BL, false, BL, false));
    tags.put("ol",      new TagInfo("ol",          false, NL, false, NL, false));
    tags.put("option",  new TagInfo("option",      false, BL, false, NL, false));
    tags.put("optgroup",new TagInfo("optgroup",    false, BL, false, BL, false));
    tags.put("p",       new TagInfo("p",           false, NL, false, NL, false));
//    tags.put("param",   new TagInfo("param",       true, BL, false, BL, false));
    tags.put("pre",     new TagInfo("pre",         false, NL, false, NL, false));
    tags.put("q",       new TagInfo("q",           false, SP, false, SP, false));
//    tags.put("s",       new TagInfo("s",           false, BL, false, BL, false));
    tags.put("samp",    new TagInfo("samp",        false, SP, false, SP, false));
//    tags.put("script",  new TagInfo("script",      false, BL, false, BL, false));
    tags.put("select",  new TagInfo("select",      true, SP, true, BL, false));
//    tags.put("small",   new TagInfo("small",       false, BL, false, BL, false));
//    tags.put("span",    new TagInfo("span",        false, BL, false, BL, false));
//    tags.put("strike",  new TagInfo("strike",      false, BL, false, BL, false));
//    tags.put("style",   new TagInfo("style",       false, BL, false, BL, false));
//    tags.put("sub",     new TagInfo("sub",         false, BL, false, BL, false));
//    tags.put("sup",     new TagInfo("sup",         false, BL, false, BL, false));
//    tags.put("strong",  new TagInfo("strong",      false, BL, false, BL, false));
    tags.put("table",   new TagInfo("table",       false, NL, true, NL, true));
//    tags.put("tbody",   new TagInfo("tbody",       false, BL, false, BL, false));
    tags.put("td",      new TagInfo("td",          false, BL, false, SP, false));
    tags.put("tfoot",   new TagInfo("tfoot",       false, BL, false, NL, false));
    tags.put("th",      new TagInfo("th",          false, BL, false, SP, false));
    tags.put("thead",   new TagInfo("thead",       false, BL, false, NL, false));
    tags.put("tr",      new TagInfo("tr",          false, BL, false, NL, false));
//    tags.put("tt",      new TagInfo("tt",          false, BL, false, BL, false));
    tags.put("textarea",new TagInfo("textarea",    true, SP, true, BL, false));
    tags.put("ul",      new TagInfo("ul",          false, NL, false, NL, false));
//    tags.put("u",       new TagInfo("u",           false, BL, false, BL, false));
//    tags.put("var",     new TagInfo("var",         false, BL, false, BL, false));  
  }    



}
